/*   assat.cpp 
	
	  assat V 1.0 :  April 2002


*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>


#define DEFAULT_ITERATION 300
#define DEFAULT_RATE 10000



#define C_ONESTEP 1024					// One increasing step for rulelist, cnflist  
#define C_LEN_COMMAND 100				// Length of command
#define C_LEN_RULE 100					// Length of a single rule
#define C_LEN_ATOM 100					// Length of a single atom(string)
#define C_LEN_FILENAME 50				// Length of file name
#define C_RUELLENGTH 50					// Max length of a rule in 00lparse
#define C_MAXATOM  100000				// Max number of atoms  
#define C_LEN_COMBINATION_POINTER 20	//Length of the combination pointer, used in CNF building
#define LEN_temp_cnflist 100       



struct LISTNODE                    // node of the rule list
{
	int data;                           // number of rules with this same head       
	struct CROSSNODE *p_cross;          // pointer to cross node
};

struct CROSSNODE                   // node of cross
{
	int data;
	struct BODYNODE *p_body;            // right pointer, point to the body link
	struct CROSSNODE *p_cross;          // next pointer, point to next cross node
	struct CROSSNODE *p_cross2;			// point to the same rule in rulelink2[i]

};

struct BODYNODE                    // node of body link 
{
	int data;                           // value of body element
	struct BODYNODE *p_body;            // pointer to body node, point to the element on right
};






struct LOOPLIST 					// _loop_list[i].data = 0; _loop_list[i].p_rule = _cp1
{
	int data;
	struct CROSSNODE *p_rule;
};


struct LOOPCHAINNODE					//
{
	int data;
	struct CROSSNODE *p_rule;
	struct LOOPCHAINNODE *p_chain;
};


struct LOOPTREENODE
{
	int data;                           // value of body element
	struct LOOPCHAINNODE *p_chain;      // point right, the emelents in the same loop 
	struct LOOPTREENODE *p_next;			// for any loop node, point to the rules (arc) to connect next node
};






	struct LISTNODE *rulelink, *rulelink2;
	struct CROSSNODE *c_pointer1, *c_pointer2, *newline;
	struct BODYNODE *b_pointer1, *b_pointer2, *newnode;

	int PARA_Reduce = 1;                 // Parameters, do the reduction
	int PARA_Station = 1;                // Parameters, on PC machine
	int PARA_Order = 0;                  // order the atom-list and encoding CNF again 

	int PARA_DebugMode = 0;              // Parameters, display debug mode
	int PARA_CompletionMode = 1;         // clark's completion or literal completion
	int PARA_LoopToSearch = DEFAULT_ITERATION;             // how many times of loop_detect - search_model
	int PARA_CheckConclusion = 0;       //

	int PARA_RateOfSubstitute = DEFAULT_RATE;      
	// In the procedure to transfer a Clark's Completion to clauses, when the number of clauses 
	// given by the naive way larger than 10 times of that given by substitution and introduce
	// temporary variables, we use the substitution approach.

	int PARA_ExecuteGrounding =1;
	// 1 means this program will load the executing of the grounding procedure (lparse).
	// 0 means this program will use a grounded program generated previously.			(00lparse)

	int PARA_MakeCompletion =1;
	// 0 Only if PARA_ExecuteGround == 0, the program will use the previous CNF file,	(00cnf)
	// 1 Normal case

	int PARA_ExecuteSAT =1;
	// 1 means this program will load the SAT slover.
	// 0 means this program will use a previous result of SAT solver,					(00satout)
	//   but the type of SAT solver should be illuminated in the PARA file.

	int PARA_ConstraintFactReduction =1;	// reduce rulelink[] by Constarint Facts

	int PARA_OutputModel =0;				// Output the model in real name, (decoding model)

	int PARA_WalkChaff =1;					// Walk-Chaff mode, Only when walksat failed, by checking this PARA,
											//            ASSAT decide if to load chaff to check again
	int PARA_SatzChaff =1;					// Satz-Chaff


	//March 30, 2002
	int PARA_CompletionOnly=0;				// only output the result of completion, no SATs.
	int PARA_ResultFile=0;					// output inner result to files
	int PARA_TextOutput=0;					// only when PARA_ResultFile=1, output in text format
    int PARA_ParameterFile=0;				// to specify another parameter file

	char str_ResultFileName[C_LEN_FILENAME];						// result file

		char str_cn0[C_LEN_FILENAME]="EMPTY";									// cnf0
		char str_cni[C_LEN_FILENAME]="EMPTY";									// cnf (i), loop formula of loop(i)
		char str_txt[C_LEN_FILENAME]="EMPTY";									// cnf (i) in TEXT 
		char str_lpi[C_LEN_FILENAME]="EMPTY";									// loop (i)
		char str_md0[C_LEN_FILENAME]="EMPTY";									// model of cnf0
		char str_mdi[C_LEN_FILENAME]="EMPTY";									// model of cnf(i)


	char str_InputFile1[C_LEN_FILENAME]="EMPTY";							// input files
	char str_InputFile2[C_LEN_FILENAME]="EMPTY";

	char str_ParameterFileName[C_LEN_FILENAME]="assat-config";		// config file

		char groundlpfile[C_LEN_FILENAME]="groundlp.temp";			// ground LP, output of lparse
		char satoutputfile[C_LEN_FILENAME]="satoutput.temp";		// standard output of SAT solvers
		char satmodelfile[C_LEN_FILENAME]="satmodel.temp";          // if necessary, the file contains model  

		char runlparse[C_LEN_COMMAND]="EMPTY";		// the Command to execute lparse
		char runcopycn0[C_LEN_COMMAND];				// "cp .cnf *.cn0" 
		char runsat[C_LEN_COMMAND]="Chaff2 ";		// the Command to execute SAT, defaultly Chaff2
		char runsat_prefix[C_LEN_COMMAND];			// the Command to get a formal model from output of SAT
		char runsat_suffix[C_LEN_COMMAND];			// suffix
		char sat_name[10]="         ";				// name of current SAT solver




	FILE *fp_cnf, *fp_lpi, *fp_cni, *fp_txt, *fp_mdi;

	char str_cnf[C_LEN_FILENAME]="00.cnf";						// SAT solver output to file   




  char item[C_LEN_RULE];           // Used in reading rules 
  char command[C_LEN_COMMAND];     // Used in reading commands

  char runsat_chaff[C_LEN_COMMAND]="Chaff2 <ResultFileName.cni> > <ResultFileName.mdi>";





  int *rule;

  // Used to translate a code (of atom) into a name
  char *atomlist;				// array of atoms, seperated by a blank
  int length_atomlist=0;		// current length of the whole array
  int position_atomlist=0;		// current position of the empty

  long atommap[C_MAXATOM];		// atommap[i] is the position of the name in atomlist


  int main_atom;           // Number of atoms       
  int code_of_fail = 0;
  int no_atom;

  int main_rule;           // Number of rules
  int len_rule;           // Max length of rules   

  int *TS_atom;                  // TS set of atoms.            (1): Facts   (2): False 
  int *TS_rule;                  // TS rules, reduced by TS set (3): Normal Rules
  int *C_rule;                   // Constraint rules.           (4): Fail rules
                                 // Only (3) and (4) be changed to CNF and input to SAT

  int *CT_atom;			// T set from the spreading of Constraints, positive literal, facT
  int *CS_atom;			// S set from the spreading of constraints, negative literal, falSe


  int *N_iff_eachatom;           // The number of iff_class for each atoms 

  int *iff;                      // iff class
  
  int *cnflist;                  // list of CNF
  int Max_cnflist, no_cnflist;   // The current length of cnflist, next position to INSERT in cnflist
  int cnf_clause;                // The number of CNF in cnflist currently 


  int n_TSrule;                  // Number of TS rules
  int n_Crule;                   // Number of constraint rules

  int n_TS_p=0;                  // Number of positive atoms in TS set   
  int n_TS_u=0;                  // Number of unknown atoms in TS set
  int n_TS_n=0;                  // Number of negative atoms in TS set


  int *model_from_sat;			// just the model(s) read from SAT
  int *model;					// current model
  int *conclusion;				// current conclusion
  int *difference;				// current difference
//  int no_model;



  // Pointers used in combination CNF
  struct BODYNODE  **combination_pointers1, **combination_pointers2;  
  int len_combination_pointer = C_LEN_COMBINATION_POINTER;  


  // arrays and varibles used in checking
	int *checking_model;            // one model, the current one on checking
	int checking_current_model;

	int *checking_glrule;
	int checking_n_glrule;

	int *checking_conclusion;




  int n_removed=0;                 // number of rules removed in TS reduce. ( marked -10 )







  // for detecting loops, but I think it is useless now
  struct LOOPLIST	 *loop_list;  
  struct LOOPCHAINNODE	 *loop_chain_head;
  struct LOOPTREENODE    *loop_tree_head;  
  struct CROSSNODE *loop_element_ordered;


  // something used to computer SCCs
  int	i_number = 0;
  int	i_component = 0;
  int * number; 
  int * lowlink; 
  int * stack; 
  int * component; 	  


  char time_of_sat[20];  // the time for running SAT
  float totaltime_sat=0.0;
  int totalnumber_sat=0;
  int totalnumber_model=0;

  
//  FILE *fp_everything;   // used to save some internal result

  int n_model_to_check=0;	// number of model given by SAT, and check if it is
		  
  int N_loopformula=0;      // Number of loop formulas added


  int error = 0;


void usage()
{
	printf("\n								ASSAT 1.0 \n");

	printf("\n	$ assat <option> <input-file1> [<input-file2>] ");
	printf("\n\nWithout any <option>, assat will call lparse to ground <input-file1>; ( or <input-file1> + <input-file2>), and use Chaff2 to compute its answet set. assat will write to standard output the answet set it found, if any, along with some statistics such as run time and number of loop formulas added. ");
	printf("\n\nassat accepts the following options: ");
	printf("\n\n-c ");
	printf("\nThis will cause assat to compute the completion of the input program, and write the result to the standard output. When this option is used, assat will not attempt to call a SAT solver. ");
	printf("\n\n-f <file> ");
	printf("\nThis option will cause assat to write some detail information to 5 files with <file> as the base: ");
	printf("\n      <file>.cn0 : the clausal set of the program completion ");
	printf("\n      <file>.md0 : the model of <file>.cn0 found by the SAT solver ");
	printf("\n      <file>.lpi : the loops found in each iteration ");
	printf("\n      <file>.cni : the loop formulas of the loops found in each iteration. ");
	printf("\n      <file>.mdi : the model of <file>.cn0 + <file>.cn(i) found by the SAT solver in each iteration ");
	printf("\n\n-t ");
	printf("\nASSAT output data in text format.");
	printf("\n\n-g <file>");
	printf("\nThis option will specify a config file for ASSAT. (The default one is assat-config . ) In addition to specifying the SAT solver, the configuration file can also include options like whether to do any simplification before computing the completion, and under what conditions the program should introduce temporary variables in converting the completion and loop formulas to clauses. ");
	printf("\n\n");

}



void output_completion()             // Read the file: 00lparse
{  

	int i, k;
	char _str[C_LEN_ATOM];



	for ( i=1; i< main_atom+1; i++ ) {
		

		printf("\n %d <=> ", i );

		c_pointer1 = rulelink[i].p_cross;
		while ( c_pointer1 != NULL ) {

			if ( c_pointer1 != rulelink[i].p_cross ) printf("V ");

			if ( c_pointer1->data > 1 ) printf("( ");

			b_pointer1 = c_pointer1->p_body;
			while (b_pointer1 != NULL ) {

				if ( b_pointer1 != c_pointer1->p_body ) printf("^ ");

				printf("%d ", b_pointer1->data);
				b_pointer1 = b_pointer1->p_body;
			}

			if ( c_pointer1->data > 1 ) printf(") ");

			c_pointer1 = c_pointer1->p_cross;
		}
	}

	printf("\n\n");



	// txt format

if ( PARA_TextOutput == 1 ) {

	for ( i=1; i< main_atom+1; i++ ) {
		




		
		//printf("\n %d <=> ", i );
		k=-1;
		do {
			k++;
			_str[k] = atomlist[ atommap[i] +k ];
		} while (_str[k] != 0 );
		printf("\n %s <=> ", _str);


		c_pointer1 = rulelink[i].p_cross;
		while ( c_pointer1 != NULL ) {

			if ( c_pointer1 != rulelink[i].p_cross ) printf("V ");

			if ( c_pointer1->data > 1 ) printf("( ");

			b_pointer1 = c_pointer1->p_body;
			while (b_pointer1 != NULL ) {

				if ( b_pointer1 != c_pointer1->p_body ) printf("^ ");

				//printf("%d ", b_pointer1->data);
				k=-1;
				do {
					k++;
					_str[k] = atomlist[ atommap[abs(b_pointer1->data)] +k ];
				} while (_str[k] != 0 );
				if (b_pointer1->data >0 ) printf("%s ", _str);
				else printf("not %s ", _str);




				b_pointer1 = b_pointer1->p_body;
			}

			if ( c_pointer1->data > 1 ) printf(") ");

			c_pointer1 = c_pointer1->p_cross;
		}
	}

	printf("\n\n");

} // text output


}	// output_completion






void savefile_TSatom(char _filename[50])
{

	FILE *fp_TSatom;

	int i;


	if (!(fp_TSatom=fopen(_filename,"w"))) {     // Open rule file with "W" mode. 
		printf("Can not open %s\n", _filename);
		error =1;
	}
	

  fprintf(fp_TSatom, "\n TS set \n");
/*
  for(i=1;i<=main_atom;i++) {
	  
	  if (TS_atom[i] > 0 ) { 
		  fprintf(fp_TSatom, "%d= %d\n", i, TS_atom[i]); 

		  n_TS_p++;            // number of positive atom in TSatom[]
	  }  
	  else if (TS_atom[i] == 0 ) { 
		  fprintf(fp_TSatom, "%d=           %d\n", i, TS_atom[i]); 

		  n_TS_u++;            // number of unknown atom in TSatom[]
	  }  
	  else {
		  fprintf(fp_TSatom, "%d=                     %d\n", i, TS_atom[i]); 

		  n_TS_n++;            // number of negative atom in TSatom[]
	  }

  }
*/

  for ( i=1; i<=main_atom; i++) {


	  if (TS_atom[i] == 1) {
		  fprintf(fp_TSatom, "%d 0\n", i );
	  }

	  if (TS_atom[i] == -1) {
		  fprintf(fp_TSatom, "%d 0\n", (-1)*i );
	  }
  }


  fclose(fp_TSatom);


} // savefile_TSatom()




void display_rulelink()
{

	int i;

 
  	// DISPLAY rulelink

	for ( i=0; i< main_atom+1; i++ ) {
		
		if ( rulelink[i].data != 0 ){
			
			printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				printf("    %d: ", c_pointer1->data);

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					printf("%d ", b_pointer1->data);
					b_pointer1 = b_pointer1->p_body;
				}
				printf("\n");

				c_pointer1 = c_pointer1->p_cross;
			}
		}

	}

} // END of display_rulelink()





/*
void print_menu()
{
  printf("\nUsage: a.out [<Options>] <Input_file>\n\n");
  printf("Options are:\n");
  printf("   -r       : Reduce operation on \n\n");
  printf("   -d       : Debuge mode\n");
  printf("   -s       : Execute on work station\n");
  printf("   -c<n>    : Set on completion mode\n");
  printf("					n=0, literal completion\n"); 
  printf("					n=1, Clark's completion\n"); 
  printf("					n=2, Clark's completion with sorting\n"); 
  printf("   -m<n>    : set the number of expected models (default: 1)\n");
  printf("\n");
}
*/






//INPUT: str_ParameterFileName                             //OUTPUT: PARAMETERS; type of SAT
void read_PARA_file(char _PARAfile[C_LEN_FILENAME] )
{
	FILE *fp_PARA;

	char _item[C_LEN_COMMAND];     
	int _temp;
	int i;



	if (!(fp_PARA=fopen(_PARAfile,"r"))) {  
		//printf("\nCan not open the file: %s\n", _PARAfile);
		//error =1;
		return;		// not specify a config file
	}


	while ( fscanf(fp_PARA,"%s\n",&_item)!=EOF ) {
		if (strcmp(_item, "-Reduce")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_Reduce = _temp;
		}
		if (strcmp(_item, "-ConstraintFactReduction")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_ConstraintFactReduction = _temp;
		}
		else if (strcmp(_item, "-DebugMode")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_DebugMode = _temp;
		}
		else if (strcmp(_item, "-Station")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_Station = _temp;
		}
		else if (strcmp(_item, "-CompletionMode")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_CompletionMode = _temp;
		}
		else if (strcmp(_item, "-Order")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_Order = _temp;
		}
		else if (strcmp(_item, "-LoopToSearch")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_LoopToSearch = _temp;
		}
		else if (strcmp(_item, "-CheckConclusion")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_CheckConclusion = _temp;
		}
		else if (strcmp(_item, "-RateOfSubstitute")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_RateOfSubstitute = _temp;
		}
		else if (strcmp(_item, "-ExecuteGrounding")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_ExecuteGrounding = _temp;
		}
		else if (strcmp(_item, "-ExecuteSAT")==0) {   //
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_ExecuteSAT = _temp;
		}
		else if (strcmp(_item, "-MakeCompletion")==0) {   
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_MakeCompletion = _temp;
		}
		else if (strcmp(_item, "-OutputModel")==0) {   
			fscanf(fp_PARA,"%d\n",&_temp);
			PARA_OutputModel = _temp;
		}

		else if (strcmp(_item, "-SAT:")==0) {					// Type of SAT solver and the command

			for (i=0; i<C_LEN_COMMAND; i++) {	  _item[i]=0;  }

			i=-1;
			do {
				i++;
				fscanf(fp_PARA,"%c",&_item[i]);
			}
			while ( _item[i] != 10 );	// 10 = End Of Line 
			
			_item[i]=' ';
			strcpy(runsat,_item);

		}
		else if (strcmp(_item, "-grounding:")==0) {				// command of grounding

			for (i=0; i<C_LEN_COMMAND; i++) {	  _item[i]=0;  }

			i=-1;
			do {
				i++;
				fscanf(fp_PARA,"%c",&_item[i]);	// 10 = End Of Line 
			}
			while ( _item[i] != 10 );

			_item[i]=0;
			strcpy(runlparse,_item);
			
		}


	} // while



	fclose(fp_PARA);
	
}  // read_PARA_file()














//OUTPUT: rule[], FILE:atomfile, main_rule, len_rule
void read_grounded_program_rulelink_reordering()
{

struct mapping                   // number - atom mapping
{
	int number;
	char str[50];
	struct mapping *p_mapping;
};


	FILE *fp_lparse, *fp_atom;
		

	char atomfile[C_LEN_FILENAME]="00atom";

	char item[C_LEN_ATOM];						// be used to read an atom name

 

	int i_head, n_body, n_not;
	int i_temp, _l;
	int i,k;


	struct mapping *_mp1, *_mp2, *_front;
	struct LISTNODE *rulelink2;

//	char _item;
//	char _str[50];
	int _neworder[C_MAXATOM];
//	int _add;





	rulelink = ( struct LISTNODE * ) malloc ( (C_MAXATOM+1) * sizeof (struct LISTNODE ) );
	rulelink2 = ( struct LISTNODE * ) malloc ( (C_MAXATOM+1) * sizeof (struct LISTNODE ) );

	for(i=0; i<C_MAXATOM+1; i++) {
		rulelink[i].data = 0;
		rulelink[i].p_cross = NULL;      
		rulelink2[i].data = 0;
		rulelink2[i].p_cross = NULL;      
	}



	if (!(fp_lparse=fopen(groundlpfile,"r"))) {  
        printf("Can not open the file: %s\n", groundlpfile);
        error =1;
	}


	

	main_rule= 0;   // number of rule in 00lparse: facts, constraints and normal rules
	               // also number of rule in rulelist[]

	//no_rule = 0;   // number of normal rule 
	len_rule = 3;  /* At least 3, the length of fact rule */



	while ((fscanf(fp_lparse,"%d ",&i_temp)!=EOF)&&(i_temp != 0 ))  { 
		
		if (i_temp != 1 ) {  /* Non-normal Logic Program with abnormal rules. */
			printf("\nNon-normal Logic Program with abnormal rules.\n");
			error =1;
		}

		main_rule++;                            // number of rule in 00lparse

		fscanf(fp_lparse,"%d %d %d ",&i_head,&n_body,&n_not);    
															/* Head */
															/* Number of body */
															/* Number of negative atoms in body */
	  



		if ( n_body == 0 ) {                            /* 1. Fact case */

			rulelink2[ i_head ].data = -1;

			if ( rulelink2[ i_head ].p_cross != NULL) {
				// empty it!
				rulelink2[ i_head ].p_cross = NULL;
			}


		  
			
		} /* end of if,  FACT case */

		else {                 /* 2. Other case: fail and normal case */		  	  
			
			// 2.1 normal case, including them with the head of code_of_fail 
		    //                  But I donot know what is the code_of_fail now 

		  	c_pointer1 = new CROSSNODE;
			c_pointer1->data = n_body;
			c_pointer1->p_body = NULL;
			c_pointer1->p_cross = NULL;		c_pointer1->p_cross2 = NULL;
		  
			c_pointer2 = rulelink2[ i_head ].p_cross;	

			if( rulelink2[ i_head ].p_cross == NULL ) {

				rulelink2[ i_head ].p_cross = c_pointer1;
			}
			else {
				
				c_pointer2 = rulelink2[ i_head ].p_cross;

				c_pointer1->p_cross = c_pointer2;

				rulelink2[ i_head ].p_cross = c_pointer1;


			}




			

			for (i=0; i<n_not; i++) {                           // (3) Negative part 

				fscanf(fp_lparse,"%d ",&i_temp);       

				b_pointer1 = new BODYNODE;

				b_pointer1->data =  (-1) * i_temp;
				b_pointer1->p_body = c_pointer1->p_body;

				c_pointer1->p_body = b_pointer1;

			}



			for (i=n_not; i<n_body; i++) {                      // (4) Positive part
				
				fscanf(fp_lparse,"%d ",&i_temp);       

				b_pointer1 = new BODYNODE;

				b_pointer1->data =  i_temp;
				b_pointer1->p_body = c_pointer1->p_body;

				c_pointer1->p_body = b_pointer1;
				
			}


		  
			if(rulelink2[ i_head ].data != -1) {
				rulelink2[ i_head ].data ++;
			}


			_l = n_body + 3;             // including 3 elements: marker, head, 0
			if ( _l > len_rule ) { len_rule = _l; }


		}  /* End of else, the FAIL and NORMAL case */

	} /* while */


	printf(" rules: %d ", main_rule);



	// DISPLAY rulelink2
	/*

	for ( i=0; i< C_MAXATOM+1; i++ ) {
		
		if ( rulelink2[i].data != 0 ){
			
			printf("\n head= %d n_iff= %d\n", i, rulelink2[i].data );

			c_pointer1 = rulelink2[i].p_cross;
			while ( c_pointer1 != NULL ) {

				printf("    %d: ", c_pointer1->data);

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					printf("%d ", b_pointer1->data);
					b_pointer1 = b_pointer1->p_body;
				}
				printf("\n");

				c_pointer1 = c_pointer1->p_cross;
			}
		}

	}
*/






  /*** 1.2 Save atoms and Decide the code_of_fail .  */

	fscanf(fp_lparse, "%d %s\n",&i_temp, &item );              // read : code atom

	no_atom = i_temp;

	//fprintf(fp_atom, "%d %s\n", no_atom, item );               // Write : code atom 



	if(no_atom != 1) {  code_of_fail = 1; }      /* Atoms are not start from 1, so 1 is reserved for FAIL */
	
	if ( ( strcmp(item,"fail")==0 ) || ( strcmp(item,"Fail")==0 ) || ( strcmp(item,"FAIL")==0 ) 
		|| ( strcmp(item,"false")==0 ) || ( strcmp(item,"False")==0 ) 
		|| ( strcmp(item,"FALSE")==0 ) || ( strcmp(item,"_False")==0 ) ) {

		code_of_fail = no_atom;

	}




	// BUILD atom link

	// _front
	_front = new	mapping;
	_front->number = 0;
	_front->p_mapping = NULL;
	strcpy( _front->str , " ");

	// first node
	_mp1 = new	mapping;
	_mp1->number = i_temp;
	_mp1->p_mapping = NULL;
	strcpy( _mp1->str , item);

	_front->p_mapping = _mp1;


	printf("\n Ordering.. ");

//	_add=0;

	
	while ( (fscanf(fp_lparse,"%d %s\n",&i_temp, &item)!= EOF)&&(i_temp!=0)) {


		// ORIGINAL PART
		no_atom = i_temp;

		if( no_atom== 10000) {
			i=i;
		}

		//fprintf(fp_atom, "%d %s\n", no_atom, item);                    /* Write atom */

		if ( ( strcmp(item,"fail")==0 ) || ( strcmp(item,"Fail")==0 ) || ( strcmp(item,"FAIL")==0 ) ) {
			code_of_fail = no_atom;

			/*
			// build node
			_mp2 = new	mapping;
			_mp2->p_mapping = NULL;
			_mp2->number = i_temp;
			strcpy( _mp2->str , item );


			// insert
			_mp2->p_mapping = _mp1->p_mapping;
			_mp1->p_mapping = _mp2;
			*/

		}

		else {
			// REORDER PART
			// locate
			_mp1 = _front;
			_mp2 = _mp1->p_mapping;
			k=1;
			while ( ( _mp2 != NULL ) && (strcmp( item, _mp2->str) > 0) ) {
				_mp1 = _mp2;
				_mp2 = _mp2->p_mapping;
				k++;
			}

			// build node
			_mp2 = new	mapping;
			_mp2->p_mapping = NULL;
			_mp2->number = i_temp;
			strcpy( _mp2->str , item );


			// insert
			_mp2->p_mapping = _mp1->p_mapping;
			_mp1->p_mapping = _mp2;
			
			//printf(".");

		}// else
		
	} /* While. when it finished, we save all atoms in file. the number of atoms is in number_atom */
	// got: code_of_fail

	fclose(fp_lparse);



	// fail, build node
	_mp2 = new	mapping;
	_mp2->p_mapping = NULL;
	_mp2->number = code_of_fail;
	strcpy( _mp2->str , "fail" );
	// insert
	_mp2->p_mapping = _front->p_mapping;
	_front->p_mapping = _mp2;


	main_atom = no_atom;   // the code of the last atom


	

	// save 00atom & register
 	if (!(fp_atom=fopen(atomfile,"w"))) {
		printf("Can not open %s\n", atomfile);
		error =1;
	}

	for ( i=0; i<C_MAXATOM; i++) {		_neworder[i] = -1;	}

	printf("\n save atom..");
	_mp1 = _front->p_mapping;

	i=1;
	while ( _mp1 != NULL ) {
		fprintf(fp_atom, "%d %s     %d\n", i, _mp1->str, _mp1->number);
		_neworder[ _mp1->number ] = i;
		_mp1 = _mp1->p_mapping;
		i++;
	}

	fclose(fp_atom);

	/*
	for (j=i; j< C_MAXATOM; j++) {
		_neworder[j] = j;
	}
	*/


	// delete mapping list
	_mp1 = _front;
	while ( _mp1 != NULL ) {
		_mp2 = _mp1;
		_mp1 = _mp1->p_mapping;
		delete _mp2;
	}




	// save new order
	FILE *fp_neworder;

	if (!(fp_neworder = fopen("00neworder","w"))) {  
		printf("Can not open the file: %s\n", "00neworder");
		error =1;
	}

	/*
	for( i=1; i<= C_MAXATOM; i++) {
		
		if ( _neworder[i] != -1 ) {
			fprintf(fp_neworder, "%d --- %d    \n", i, _neworder[i]);
		}
	}*/


	for( i=1; i<= no_atom; i++) {
		
		if ( _neworder[i] != -1 ) {
			fprintf(fp_neworder, "%d ---> %d    \n", i, _neworder[i]);
		}
	}

	fclose( fp_neworder);




	// translate 

	printf("C_MAXATOM= %d \n",C_MAXATOM);

	/*
	for ( i=0; i<= C_MAXATOM+1; i++ ) {
	
		printf("%d:%d ",i,rulelink2[i].data);

	}*/

	for ( i=0; i< C_MAXATOM+1; i++ ) {
	
		//printf("%d ",i);
		// fact
		if ( rulelink2[i].data == -1 ) {
			rulelink[ _neworder[i] ].data = -1;
			rulelink[ _neworder[i] ].p_cross = NULL;
		}

		// normal rule
		else if ( rulelink2[i].data > 0 ) {

			// BODY part
			c_pointer1 = rulelink2[i].p_cross;
			while ( c_pointer1 != NULL ) {

				//printf("    %d: ", c_pointer1->data);

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					//printf("%d ", b_pointer1->data);
					if ( b_pointer1->data >0 ) {
						b_pointer1->data = _neworder[ b_pointer1->data ];
					}
					else {
						b_pointer1->data = _neworder[ abs(b_pointer1->data) ] * (-1) ;
					}
					
					b_pointer1 = b_pointer1->p_body;
				}
				//printf("\n");

				c_pointer1 = c_pointer1->p_cross;
			}

			// HEAD part
			rulelink[ _neworder[i] ].data = rulelink2[ i ].data;
			rulelink[ _neworder[i] ].p_cross = rulelink2[ i ].p_cross;

		} // else if, for normal rules

	} // for, translation


	delete []rulelink2;











	
	
	//fclose(fp_atom); 
	//fclose(fp_lparse);

	printf("\n atoms: %d ", main_atom);
	


} // END of read_grounded_program_reordering()








//OUTPUT: rule[], FILE:atomfile, main_rule, len_rule
void read_grounded_program_rulelink()
{



	FILE *fp_lparse, *fp_atom;
	


	char atomfile[C_LEN_FILENAME]="00atom";

	char item[C_LEN_ATOM];						// be used to read an atom name

 

	int i_head, n_body, n_not;
	int i_temp, _l;
	int i, k;






	rulelink = ( struct LISTNODE * ) malloc ( (C_MAXATOM+1) * sizeof (struct LISTNODE ) );

	for(i=0; i<C_MAXATOM+1; i++) {
		rulelink[i].data = 0;
		rulelink[i].p_cross = NULL;     	
		
	}



	if (!(fp_lparse=fopen(groundlpfile,"r"))) {  
        printf("Can not open the file: %s\n", groundlpfile);
        error =1;
	}


	

	main_rule= 0;   // number of rule in 00lparse: facts, constraints and normal rules
	               // also number of rule in rulelist[]

	//no_rule = 0;   // number of normal rule 
	len_rule = 3;  /* At least 3, the length of fact rule */



	while ((fscanf(fp_lparse,"%d ",&i_temp)!=EOF)&&(i_temp != 0 ))  { 
		
		if (i_temp != 1 ) {  /* Non-normal Logic Program with abnormal rules. */
			printf("\nNon-normal Logic Program with abnormal rules.\n");
			error =1;
		}

		main_rule++;                            // number of rule in 00lparse

		fscanf(fp_lparse,"%d %d %d ",&i_head,&n_body,&n_not);    
															/* Head */
															/* Number of body */
															/* Number of negative atoms in body */
	  



		if ( n_body == 0 ) {                            /* 1. Fact case */

			rulelink[ i_head ].data = -1;

			if ( rulelink[ i_head ].p_cross != NULL) {
				// empty it!
				rulelink[ i_head ].p_cross = NULL;
			}


		  
			
		} /* end of if,  FACT case */

		else {                 /* 2. Other case: fail and normal case */		  	  
			
			// 2.1 normal case, including them with the head of code_of_fail 
		    //                  But I donot know what is the code_of_fail now 

		  	c_pointer1 = new CROSSNODE;
			c_pointer1->data = n_body;
			c_pointer1->p_body = NULL;
			c_pointer1->p_cross = NULL;		c_pointer1->p_cross2 = NULL;
		  
			c_pointer2 = rulelink[ i_head ].p_cross;	

			if( rulelink[ i_head ].p_cross == NULL ) {

				rulelink[ i_head ].p_cross = c_pointer1;
			}
			else {
				
				c_pointer2 = rulelink[ i_head ].p_cross;

				c_pointer1->p_cross = c_pointer2;

				rulelink[ i_head ].p_cross = c_pointer1;


			}




			

			for (i=0; i<n_not; i++) {                           // (3) Negative part 

				fscanf(fp_lparse,"%d ",&i_temp);       

				b_pointer1 = new BODYNODE;

				b_pointer1->data =  (-1) * i_temp;
				b_pointer1->p_body = c_pointer1->p_body;

				c_pointer1->p_body = b_pointer1;

			}



			for (i=n_not; i<n_body; i++) {                      // (4) Positive part
				
				fscanf(fp_lparse,"%d ",&i_temp);       

				b_pointer1 = new BODYNODE;

				b_pointer1->data =  i_temp;
				b_pointer1->p_body = c_pointer1->p_body;

				c_pointer1->p_body = b_pointer1;
				
			}


		  
			if(rulelink[ i_head ].data != -1) {
				rulelink[ i_head ].data ++;
			}


			_l = n_body + 3;             // including 3 elements: marker, head, 0
			if ( _l > len_rule ) { len_rule = _l; }


		}  /* End of else, the FAIL and NORMAL case */

	} /* while */


	printf(" rules: %d ", main_rule);



	// DISPLAY rulelink
	/*

	for ( i=0; i< C_MAXATOM+1; i++ ) {
		
		if ( rulelink[i].data != 0 ){
			
			printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				printf("    %d: ", c_pointer1->data);

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					printf("%d ", b_pointer1->data);
					b_pointer1 = b_pointer1->p_body;
				}
				printf("\n");

				c_pointer1 = c_pointer1->p_cross;
			}
		}

	}
*/






  /*** 1.2 Save atoms and Decide the code_of_fail .  */


	if ( PARA_TextOutput==1 ) {
		length_atomlist = 20 * C_ONESTEP;		// a buffer of 20K
		position_atomlist=0;
		atomlist = ( char * ) malloc ( length_atomlist * sizeof (char) ) ;
	}
    




 	if (!(fp_atom=fopen(atomfile,"w"))) {
		printf("Can not open %s\n", atomfile);
		error =1;
	}


	fscanf(fp_lparse, "%d %s\n",&i_temp, &item );              // read : code atom


	// atomlist
	if ( PARA_TextOutput==1 ) {

		if ( length_atomlist < position_atomlist + 100 ) {

			length_atomlist = length_atomlist + C_ONESTEP;

			if( (atomlist = ( char * ) realloc ( atomlist, length_atomlist * sizeof (char) ) ) ==  NULL ) 
				error=1;
		}

		k=-1;
		do {
			k++;
			atomlist[ position_atomlist + k ] = item[k];
		} while( item[k] != 0 );

		atommap[i_temp] = position_atomlist;
		position_atomlist = position_atomlist +k+1;
	}


	no_atom = i_temp;

	fprintf(fp_atom, "%d %s\n", no_atom, item );               // Write : code atom 



	if(no_atom != 1) {  code_of_fail = 1; }      /* Atoms are not start from 1, so 1 is reserved for FAIL */
	
	if ( ( strcmp(item,"fail")==0 ) || ( strcmp(item,"Fail")==0 ) || ( strcmp(item,"FAIL")==0 ) 
		|| ( strcmp(item,"false")==0 ) || ( strcmp(item,"False")==0 ) 
		|| ( strcmp(item,"FALSE")==0 ) || ( strcmp(item,"_False")==0 ) ) {

		code_of_fail = no_atom;

	}


	while ( (fscanf(fp_lparse,"%d %s\n",&i_temp, &item)!= EOF)&&(i_temp!=0)) {

		// atomlist
		if ( PARA_TextOutput==1 ) {

			if ( length_atomlist < position_atomlist + 100 ) {

				length_atomlist = length_atomlist + C_ONESTEP;

				if( (atomlist = ( char * ) realloc( atomlist, length_atomlist * sizeof( char )) ) ==  NULL ) 
					error =1;
			}

			k=-1;
			do {
				k++;
				atomlist[ position_atomlist + k ] = item[k];
			} while( item[k] != 0 );

			atommap[i_temp] = position_atomlist;
			position_atomlist = position_atomlist +k+1;
		}



		no_atom = i_temp;

		fprintf(fp_atom, "%d %s\n", no_atom, item);                    /* Write atom */

		if ( ( strcmp(item,"fail")==0 ) || ( strcmp(item,"Fail")==0 ) || ( strcmp(item,"FAIL")==0 ) ) {
			code_of_fail = no_atom;
		}

		
	} /* While. when it finished, we save all atoms in file. the number of atoms is in number_atom */
	// got: code_of_fail


	main_atom = no_atom;   // the code of the last atom

	
	
	
	fclose(fp_atom); 
	fclose(fp_lparse);

	printf(" atoms: %d", main_atom);





} // END of read_grounded_program()







// Publice: rulelink[], TS_atom[], main_atom, main_rule, len_rule, n_Crule, n_TSrule,
// 
int Reduce_ConstraintFact_Collection() 
{
// return value:	-1, inconsistent! (a) get 'fail' as a fact! The program is inconsistent and has no stable model
//					 1 , if the NEW TS_set = the old one; otherwise 0
	
  int i;
  int i_temp;
  int _stable;




  _stable = 1;

  // (2) build CS-CT set
  i=0;
  while((i < main_atom+1) && (_stable != -1)){	// check rules, collect CT and CS from constraints


	  if ( CS_atom[i] == 1)   {					// Approach 1, collect from S set, constraint false

		  // Constraint facts
		  c_pointer1 = rulelink[i].p_cross;
		  while ( c_pointer1 != NULL ) {
			  
			  if ( c_pointer1->data == 1 ) {	// single body

				  b_pointer1 = c_pointer1->p_body;
				  i_temp = b_pointer1->data;

				  if ( ( i_temp > 0 ) && ( CS_atom[ abs( i_temp) ] == 0 ) ) {		// fail :- p
					  
					  _stable =0; 
					  CS_atom[ abs(i_temp) ] = 1;
						  
				  }
				  else if ( ( i_temp < 0 ) && ( CT_atom[ abs( i_temp) ] == 0 ) ) {	// fail :- not p
						  					 
					  _stable =0; 
					  CT_atom[ abs(i_temp) ] = 1;
								  
				  } // else if 
			  
			  } // if

			  c_pointer1 = c_pointer1->p_cross;

		  } // while
		  
	  }// if, S set, constraint false


										  		
	  if ( CT_atom[i] == 1 ) {					// Approach 2, collect from T set, constraint facT

		  if ( rulelink[i].data == 1 ) {		// Only one rule

			  c_pointer1 = rulelink[i].p_cross;
			  if ( c_pointer1->data == 1 ) {	// Only one body

				  b_pointer1 = c_pointer1->p_body;
				  i_temp = b_pointer1->data;

				  if ( ( i_temp > 0 ) && ( CT_atom[ abs( i_temp) ] == 0 ) ) {		// true <-> p
					  
					  _stable =0; 
					  CT_atom[ abs(i_temp) ] = 1;
						  
				  }
				  else if ( ( i_temp < 0 ) && ( CS_atom[ abs( i_temp) ] == 0 ) ) {	// true <-> not p
						  					 
					  _stable =0; 
					  CS_atom[ abs(i_temp) ] = 1;
								  
				  } // else if 


				  //reduce
				  rulelink[i].data = 0;
				  rulelink[i].p_cross = NULL;	
				  delete b_pointer1;
				  delete c_pointer1;
			  
			  } // if, Only one body
		  
		  } // if, Only one rule
						
	  } // if, Approach 2,



	  // checking the consistency of the program
	  if ((CT_atom[i]==1)&&(CS_atom[i]==1 )) { _stable = -1; }	// Constraint facT && Constraint falSe
	  if ((CT_atom[i]==1)&&(TS_atom[i]==-1 )) { _stable = -1; }	// Constraint facT && pure false
	  if ((CS_atom[i]==1)&&(TS_atom[i]==1 )) { _stable = -1; }	// Constraint falSe && pure fact
	  
	  if ( ( _stable == -1 ) && ( PARA_DebugMode > 0 ) ) { 
		  //fprintf(fp_everything, "\n Inconsistent: %d : CT: %d, CS: %d, TS: %d \n", i, CT_atom[i], CS_atom[i], TS_atom[i] );
	  }

	  i++;

  }  // end of while  



  // About cpnstraint fact and pure fact.
  // pure fact p:	CT_atom[p] ==0; CS_atom[p] ==0; TS_atom[p] == +1; rulelink[p].data == -1
  // pure false p:	CT_atom[p] ==0; CS_atom[p] ==0; TS_atom[p] == -1; rulelink[p].data == 0
  // constraint fact p:	CT_atom[p] ==1; CS_atom[p] ==0; TS_atom[p] == 0; rulelink[p].data > 0
  // constraint false p:CT_atom[p] ==0; CS_atom[p] ==1; TS_atom[p] == 0; rulelink[p].data > 0

  if ( PARA_DebugMode > 1 ) {

	  //fprintf(fp_everything, "\n\n Reduce_ConstraintFact_Collection: set T, facT; set S, flaSe\n\n"); 
	  for (i=1; i<= main_atom; i++ ) {
		  if ( CT_atom[i] ==1 ) {  //fprintf(fp_everything, "%d: T  ", i); 
		  }
		  if ( CS_atom[i] ==1 ) {  //fprintf(fp_everything, "%d: S  ", i); 
		  }
	  }
	  //fprintf(fp_everything, "\n\n"); 
  }


  
  return(_stable);


} // END of Reduce_ConstraintFact_Collection(), 
// OUTPUT: CF_atom[], _coincide, 






// publice: rulelink[], CF_atom[], main_rule, len_rule, 
void Reduce_ConstraintFact_Reduce( )						// reduce rulelink[] by constraint facts
{ 
	// T-set are those must be positive in any models, such as facts
	// S-set are those must be negative in any models, such as fail.

	int i;
	int _head, _body;
	int _stable =1;	// T-set stable
//	int _stableS =1;	// S-set stable


	// reduce rulelink

	for ( i=1; i< main_atom+1; i++ ) {
		if( i==11 ) {
			i=i;
		}


		if ( rulelink[i].data >= 0 ){          // for normal rules and fail rule, constraints

			_head = i;


			// (2)body reducing
			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					_body = b_pointer1->data;

					// a. positive-negative negative-positive case, delete this rule
					if (((_body<0)&&(CT_atom[abs(_body)]==1))||((_body>0)&&(CS_atom[abs(_body)]==1))){

						b_pointer1 = c_pointer1->p_body;	// delete body nodes
						while (b_pointer1 != NULL ) {

							b_pointer2 = b_pointer1;
							b_pointer1 = b_pointer1->p_body;
							delete b_pointer2;

						}
						
						c_pointer2 = rulelink[i].p_cross;	// delete cross nodes
						if ( c_pointer2 == c_pointer1 ) {
							rulelink[i].p_cross = c_pointer1->p_cross;
							
							c_pointer1->p_cross2->p_cross2 = NULL;		//	break 1-1 mapping
							delete c_pointer1;

							c_pointer1 = rulelink[i].p_cross;
						}
						else {
							while ( c_pointer2->p_cross != c_pointer1 ) {
								c_pointer2 = c_pointer2->p_cross;
							}
							c_pointer2->p_cross = c_pointer1->p_cross;

							c_pointer1->p_cross2->p_cross2 = NULL;		//	break 1-1 mapping
							delete c_pointer1;

							c_pointer1 = c_pointer2;
						} // else if


						rulelink[i].data--;					// decrease number of iff-class




						if ( (rulelink[i].data==0)&&(CS_atom[i]==0) ) {// check and add in falSe
							CS_atom[i] = 1;
							_stable = 0;
						}
						
						if( c_pointer1 != NULL ) {
							b_pointer1 = c_pointer1->p_body;
						}
						else {
							b_pointer1 = NULL;
						}
						
					} // end of if, delete rule

					
					// b. positive-positive or negative-negative case, delete this literal
					else if (((_body<0)&&(CS_atom[abs(_body)]==1))||((_body>0)&&(CT_atom[abs(_body)]==1))){

						b_pointer2 = c_pointer1->p_body;	// delete this body node
						if( b_pointer2 == b_pointer1 ) {
							c_pointer1->p_body = b_pointer1->p_body;
							delete b_pointer1;
							b_pointer1 = c_pointer1->p_body;
						}
						else {
							while ( b_pointer2->p_body != b_pointer1 ) {
								b_pointer2 = b_pointer2->p_body;
							}
							b_pointer2->p_body = b_pointer1->p_body;
							delete b_pointer1;
							b_pointer1 = b_pointer2->p_body;
						} // else


						c_pointer1->data--;					// n_body decreased by 1
						
						if ( c_pointer1->data == 0 ) {		// Once a rule is satisfied
						
							if ( CT_atom[i] == 0 ) {			// (i), check and add in facT
								CT_atom[i] = 1;								
								_stable = 0;
							}

							c_pointer2 = rulelink[i].p_cross;	// (ii), delete this cross node
							if ( c_pointer2 == c_pointer1 ) {
								rulelink[i].p_cross = c_pointer1->p_cross;

								c_pointer1->p_cross2->p_cross2 = NULL;		//	break 1-1 mapping
								delete c_pointer1;

								c_pointer1 = rulelink[i].p_cross;
							}
							else {
								while ( c_pointer2->p_cross != c_pointer1 ) {
									c_pointer2 = c_pointer2->p_cross;
								}
								c_pointer2->p_cross = c_pointer1->p_cross;

								c_pointer1->p_cross2->p_cross2 = NULL;		//	break 1-1 mapping
								delete c_pointer1;

								c_pointer1 = c_pointer2;
							} // else if

							rulelink[i].data--;					// (iii), decrease number of iff-class

						}// if, Once a rule is satisfied


					} // end of else if, (b). this atom is undeterminate, delete b_pointer1


					// (c). no action, check next rule element
					else {
						b_pointer1 = b_pointer1->p_body;
					}

				}// end of while, one rule
				
				if (c_pointer1 != NULL ) {
					c_pointer1 = c_pointer1->p_cross;
				}
				
			}// end of while, (2), one iff_class

		}// end of if, for normal and fail rules


	} // end of for




	

} // END of function Reduce_ConstraintFact_Reduce() 
// OUTPUT: CF_rule[]




int Reduce_ConstraintFact()				// to spreat the constraints, what must be satisfied for every model
{

	int i;
	int CF_stable;
	
	  //  Creat CT_atom[],CS_atom[], THis is the T-S set used for constraint spreading
	  //  For any i, CT_atom[i] = 1, if-and-only-if i belongs set CT. 
	  //  For any i, CS_atom[i] = 1, if-and-only-if i belongs set CS. 
	  
  
	  CT_atom = (int * ) malloc( (main_atom+1) * sizeof(int) ) ;         // set T from Constraints 
	  if (CT_atom==NULL) { printf("\nHalt! out of memory: d1\n"); error =1; }
	  CS_atom = (int * ) malloc( (main_atom+1) * sizeof(int) ) ;         // set S from Constraints 
	  if (CS_atom==NULL) { printf("\nHalt! out of memory: d1\n"); error =1; }

	  for(i=0;i<=main_atom;i++) {  CT_atom[i] = 0; CS_atom[i] =0; }     // Initially, 
	  

	  CS_atom[ code_of_fail ] = 1;						// the first constraint


	  // (b) Firstly, CF set is not stable. ( Of course! )
	  CF_stable = Reduce_ConstraintFact_Collection(); 

//  	  if ( PARA_DebugMode > 1 ) {
//		  savefile_rulelink("00rulelink_before_reduce");   // Save the rule-link into a file BEFORE REDUCTION
//	  }

	  // (c) build a loop, Reduce and check, CF-1, CF-2, ..., CF-n. 
	  
	  while (CF_stable ==0 ) {		// not stable

		  Reduce_ConstraintFact_Reduce();                 // REDUCE rule_link by CF-set 
		  CF_stable = Reduce_ConstraintFact_Collection();	// generate CF-set from rule_link 

	  } // end of while, get a stable CF set 

	  if( CF_stable == -1 ) {
		  //printf("\n Get 'Fail' literal, program is inconsistent and has no stable model \n");
		  return( CF_stable );
	  }  

	  Reduce_ConstraintFact_Reduce();                 // REDUCE rule_link by CF-set 


	  return( CF_stable );

}//int Reduce_ConstraintFact()










// Publice: rulelink[], TS_atom[], main_atom, main_rule, len_rule, n_Crule, n_TSrule,
// 
int Reduce_TS_Collection() 
{
// return value:	-1, get 'fail' as a fact! The program is inconsistent and has no stable model
//					1 , if the NEW TS_set = the old one; otherwise 0
	
  int *_TS_atom;
  int _coincide;
//  int _position;

  int i;


  n_Crule=0; n_TSrule=0;

  // (1) generate _TS_atom, initialize it

  _TS_atom = (int * ) malloc( (main_atom+1) * sizeof(int) ) ;         /* _TS_atom */
  if (_TS_atom==NULL) { printf("\nHalt! out of memory: d1\n"); error =1; }
  for(i=0;i<=main_atom;i++) {  _TS_atom[i]=-1; }     // Initially, set -1, false



  // (2) build _TS_atom
  for(i=0;i<main_atom+1;i++) {              /* check rules, find TS set*/


      // FACT  
	  if ( rulelink[i].data == -1)  {
		  _TS_atom[ i ] = 1;		// pure fact

		  if ( i == code_of_fail ) {		// Get 'Fail' literal, return inconsistent
			  return(-1);
		  }
		  
	  }

	  // false
	  else if ( rulelink[i].data == 0 ) {
		  _TS_atom[ i ] = -1;		// pure false
	  }

	  // normal
	  else {
		  _TS_atom[ i ] = 0;		// unknown
	  }

	  
  }  // end of for  

  //_TS_atom[ code_of_fail ] = -1;		// 



  // (3) compare with previous TS_atom
  
  _coincide = 1;
  for (i=1;i<=main_atom; i++) {
	  if ( TS_atom[i] != _TS_atom[i] ) {
		  TS_atom[i] = _TS_atom[i];
		  _coincide = 0;
	  }
  }



  // (4) return
  
  return(_coincide);


} // END of Reduce_TS_Collection(), 
// OUTPUT: TS_atom[], _coincide, 







// publice: rulelink[], TS_atom[], main_rule, len_rule, 
void Reduce_TS_Reduce( )  
{ 
	// T-set are those must be positive in any models, such as facts
	// S-set are those must be negative in any models, such as fail.

	int i;
	int _temp, _head, _body;



	// reduce rulelink

	for ( i=1; i< main_atom+1; i++ ) {
		


		if ( rulelink[i].data == -1 ) {
			
			//free link
			c_pointer1 = rulelink[i].p_cross;
			rulelink[i].p_cross = NULL;	

			while ( c_pointer1 != NULL ) {
				
				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					b_pointer2 = b_pointer1;
					b_pointer1 = b_pointer1->p_body;
					delete b_pointer2;

				}
				

				c_pointer2 = c_pointer1;
				c_pointer1 = c_pointer1->p_cross;
				delete c_pointer2;
			} // end of while

		}// end of if, free link for facts


		//if ( rulelink[i].data > 0 ){          // for normal rules and fail rule
		if ( rulelink[i].data >= 0 ){          // for normal rules and fail rule, constraints

			_head = i;

			
			// (1) fact absorbing
			if( TS_atom[ _head ] == 1 ) {     // fact absorbing, Find a new fact

				rulelink[ _head ].data = -1;  // mark fact


				//free link
				c_pointer1 = rulelink[i].p_cross;
				rulelink[i].p_cross = NULL;      

				while ( c_pointer1 != NULL ) {
					
					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						b_pointer2 = b_pointer1;
						b_pointer1 = b_pointer1->p_body;
						delete b_pointer2;

					}
				

					c_pointer2 = c_pointer1;
					c_pointer1 = c_pointer1->p_cross;
					delete c_pointer2;

				}// end of while

			} // end of if, fact absorbing



			// (2)body reducing
			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					_body = b_pointer1->data;
					//if(_body==125) {
					//	i=i;
					//}
					//if(_body==316) {
					//	i=i;
					//}
					_temp = TS_atom[abs(_body)] * _body;

					// a. positive-negative case, delete this rule
					if ( _temp < 0 ) {

						b_pointer1 = c_pointer1->p_body;
						while (b_pointer1 != NULL ) {

							b_pointer2 = b_pointer1;
							b_pointer1 = b_pointer1->p_body;
							delete b_pointer2;

						}
						
						c_pointer2 = rulelink[i].p_cross;
						if ( c_pointer2 == c_pointer1 ) {
							rulelink[i].p_cross = c_pointer1->p_cross;
							delete c_pointer1;

							c_pointer1 = rulelink[i].p_cross;
						}
						else {
							while ( c_pointer2->p_cross != c_pointer1 ) {
								c_pointer2 = c_pointer2->p_cross;
							}
							c_pointer2->p_cross = c_pointer1->p_cross;
							delete c_pointer1;

							c_pointer1 = c_pointer2;
						} // else if

						rulelink[i].data--;
						
						if( c_pointer1 != NULL ) {
							b_pointer1 = c_pointer1->p_body;
						}
						else {
							b_pointer1 = NULL;
						}
						
					} // end of if

					
					// b. positive-positive case or negative-negative case, delete this literal
					else if ( _temp > 0 ) {  // delete b_pointer1

						b_pointer2 = c_pointer1->p_body;
						if( b_pointer2 == b_pointer1 ) {
							c_pointer1->p_body = b_pointer1->p_body;
							delete b_pointer1;
							b_pointer1 = c_pointer1->p_body;
						}
						else {
							while ( b_pointer2->p_body != b_pointer1 ) {
								b_pointer2 = b_pointer2->p_body;
							}
							b_pointer2->p_body = b_pointer1->p_body;
							delete b_pointer1;
							b_pointer1 = b_pointer2->p_body;
						} // else

						c_pointer1->data--;  // n_body decreased by 1

						// reduce to fact
						if( c_pointer1->data == 0 ) {  // n_body == 0

							rulelink[i].data = -1;

							b_pointer1 = NULL;  // break the loop
							c_pointer1 = NULL;

							i--;

						}


					} // end of else if, (b). this atom is undeterminate, delete b_pointer1


					// (c). equal to 0, no action
					else {
						b_pointer1 = b_pointer1->p_body;
					}

				}// end of while, one rule
				
				if (c_pointer1 != NULL ) {
					c_pointer1 = c_pointer1->p_cross;
				}
				
			}// end of while, (2), one iff_class

		}// end of if, for normal and fail rules


	} // end of for




	

} // END of function Reduce_TS_Reduce() 
// OUTPUT: TS_rule[]




int Reduce_TS()		// from facT-falSe set
{
	int i;
	int TS_stable;
	
	  // (a) INITIALIZE. Creat TS_atom[], and initialize it.  THis is the TS set used for reduction
	  // I build an array for atoms. For each atom, value
	  //                                1  means  TRUE
	  //                                0  means  UNKNOW  
	  //                               -1  means  FALSE 
	  // That is TS_atom[]
  
	  TS_atom = (int * ) malloc( (main_atom+1) * sizeof(int) ) ;         // TS_atom 
	  if (TS_atom==NULL) { printf("\nHalt! out of memory: d1\n"); error =1; }
	  for(i=0;i<=main_atom;i++) {  TS_atom[i]=-1; }     // Initially, set -1, mean false, no rules support it
	  
	  // (b) Firstly, TS set is not stable. ( Of course! )
	  TS_stable = Reduce_TS_Collection(); 

//  	  if ( PARA_DebugMode > 1 ) {
//		  savefile_rulelink("00rulelink_before_reduce");   // Save the rule-link into a file BEFORE REDUCTION
//	  }

	  // (c) build a loop, Reduce and check, TS-1, TS-2, ..., TS-n. 
	  
	  while (TS_stable ==0 ) {

		  Reduce_TS_Reduce();                 // REDUCE rule_link by TS-set 
		  TS_stable = Reduce_TS_Collection();	// generate TS-set from rule_link 

	  } // end of while, get a stable TS set 

	  if( TS_stable == -1 ) {
		  //printf("\n Get 'Fail' literal, program is inconsistent and has no stable model \n");
		  
	  }  

	  Reduce_TS_Reduce();                 // REDUCE rule_link by TS-set 


	  return( TS_stable );

} // int Reduce_TS()







int Reduce_StrongE_1()							// Reduce on Strong Equivalence formulas
{	// For p :- p, G , then delete it
	int i;
//	int _temp, , _body;
	int _head;


	// reduce rulelink

	for ( i=1; i< main_atom+1; i++ ) {
		




		if ( rulelink[i].data > 0 ){          // for normal rules 

			_head = i;
	

			// (2)body reducing
			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {
					
					
					if ( _head == b_pointer1->data ) {			// p:-p, G, delete this rule

						b_pointer1 = c_pointer1->p_body;
						while (b_pointer1 != NULL ) {

							b_pointer2 = b_pointer1;
							b_pointer1 = b_pointer1->p_body;
							delete b_pointer2;

						}
						
						c_pointer2 = rulelink[i].p_cross;
						if ( c_pointer2 == c_pointer1 ) {
							rulelink[i].p_cross = c_pointer1->p_cross;
							delete c_pointer1;

							c_pointer1 = rulelink[i].p_cross;
						}
						else {
							while ( c_pointer2->p_cross != c_pointer1 ) {
								c_pointer2 = c_pointer2->p_cross;
							}
							c_pointer2->p_cross = c_pointer1->p_cross;
							delete c_pointer1;

							c_pointer1 = c_pointer2;
						} // else if

						rulelink[i].data--;
						
						if( c_pointer1 != NULL ) {
							b_pointer1 = c_pointer1->p_body;
						}
						else {
							b_pointer1 = NULL;
						}

						
						if( PARA_DebugMode > 1 ) {
							//fprintf(fp_everything, "\n delete a rule in Reduce_StrongE_1(), %d :- %d , G \n",i,i);
						}

					} // end of if == , delete this rule
					
					else {										// next,
						b_pointer1 = b_pointer1->p_body;
					}

				}// end of while, one rule
				
				if (c_pointer1 != NULL ) {
					c_pointer1 = c_pointer1->p_cross;
				}
				
			}// end of while, (2), one iff_class


		}// end of if, for normal and fail rules


	} // end of for



	return(1);

}  // end of Reduce_StrongE_1()




int Reduce_StrongE_2()							// Reduce on Strong Equivalence formulas
{	// For p :-  not p, return -1, no stable model

	int i;
	int _head;


	// reduce rulelink

	for ( i=1; i< main_atom+1; i++ ) {

		if ( rulelink[i].data == 1 ) {          // for rules with single rule

			if ( rulelink[i].p_cross ->data == 1 ) {          // for rules with single body

				if ( i == (-1) * rulelink[i].p_cross ->p_body->data )	{

					if( PARA_DebugMode > 1 ) {
						//fprintf(fp_everything, "\n Reduce_StrongE_2(), %d :- not %d \n",i, i);
					}

					//printf("\n Reduce_StrongE_2(), %d :- not %d \n",i, i);

					return(-1);
				}
			}
		}

	}

	return(1);

} // Reduce_StrongE_2()




int check_consistency()          // return _consistent, consistent returns 1, otherwise 0
{
	struct CROSSNODE *_cp1;
	struct BODYNODE *_bp1;

	int i;


	for ( i=1; i<=main_atom; i++) {
		
		if ( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {

			_cp1 = rulelink[i].p_cross;
			while( _cp1 != NULL ) {
				
				_bp1=_cp1->p_body;

				while( _bp1 != NULL ) {

					if ( TS_atom[ abs(_bp1->data) ] != 0 ) {
						return(0);
					}
					_bp1 = _bp1->p_body;

				} // while

				_cp1 = _cp1->p_cross;

			} //while

		} // end of if
			
	} // end of for

	//printf("    .... consistent!\n");
	return(1);

}  // end of check_consistency()











void CNF_iffclass_by_ccalc(  int _head )    // build CNF by CCALC

	/*						p :- a1, a2, ..., am
							p :- b1, b2, ..., bn
							p :- c
					-----------------------------------
				NORMAL method,          |         SUBSTISUTE

			 (A.1) " IF_semantics "		|   (B.1) " IF "
				p <-  a1^a2^...^an		|		p <- A V B V c
				p <-  b1^b2^...^bm		|	------------------------- 
				p <-  c					|		-A P
          ------------------------------|		-B p
				-a1 V ... V -an V p		|		-c p
				-b1 V ... V -bn V p		|
				-c V p					|

			 (A.2) " ONLYIF-Semantics " |   (B.2) " ONLYIF-Semantics ", substitute
             	p ->  a1^a2^...^an      |        p -> A
				p ->  b1^b2^...^bm      |        p -> B
				p ->  c                 |        p -> c
			----------------------------|		 A <=> a1^a2^...^an
				-p a1 b1 c              |        B <=> b1^b2^...^bm  
				-p a1 b2 c              |  --------------------------------------
				...                     |        (a) -a1 -a2 ... -an A
				-p a1 bm c              |        (b) -A a1 / -A a2 / ... / -A an
				-p a2 b1 c              |        (c) -p A B c 
				...                     |       
				...                     |
				-p an bm c              |
  	 
	*/

{
	struct CROSSNODE *_linkhead;
	struct CROSSNODE *_cp1 ;
	struct BODYNODE  *_bp1 ;
	//struct BODYNODE  **combination_pointers1, **combination_pointers2;

	int _n_iff;

	int _n_add_atom=0;
	int _add_atom;    //_add_atom = no_atom + _n_add_atom;

	int _pi_times;

	int i, j, k, _stop;



	// (1),

	_n_iff = rulelink[ _head ].data;
	_linkhead = rulelink[ _head ].p_cross; 

 	



	// (2), calculate _pi_times ,  _pi_times = l1*l2*...*lm

	_pi_times = 1; 


	_cp1 = _linkhead;
	while (_cp1 != NULL ) {

		_pi_times = _pi_times * _cp1->data;
		
		_cp1 = _cp1->p_cross;

	} // end of while, 

	






	// (3), completion

	if ( _pi_times > 8 ) {             // (B), " Substitute 


		// (B.1), IF- semantics
		

		_cp1 = _linkhead;
		
		while (_cp1 != NULL ) {

			_bp1 = _cp1->p_body;

			while ( _bp1 != NULL ) {

				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
				
				_bp1 = _bp1->p_body;
			}


			fprintf(fp_cnf, "%d 0\n", _head );
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class
		// (B.1), implement the " IF_semantics " of this iff-class

		

		// (B.2), ONLYIF- semantics

		_cp1 = _linkhead;
		
		while (_cp1 != NULL ) {    

			if ( _cp1->data > 1 ) {   // This guy is to be substitute

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;


				/*
				// (a), A <- a1^a2^...^an      |     -a1 -a2 ... -an A
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					fprintf(fp_cnf, "%d ", (-1) * _bp1->data );  
					_bp1 = _bp1->p_body;

				} // end of while. 

				fprintf(fp_cnf, "%d 0\n", _add_atom );  
				cnf_clause++;
				*/



				// (b), A -> a1^a2^...^an      |     -A a1 / -A a2 / ... / -A an 
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					fprintf(fp_cnf, "%d %d 0\n", (-1)*_add_atom, _bp1->data );  
					cnf_clause++;

					_bp1 = _bp1->p_body;

				} // end of while. 
			
			}  // end of if, this guy has been substituted
		
			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class



		// (c), p -> A B c                        |   -p A B c
		fprintf(fp_cnf, "%d ", (-1)*_head );  
		
		_cp1 = _linkhead;
		while (_cp1 != NULL ) {
			
			if ( _cp1->data == 1 ) {        // Normal single body

				_bp1 = _cp1->p_body;
				fprintf(fp_cnf, "%d ", _bp1->data );  

			}

			else {                          // add_atom

				no_atom++;
				fprintf(fp_cnf, "%d ", no_atom );

			}

			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class

		fprintf(fp_cnf, "0\n" );  
		
		cnf_clause++;

	}  // end of if, (B) substitute



	else {                 // (A), no substitute, normal method, combination   


		// (A.1)   " IF_semantics "	
		
		_cp1 = _linkhead;
		
		while (_cp1 != NULL ) {

			_bp1 = _cp1->p_body;

			while ( _bp1 != NULL ) {

				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
				
				_bp1 = _bp1->p_body;
			}

			fprintf(fp_cnf, "%d 0\n", _head );
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, (A.1), implement the " IF_semantics " of this iff-class





		// (A.2), ONLYIF - semantics

		//combination_pointers1 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }
		//combination_pointers2 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		if ( _n_iff > len_combination_pointer ) {
			//printf(" _n_iff:%d ",_n_iff); 
			free ( combination_pointers1 );
			free ( combination_pointers2 );
			
			len_combination_pointer = _n_iff +2;

			combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }


			
		}



		i=0;

		_cp1 = _linkhead;
		while ( _cp1 != NULL ) {

			combination_pointers1[i] = _cp1->p_body;   
			combination_pointers2[i] = _cp1->p_body;   

			i++;

			_cp1 = _cp1->p_cross;
		}



		_stop=0;
		while ( _stop == 0 ) {
			
			fprintf(fp_cnf,"%d ", (-1) * _head);
			
			for (i=0; i < _n_iff; i++) {
				fprintf(fp_cnf, "%d ", combination_pointers1[i]->data);
			}

			fprintf(fp_cnf, "0\n");
			cnf_clause++;


			j=0;
			while ( (j<_n_iff) && ( combination_pointers1[j]->p_body == NULL ) ) {
				j++;
			}

			if ( j == _n_iff ) {  _stop = 1;	}
			else {
				combination_pointers1[j] = combination_pointers1[j]->p_body;

				for( k=0; k<j; k++) {
					combination_pointers1[k] = combination_pointers2[k];
				}
			}


		}  // end of while


		//delete []combination_pointers1;
		//delete []combination_pointers2;

	}  // end of else, (A), no substitute, normal method, combination   















	// (5), delete link ?  remind me, why do not use rulelink for CHECK part?

	/*
	_cp1 = _linkhead;
	_cp2 = _cp1;

	while (_cp1 != NULL ) {

		_bp1 = _cp1->p_body;
		_bp2 = _bp1;

		while ( _bp1 != NULL ) {  // delete body nodes

			_bp1 = _bp1->p_body;
			delete _bp2;

			_bp2 = _bp1;
					
		}

		_cp1 = _cp1->p_cross;
		delete _cp2;              // delete cross node

		_cp2 = _cp1;

	} // end of while, delete link.

	rulelink[_head].p_cross = NULL;

    */



	return;

////////

} // CNF_iffclass_by_ccalc()



void CNF_iffclass_by_ccalc_old(  int _head )
{

	struct CROSSNODE *_linkhead;
	struct CROSSNODE *_cp1;//, *_cp2;
	struct BODYNODE  *_bp1, *_bp2;

	int _n_iff;
	int _n_add_atom=0;
	int _add_atom;




	// (1),

	_n_iff = rulelink[ _head ].data;
	_linkhead = rulelink[ _head ].p_cross; 





	// (2), single rule

	if ( _n_iff ==1 ) {

		// (2.1), CNF
		



		// (A'), " IF-Semantics "

		_cp1 = _linkhead;
		_bp1 = _cp1->p_body;

		while ( _bp1 != NULL ) {

			fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
			
			_bp1 = _bp1->p_body;
		}

		fprintf(fp_cnf, "%d 0\n", _head );
		cnf_clause++;




		// (C'), " ONLYIF-Semantics "

		_cp1 = _linkhead;
		_bp1 = _cp1->p_body;

		while ( _bp1 != NULL ) {

			fprintf(fp_cnf, "%d %d 0\n", (-1)*_head, _bp1->data );  
			cnf_clause++;

			_bp1 = _bp1->p_body;

		}


		
		


		// (2.2) Delete
		_cp1 = _linkhead;
		_bp1 = _cp1->p_body;
		_bp2 = _bp1;

		while ( _bp1 != NULL ) {

			_bp1 = _bp1->p_body;
			delete _bp2;

			_bp2 = _bp1;
		}

		delete _cp1;

		rulelink[ _head ].p_cross = NULL;

		//single_rule(_linkhead->p_body, _common, _head);
		return;

	}  // end of if, (2), single rule





	// (3), Non-single rule
	/*										p :- a1, a2, ..., am
											p :- b1, b2, ..., bn
											p :- c
										-----------------------------------
								
								  (A') " IF_semantics "		
											p <-  a1^a2^...^an 
											p <-  b1^b2^...^bm 
											p <-  c               

								  (B') " Substitute_semantics "
											a1^a2^...^an <- A
											b1^b2^...^bm <- B      

								  (C') " ONLYIF-Semantics "

											A V B V c <- p
	*/




	// (A'),  " IF_semantics "	

	_cp1 = _linkhead;
	
	while (_cp1 != NULL ) {

		_bp1 = _cp1->p_body;

		while ( _bp1 != NULL ) {

			fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
			
			_bp1 = _bp1->p_body;
		}


		fprintf(fp_cnf, "%d 0\n", _head );
		cnf_clause++;

		_cp1 = _cp1->p_cross;

	} // end of while, implement the " IF_semantics " of this iff-class




	// (B'), " Substitute_semantics "

	_cp1 = _linkhead;
	
	while (_cp1 != NULL ) {

		if ( _cp1->data > 1 ) {  // The length of body is larger than 1, SUBSTITUTION

			_n_add_atom ++;

			_add_atom = no_atom + _n_add_atom;

			_bp1 = _cp1->p_body;
			while ( _bp1 != NULL ) {

				fprintf(fp_cnf, "%d %d 0\n", (-1)*_add_atom, _bp1->data );  
				cnf_clause++;

				_bp1 = _bp1->p_body;

			} // end of while. 

		} // end of if, one Substituation

		_cp1 = _cp1->p_cross;

	} // end of while, implement the " IF_semantics " of this iff-class




	// (C'), " ONLYIF-Semantics "

	fprintf(fp_cnf, "%d ", (-1)*_head );  
	
	_cp1 = _linkhead;
	while (_cp1 != NULL ) {

		if ( _cp1->data == 1 ) {        // Normal single body

			_bp1 = _cp1->p_body;
			fprintf(fp_cnf, "%d ", _bp1->data );  

		}

		else {                          // add_atom

			no_atom++;
			fprintf(fp_cnf, "%d ", no_atom );

		}

		_cp1 = _cp1->p_cross;

	} // end of while, implement the " IF_semantics " of this iff-class

	fprintf(fp_cnf, "0\n" );  
	cnf_clause++;







	// (4), delete link ?  remind me, why do not use rulelink for CHECK part?
/*
	
	_cp1 = _linkhead;
	_cp2 = _cp1;

	while (_cp1 != NULL ) {

		_bp1 = _cp1->p_body;
		_bp2 = _bp1;

		while ( _bp1 != NULL ) {  // delete body nodes

			_bp1 = _bp1->p_body;
			delete _bp2;

			_bp2 = _bp1;
					
		}

		_cp1 = _cp1->p_cross;
		delete _cp2;              // delete cross node

		_cp2 = _cp1;

	} // end of while, delete link.

	rulelink[_head].p_cross = NULL;

*/


	return;

////////

} // CNF_iffclass_by_ccalc()








void CNF_iffclass_by_clark(  int _head )    // build CNF by Clark's approach
{
	/*						p :- a1, a2, ..., am
							p :- b1, b2, ..., bn
							p :- c
					-----------------------------------
				NORMAL method,          |         SUBSTISUTE

			 (A.1) " IF_semantics "		|   (B.1) " IF "
				p <-  a1^a2^...^an		|		p <- A V B V c
				p <-  b1^b2^...^bm		|	------------------------- 
				p <-  c					|		-A P
          ------------------------------|       -B p
				-a1 V ... V -an V p		|		-c p
				-b1 V ... V -bn V p		|
				-c V p					|

			 (A.2) " ONLYIF-Semantics " |   (B.2) " ONLYIF-Semantics ", substitute
             	p ->  a1^a2^...^an      |        p -> A
				p ->  b1^b2^...^bm      |        p -> B
				p ->  c                 |        p -> c
			----------------------------|		 A <=> a1^a2^...^an
				-p a1 b1 c              |        B <=> b1^b2^...^bm  
				-p a1 b2 c              |  --------------------------------------
				...                     |        (a) -a1 -a2 ... -an A
				-p a1 bm c              |        (b) -A a1 / -A a2 / ... / -A an
				-p a2 b1 c              |        (c) -p A B c 
				...                     |       
				...                     |
				-p an bm c              |
  	 
	*/


	struct CROSSNODE *_linkhead;
	struct CROSSNODE *_cp1;//, *_cp2;
	struct BODYNODE  *_bp1;//, *_bp2;
	//struct BODYNODE  **combination_pointers1, **combination_pointers2;

	int _n_iff;

	int _n_add_atom=0;
	int _add_atom;    //_add_atom = no_atom + _n_add_atom;

	int _pi_times, _sigma_adds;

	int i, j, k, _stop;



	// (1),

	_n_iff = rulelink[ _head ].data;
	_linkhead = rulelink[ _head ].p_cross; 

 	



	// (2), calculate _pi_times & _sigma_adds; decide if it is necessary to substitute

	_pi_times = 1; _sigma_adds = 0;


	_cp1 = _linkhead;
	while (_cp1 != NULL ) {

		_pi_times = _pi_times * _cp1->data;
		_sigma_adds = _sigma_adds + _cp1->data;
		_cp1 = _cp1->p_cross;

	} // end of while, 

	_pi_times = _pi_times + _n_iff;
	_sigma_adds = _sigma_adds + 2 * _n_iff + 1;






	// (3), completion

	if ( _pi_times > PARA_RateOfSubstitute * _sigma_adds ) {             // (B), " Substitute 

		

		// (B.1), IF- semantics
		_cp1 = _linkhead; 			
		_n_add_atom =0;
		
		while (_cp1 != NULL ) {

			if ( _cp1->data >1 ) {

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;

				fprintf(fp_cnf, "%d ", (-1)* _add_atom );  
				
			}
			else if ( _cp1->data == 1 ) {
				_bp1 = _cp1->p_body;
				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
			}
			_cp1 = _cp1->p_cross;

			fprintf(fp_cnf, "%d 0\n", _head );
			cnf_clause++;

		} 	// end of while, 

		//fprintf(fp_cnf, "%d 0\n", _head );
		//cnf_clause++;
		// (B.1), implement the " IF_semantics " of this iff-class

		

		// (B.2), ONLYIF- semantics

		_cp1 = _linkhead;
		_n_add_atom =0;
		
		while (_cp1 != NULL ) {    

			if ( _cp1->data > 1 ) {   // This guy is to be substitute

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;


				// (a), A <- a1^a2^...^an      |     -a1 -a2 ... -an A
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					fprintf(fp_cnf, "%d ", (-1) * _bp1->data );  
					_bp1 = _bp1->p_body;

				} // end of while. 

				fprintf(fp_cnf, "%d 0\n", _add_atom );  
				cnf_clause++;



				// (b), A -> a1^a2^...^an      |     -A a1 / -A a2 / ... / -A an 
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					fprintf(fp_cnf, "%d %d 0\n", (-1)*_add_atom, _bp1->data );  
					cnf_clause++;

					_bp1 = _bp1->p_body;

				} // end of while. 
			
			}  // end of if, this guy has been substituted
		
			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class



		// (c), p -> A B c                        |   -p A B c
		fprintf(fp_cnf, "%d ", (-1)*_head );  
		
		_cp1 = _linkhead;
		while (_cp1 != NULL ) {
			
			if ( _cp1->data == 1 ) {        // Normal single body

				_bp1 = _cp1->p_body;
				fprintf(fp_cnf, "%d ", _bp1->data );  

			}

			else {                          // add_atom

				no_atom++;
				fprintf(fp_cnf, "%d ", no_atom );

			}

			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class

		fprintf(fp_cnf, "0\n" );  
		
		cnf_clause++;

	}  // end of if, (B) substitute



	else {                 // (A), no substitute, normal method, combination   


		// (A.1)   " IF_semantics "	
		
		_cp1 = _linkhead;
		
		while (_cp1 != NULL ) {

			_bp1 = _cp1->p_body;

			while ( _bp1 != NULL ) {

				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
				
				_bp1 = _bp1->p_body;
			}

			fprintf(fp_cnf, "%d 0\n", _head );
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, (A.1), implement the " IF_semantics " of this iff-class





		// (A.2), ONLYIF - semantics

		//combination_pointers1 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		//combination_pointers2 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		if ( _n_iff > len_combination_pointer ) {
			//printf(" _n_iff:%d ",_n_iff); 
			
			free ( combination_pointers1 );
			free ( combination_pointers2 );
			
			len_combination_pointer = _n_iff +2;

			combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }

			
		}


		i=0;

		_cp1 = _linkhead;
		while ( _cp1 != NULL ) {

			combination_pointers1[i] = _cp1->p_body;   
			combination_pointers2[i] = _cp1->p_body;   

			i++;

			_cp1 = _cp1->p_cross;
		}



		_stop=0;
		while ( _stop == 0 ) {
			
			fprintf(fp_cnf,"%d ", (-1) * _head);
			
			for (i=0; i < _n_iff; i++) {
				fprintf(fp_cnf, "%d ", combination_pointers1[i]->data);
			}

			fprintf(fp_cnf, "0\n");
			cnf_clause++;


			j=0;
			while ( (j<_n_iff) && ( combination_pointers1[j]->p_body == NULL ) ) {
				j++;
			}

			if ( j == _n_iff ) {  _stop = 1;	}
			else {
				combination_pointers1[j] = combination_pointers1[j]->p_body;

				for( k=0; k<j; k++) {
					combination_pointers1[k] = combination_pointers2[k];
				}
			}


		}  // end of while


		//delete []combination_pointers1;
		//delete []combination_pointers2;

	}  // end of else, (A), no substitute, normal method, combination   















	// (5), delete link ?  remind me, why do not use rulelink for CHECK part?

/*	
	_cp1 = _linkhead;
	_cp2 = _cp1;

	while (_cp1 != NULL ) {

		_bp1 = _cp1->p_body;
		_bp2 = _bp1;

		while ( _bp1 != NULL ) {  // delete body nodes

			_bp1 = _bp1->p_body;
			delete _bp2;

			_bp2 = _bp1;
					
		}

		_cp1 = _cp1->p_cross;
		delete _cp2;              // delete cross node

		_cp2 = _cp1;

	} // end of while, delete link.

	rulelink[_head].p_cross = NULL;

*/


	return;

////////

} // CNF_iffclass_by_clark()




void sort( int _sorting[100] )
{

	int i, j;
	int temp;

	for (i=1; i<= _sorting[0]; i++ ) {

		temp = _sorting[i];

		for( j=i+1; j<= _sorting[0]; j++ ) {

			if( temp > _sorting[j] ) {  // exchange
				temp = _sorting[j];
				_sorting[j] = _sorting[i];
				_sorting[i] = temp;
			}
		} // end of for, j

		fprintf(fp_cnf, "%d ", temp);

	} // end of for, i

	fprintf(fp_cnf, "0\n");

	/*
	struct BODYNODE *_bp1, *_bp2, *_bp3;


	_bp1 = new BODYNODE;

	_bp1->data = _sorting[1];    _bp1->p_body = NULL;


	for ( i=1; i<= _sorting[0]; i++) {

		_bp3 = new BODYNODE;
		_bp3->data = _sorting[i];    _bp3->p_body = NULL;

		_bp2 = _bp1;
		while ( _bp2->p_body != NULL ) {
			if ( _bp2->p_body->data < _bp3->data ) { _bp2 = _bp2->p_body;  }
			else {
				_bp3->p_body = _bp2->p_body;
				_bp2->p_body = _bp3;
			} // end of else
		} // while

		if (_bp2->p_body == NULL ) {
			_bp3->p_body = _bp2->p_body;
			_bp2->p_body = _bp3;
		}

	} // end of for

	
	_bp2 = _bp1->p_body;
	while ( _bp2 != NULL ) {

		fprintf(fp_cnf, "%d ", _bp2->data);

		_bp2 = _bp2->p_body;

	} // while
	
	fprintf(fp_cnf, "0\n");
*/
}





void CNF_iffclass_by_clark_withsorting(  int _head )    // build CNF by Clark's approach
{
	/*						p :- a1, a2, ..., am
							p :- b1, b2, ..., bn
							p :- c
					-----------------------------------
				NORMAL method,          |         SUBSTISUTE

			 (A.1) " IF_semantics "		|   (B.1) " IF "
				p <-  a1^a2^...^an		|		p <- A V B V c
				p <-  b1^b2^...^bm		|	------------------------- 
				p <-  c					|		-A P
          ------------------------------|       -B p
				-a1 V ... V -an V p		|		-c p
				-b1 V ... V -bn V p		|
				-c V p					|

			 (A.2) " ONLYIF-Semantics " |   (B.2) " ONLYIF-Semantics ", substitute
             	p ->  a1^a2^...^an      |        p -> A
				p ->  b1^b2^...^bm      |        p -> B
				p ->  c                 |        p -> c
			----------------------------|		 A <=> a1^a2^...^an
				-p a1 b1 c              |        B <=> b1^b2^...^bm  
				-p a1 b2 c              |  --------------------------------------
				...                     |        (a) -a1 -a2 ... -an A
				-p a1 bm c              |        (b) -A a1 / -A a2 / ... / -A an
				-p a2 b1 c              |        (c) -p A B c 
				...                     |       
				...                     |
				-p an bm c              |
  	 
	*/


	struct CROSSNODE *_linkhead;
	struct CROSSNODE *_cp1, *_cp2;
	struct BODYNODE  *_bp1, *_bp2;
	//struct BODYNODE  **combination_pointers1, **combination_pointers2;

	int _n_iff;

	int _n_add_atom=0;
	int _add_atom;    //_add_atom = no_atom + _n_add_atom;

	int _pi_times, _sigma_adds;

	int i, j, k, _stop;

	int _sorting[100];


	// (0)
	for( i=0; i<100; i++) {
		_sorting[i] = 0;
	}



	if( _head == 210) {
		i=i;
	}

	// (1),

	_n_iff = rulelink[ _head ].data;
	_linkhead = rulelink[ _head ].p_cross; 

 	



	// (2), calculate _pi_times & _sigma_adds; decide if it is necessary to substitute

	_pi_times = 1; _sigma_adds = 0;


	_cp1 = _linkhead;
	while (_cp1 != NULL ) {

		_pi_times = _pi_times * _cp1->data;
		_sigma_adds = _sigma_adds + _cp1->data;
		_cp1 = _cp1->p_cross;

	} // end of while, 

	_pi_times = _pi_times + _n_iff;
	_sigma_adds = _sigma_adds + 2 * _n_iff + 1;






	// (3), completion

	if ( _pi_times > PARA_RateOfSubstitute * _sigma_adds ) {             // (B), " Substitute 


		// (B.1), IF- semantics
		_cp1 = _linkhead; 			
		_n_add_atom =0;
		
		while (_cp1 != NULL ) {

			if ( _cp1->data >1 ) {

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;

				//fprintf(fp_cnf, "%d ", (-1)* _add_atom );  
				_sorting[0]++;
				_sorting[ _sorting[0] ] = (-1)* _add_atom;
				
			}
			else if ( _cp1->data == 1 ) {
				_bp1 = _cp1->p_body;

				//fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
				_sorting[0]++;
				_sorting[ _sorting[0] ] = (-1)* _bp1->data ;

			}
			_cp1 = _cp1->p_cross;

			_sorting[0]++;
			_sorting[ _sorting[0] ] = _head ;

			sort(_sorting); _sorting[0]=0;
			cnf_clause++;

		} 	// end of while, 


		//fprintf(fp_cnf, "%d 0\n", _head );
		// (B.1), implement the " IF_semantics " of this iff-class

		

		// (B.2), ONLYIF- semantics

		_cp1 = _linkhead;
		_n_add_atom=0;
		
		while (_cp1 != NULL ) {    

			if ( _cp1->data > 1 ) {   // This guy is to be substitute

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;


				// (a), A <- a1^a2^...^an      |     -a1 -a2 ... -an A
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					//fprintf(fp_cnf, "%d ", (-1) * _bp1->data );  
					_sorting[0]++;
					_sorting[ _sorting[0] ] = (-1)* _bp1->data ;

					_bp1 = _bp1->p_body;

				} // end of while. 

				//fprintf(fp_cnf, "%d 0\n", _add_atom );  
				_sorting[0]++;
				_sorting[ _sorting[0] ] = _add_atom ;

				sort( _sorting );   _sorting[0]=0;
				cnf_clause++;



				// (b), A -> a1^a2^...^an      |     -A a1 / -A a2 / ... / -A an 
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					//fprintf(fp_cnf, "%d %d 0\n", (-1)*_add_atom, _bp1->data );  
					_sorting[0]++;
					_sorting[ _sorting[0] ] = (-1)*_add_atom;
					_sorting[0]++;
					_sorting[ _sorting[0] ] = _bp1->data;

					sort( _sorting);   _sorting[0]=0;
					cnf_clause++;

					_bp1 = _bp1->p_body;

				} // end of while. 
			
			}  // end of if, this guy has been substituted
		
			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class



		// (c), p -> A B c                        |   -p A B c

		//fprintf(fp_cnf, "%d ", (-1)*_head );  
		_sorting[0]++;
		_sorting[ _sorting[0] ] = (-1)*_head;

		
		_cp1 = _linkhead;
		while (_cp1 != NULL ) {
			
			if ( _cp1->data == 1 ) {        // Normal single body

				_bp1 = _cp1->p_body;

				//fprintf(fp_cnf, "%d ", _bp1->data );  
				_sorting[0]++;
				_sorting[ _sorting[0] ] = _bp1->data;

			}

			else {                          // add_atom

				no_atom++;

				//fprintf(fp_cnf, "%d ", no_atom );
				_sorting[0]++;
				_sorting[ _sorting[0] ] = no_atom;

			}

			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class

		//fprintf(fp_cnf, "0\n" );  

		sort( _sorting );   _sorting[0]=0;
		cnf_clause++;

	}  // end of if, (B) substitute



	else {                 // (A), no substitute, normal method, combination   


		// (A.1)   " IF_semantics "	
		
		_cp1 = _linkhead;
		
		while (_cp1 != NULL ) {

			_bp1 = _cp1->p_body;

			while ( _bp1 != NULL ) {

				//fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  
				_sorting[0]++;
				_sorting[ _sorting[0] ] = (-1)* _bp1->data;
				
				_bp1 = _bp1->p_body;
			}

			//fprintf(fp_cnf, "%d 0\n", _head );
			_sorting[0]++;
			_sorting[ _sorting[0] ] = _head;

			sort( _sorting );  _sorting[0]=0;
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, (A.1), implement the " IF_semantics " of this iff-class





		// (A.2), ONLYIF - semantics

		//combination_pointers1 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }
		//combination_pointers2 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		if ( _n_iff > len_combination_pointer ) {
			//printf("_n_iff:%d",_n_iff); 

			free ( combination_pointers1 );
			free ( combination_pointers2 );
			
			len_combination_pointer = _n_iff+2;

			combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }

		}



		i=0;

		_cp1 = _linkhead;
		while ( _cp1 != NULL ) {

			combination_pointers1[i] = _cp1->p_body;   
			combination_pointers2[i] = _cp1->p_body;   

			i++;

			_cp1 = _cp1->p_cross;
		}



		_stop=0;
		while ( _stop == 0 ) {
			
			//fprintf(fp_cnf,"%d ", (-1) * _head);
			_sorting[0]++;
			_sorting[ _sorting[0] ] = (-1)*_head;

			
			for (i=0; i < _n_iff; i++) {
				//fprintf(fp_cnf, "%d ", combination_pointers1[i]->data);
				_sorting[0]++;
				_sorting[ _sorting[0] ] = combination_pointers1[i]->data;

			}

			//fprintf(fp_cnf, "0\n");

			sort ( _sorting );  _sorting[0] = 0;
			cnf_clause++;


			j=0;
			while ( (j<_n_iff) && ( combination_pointers1[j]->p_body == NULL ) ) {
				j++;
			}

			if ( j == _n_iff ) {  _stop = 1;	}
			else {
				combination_pointers1[j] = combination_pointers1[j]->p_body;

				for( k=0; k<j; k++) {
					combination_pointers1[k] = combination_pointers2[k];
				}
			}


		}  // end of while


		//delete []combination_pointers1;
		//delete []combination_pointers2;

	}  // end of else, (A), no substitute, normal method, combination   















	// (5), delete link ?  remind me, why do not use rulelink for CHECK part?

	
	_cp1 = _linkhead;
	_cp2 = _cp1;

	while (_cp1 != NULL ) {

		_bp1 = _cp1->p_body;
		_bp2 = _bp1;

		while ( _bp1 != NULL ) {  // delete body nodes

			_bp1 = _bp1->p_body;
			delete _bp2;

			_bp2 = _bp1;
					
		}

		_cp1 = _cp1->p_cross;
		delete _cp2;              // delete cross node

		_cp2 = _cp1;

	} // end of while, delete link.

	rulelink[_head].p_cross = NULL;




	return;

////////

} // CNF_iffclass_by_clark_withsorting()



void build_rulelink2( )    // rulelink[] => rulelink2[]    
{

	struct CROSSNODE *_cp, *_cp1, *_cp2;
	struct BODYNODE  *_bp, *_bp1, *_bp2;

	int i;


	rulelink2 = ( struct LISTNODE * ) malloc ( (C_MAXATOM+1) * sizeof (struct LISTNODE ) );

	for(i=0; i<C_MAXATOM+1; i++) {

		rulelink2[i].data = rulelink[i].data;
		rulelink2[i].p_cross = rulelink[i].p_cross;		

		_cp = rulelink[i].p_cross;
		_cp2 = NULL;
		while ( _cp != NULL ) {
			
			_cp1 = new CROSSNODE;
			_cp1->data = _cp->data;
			_cp1->p_body = NULL;
			_cp1->p_cross = NULL;		
			
			_cp->p_cross2 = _cp1;	_cp1->p_cross2 = _cp;			// build rule to rule 1-1 mapping


			if ( _cp2 == NULL ) { rulelink2[i].p_cross = _cp1; }	// the 1st cross-node
			else { _cp2->p_cross = _cp1; }


			_bp2 = NULL;
			_bp = _cp->p_body;
			while ( _bp != NULL ) {

				_bp1 = new BODYNODE;
				_bp1->data = _bp->data;
				_bp1->p_body = NULL;

				if (_bp2 == NULL ) {	_cp1->p_body = _bp1;	}	// the 1st body-node
				else {	_bp2->p_body = _bp1;		}

				_bp2 = _bp1;

				_bp = _bp->p_body;

			}// while, _bp

			_cp2 = _cp1;

			_cp = _cp->p_cross;

		}// while, _cp

	}// for


//	if ( PARA_DebugMode > 1 ) { savefile_rulelink2("00rulelink2"); }



}// build_rulelink2()




void build_TSrule( )    // CNF, rulelink[] => TSrule[]    
{                          // Both " CCALC, literal completion " and " Clark's completion "

	FILE *fp_rule;
	char rulefile[20]="00TSrule";	
	
	int i, j;
	int _no_rulelist;

	int _position;
//	int _n_fact, _n_false;




	

	// TS_rule includes ALL rules after TS reduction

	n_TSrule = main_rule;


 
	
	// (1), generate the array of TS_rule[]

	TS_rule = (int * ) malloc( (n_TSrule*len_rule) * sizeof(int) ) ;      
	if (TS_rule==NULL) { printf("\n No enough memory,Halt! d1\n"); error =1; }
	for ( i=0; i<=(n_TSrule*len_rule); i++) {  TS_rule[i] = 0; }   

	_no_rulelist = 0;  








	// (3), fill in TS_rule[], in order.

	if ( PARA_Reduce == 0 ) {											// NON- TS-reduction Mode

		for ( i=1; i< main_atom+1; i++ ) {


			// (3.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;

			}  // end of if, (3.1) Fact



			// (3.2) False, In NON-reduce mode, it is necessary for CNF

			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom

				/*	// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;  */

			}  // end of if, (3.2) False 
			


			
			
			// (3.3) Normal rules and constraints

			if (  rulelink[i].data > 0 ) {
			
			
				// (a), TS_rule[]. Normal rules and constraints.

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while


			}// end of if, (3.3) Normal and constraint


		} // end of for, one loop finished

 

	} // end of if, (3), NON-reduce mode




	// (4), reduce mode

	else if ( PARA_Reduce == 1 ) {      // reduce-mode 1
		
		for ( i=1; i< main_atom+1; i++ ) {

			//if(i==6840){
			//	i=i;
			//}

			// (4.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;


			}  // end of if, (4.1) Fact



			// (4.2) False, In reduce-mode, not be included in CNF nor TS_rule[]

			
			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom

																		  /*
			// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;*/


			}  // end of if, (4.2) False 
			


			
			
			// (4.3) Normal

			if ( rulelink[i].data > 0 )  {
			
			
				// (a), TS_rule[].

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while




			}// end of if, (4.3) Normal 


		} // end of for, one loop finished


	}  // end of else, (4), reduce-mode





	// (5), save to rule file, optional!

	if ( PARA_DebugMode > 0 ) {
		
		if (!(fp_rule=fopen(rulefile,"w"))) {     // Open rule file with "W" mode. 
			printf("Can not open %s\n", rulefile);
			error =1;
		}

		fprintf(fp_rule, "\nNo. <> Length of body <>   head <:-> body1 body2 ... 0\n\n");

		for(i=0;i<n_TSrule;i++) {             

			_position = i*len_rule;

			fprintf(fp_rule, "No.%d  <> ",i);

			j=0;
			while( TS_rule[_position + j] != 0 ) {

				if ( j== 1 ) {  fprintf(fp_rule, " <> "); }
				if ( j== 2 ) {  fprintf(fp_rule, "    <:-> " );  }

				fprintf(fp_rule, "%d ",TS_rule[_position + j]);
				j++;
			}
			
			fprintf(fp_rule," 0\n");

		}
		
		fclose(fp_rule); 

	}   // end of if, (5)



 


} // end of build_TSrule()





void CNF_iff_Combination(int _head, int _n_iff, struct CROSSNODE *_linkhead)
{	// CNF of a iff-class, by normal method, Combination   

	
	struct CROSSNODE *_cp1 ;
	struct BODYNODE  *_bp1 ;
	//struct BODYNODE  **combination_pointers1, **combination_pointers2;

//	int _n_iff;

//	int _n_add_atom=0;
//	int _add_atom;    //_add_atom = no_atom + _n_add_atom;

//	int _pi_times;

	int i, j, k, _stop;



																		// (A)   " IF_semantics "	
	
	if ( CS_atom[_head] == 1 ) {			// (a), Constraint falSe, " IF_semantics " is enough

		_cp1 = _linkhead;		
		while ( (_cp1 != NULL ) && ( _n_iff != 0 ) ) {  

			_bp1 = _cp1->p_body;
			while ( _bp1 != NULL ) {
				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  				
				_bp1 = _bp1->p_body;
			}

			fprintf(fp_cnf, "0\n" );
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, 

	} // if, (a), Constraint falSe

	else if ( CT_atom[_head] == 1 ) { }		// (b), Constraint facT, " IF_semantics " is skipped!

	else if (  _head > 0 )  {				// (c), normal rule

		_cp1 = _linkhead;		
		while ( (_cp1 != NULL ) && ( _n_iff != 0 ) ) {  

			_bp1 = _cp1->p_body;
			while ( _bp1 != NULL ) {
				fprintf(fp_cnf, "%d ", (-1)* _bp1->data );  				
				_bp1 = _bp1->p_body;
			}

			fprintf(fp_cnf, "%d 0\n", _head );
			cnf_clause++;

			_cp1 = _cp1->p_cross;

		} // end of while, 

	} // if, (c), normal rule.							// (A)," IF_semantics " of this iff-class



	
	
																		// (B), ONLYIF - semantics

	if ( ( CS_atom[_head] != 1 ) && ( _n_iff != 0 ) ) {	// Constraint falSe do NOT need, " ONLYIF_semantics "

		//combination_pointers1 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }
		//combination_pointers2 = (struct BODYNODE ** ) malloc( _n_iff * sizeof( struct BODYNODE ) ) ;      
		//if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		if ( _n_iff > len_combination_pointer ) {
			//printf("_n_iff:%d",_n_iff); 

			free ( combination_pointers1 );
			free ( combination_pointers2 );
			
			len_combination_pointer = _n_iff+2;

			combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }

		}


		i=0;

		_cp1 = _linkhead;
		while ( _cp1 != NULL ) {

			combination_pointers1[i] = _cp1->p_body;   
			combination_pointers2[i] = _cp1->p_body;   

			i++;

			_cp1 = _cp1->p_cross;
		}



		_stop=0;
		while ( _stop == 0 ) {
			
			if ( CT_atom[_head] == 0 ) {  // Constraint facT, do NOT need this one
				fprintf(fp_cnf,"%d ", (-1) * _head);
			}

			for (i=0; i < _n_iff; i++) {
				fprintf(fp_cnf, "%d ", combination_pointers1[i]->data);
			}

			fprintf(fp_cnf, "0\n");
			cnf_clause++;


			j=0;
			while ( (j<_n_iff) && ( combination_pointers1[j]->p_body == NULL ) ) {
				j++;
			}

			if ( j == _n_iff ) {  _stop = 1;	}
			else {
				combination_pointers1[j] = combination_pointers1[j]->p_body;

				for( k=0; k<j; k++) {
					combination_pointers1[k] = combination_pointers2[k];
				}
			}


		}  // end of while


		//delete []combination_pointers1;
		//delete []combination_pointers2;

	}// if, ONLYIF-


} // CNF_iff_Combination()







void CNF( )					// reduce mode and NON-reduce mode  
{							// Both " CCALC, literal completion " and " Clark's completion "

	
	int i;//, j;
//	int _n_fact, _n_false;





	if ( PARA_Reduce == 1 ) {												// reduce mode
		
							// FACTS:	// Constraint facT, Constraint falSe, pure fact, pure false
		for ( i=1; i< main_atom+1; i++ ) {	


			if ( CT_atom[i] == 1 ) {					// (a), facT
				fprintf(fp_cnf, "%d 0\n", i);								// CNF
				cnf_clause++;

				//CNF_iff_Combination(i, rulelink[i].data, rulelink[i].p_cross);

			}// if, (a), facT


			else if ( CS_atom[i] == 1 ) {				// (b), falSe
				fprintf(fp_cnf, "%d 0\n", (-1)*i);							// CNF
				cnf_clause++;

				//CNF_iff_Combination(i, rulelink[i].data, rulelink[i].p_cross);

			}// if, (b), falSe

														
			else if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {	// (c), pure fact
				fprintf(fp_cnf, "%d 0\n", i);				// CNF
				cnf_clause++;

			}  // if, (c), pure fact

		
			else if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {		// (d), pure false
																	  
				fprintf(fp_cnf, "%d 0\n", (-1)*i);         // CNF
				cnf_clause++;

			}  // if, (d), pure false
			
		} // for 

		
		for ( i=1; i< main_atom+1; i++ ) {					// (e), constraint formulars
			
			if ( ( CT_atom[i] == 1 ) || ( CS_atom[i] == 1 ) ) {		
				CNF_iff_Combination(i, rulelink[i].data, rulelink[i].p_cross);
			}

		}// for, (e), constraint formulars


		for ( i=1; i< main_atom+1; i++ ) {					// (f), normal rules

			if ( ( rulelink[i].data > 0 ) && ( CT_atom[i] != 1 ) && ( CS_atom[i] != 1 ) ) {							
			
				if (PARA_CompletionMode == 0 ) {	CNF_iffclass_by_ccalc(i);	}
				else if (PARA_CompletionMode == 1) {	CNF_iffclass_by_clark(i);	}
				else if (PARA_CompletionMode == 2) {	CNF_iffclass_by_clark_withsorting(i);	}

			}// if, data > 0

		} // for, (f), normal rules


	}  // if,																	// reduce-mode




	else if ( PARA_Reduce == 0 ) {												// NON- reduce Mode
	

		if ( code_of_fail > 0 ) {						// (a) fail 

			i = code_of_fail;
			fprintf(fp_cnf, "%d 0\n", (-1)*i );							//CNF
			cnf_clause++;
		}


		for ( i=1; i< main_atom+1; i++ ) {				// (b) pure fact and pure false

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {	// pure fact

				fprintf(fp_cnf, "%d 0\n", i);								// CNF
				cnf_clause++;

			}  // if, Fact


			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {		// pure flase

				/*	// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;  */

				fprintf(fp_cnf, "%d 0\n", (-1)*i);							// CNF
				cnf_clause++;

			}  // if, False 

		}// for, (b)


		if ( code_of_fail > 0 ) {						// (c), constraint formulas from fail

			if (  rulelink[code_of_fail].data != 0  ) {	// constraints
				
				//printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

				c_pointer1 = rulelink[code_of_fail].p_cross;
				while ( c_pointer1 != NULL ) {


					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						fprintf(fp_cnf, "%d ", (-1)*b_pointer1->data );
						
						b_pointer1 = b_pointer1->p_body;
					}

					fprintf(fp_cnf, "0\n");								//CNF
					cnf_clause++;

					c_pointer1 = c_pointer1->p_cross;

				} // while
		
			}// if, constraints

		} // if (c), constraint formulas from fail
		
			
			
		for ( i=1; i< main_atom+1; i++ ) {				// (d) Normal rules 

			if ( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {	

				if (PARA_CompletionMode == 0 ) {	CNF_iffclass_by_ccalc(i);	}
				else if (PARA_CompletionMode == 1) {	CNF_iffclass_by_clark(i);	}
				else if (PARA_CompletionMode == 2) {	CNF_iffclass_by_clark_withsorting(i); } 

			}// if, 

		} // for, (d), Normal rules 

 

	} // else if, ( PARA_Reduce == 0 )												NON- reduce Mode



} // end of CNF()






















void seperate_rulelink( )  // CNF, rulelink[] => TSrule[]    
{                          // Both " CCALC, literal completion " and " Clark's completion "

	FILE *fp_rule;
	char rulefile[20]="00TSrule";	
	
	int i, j;
	int _no_rulelist;

	int _position;
//	int _n_fact, _n_false;






	// (0), decide the total number of TSrule, that is also the length of it

	// ALL rules!!!!

	n_TSrule = main_rule;

	/*
	n_TSrule=0;

	for( i=1; i<main_atom+1; i++) { // collect normal rules and facts

		if( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {	// normal
			n_TSrule = n_TSrule + rulelink[i].data;  
			//printf(" #%d", n_TSrule);
		}

		if( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {	// fact
			n_TSrule++;  
			//printf(" #%d", n_TSrule);
		}

	} // for
	
	if (PARA_DebugMode >0 ) {
		printf("\n                               n_TSrule = %d", n_TSrule);
	}
	*/


 
	
	// (1), generate the array of TS_rule[]

	TS_rule = (int * ) malloc( (n_TSrule*len_rule) * sizeof(int) ) ;      
	if (TS_rule==NULL) { printf("\n No enough memory,Halt! d1\n"); error =1; }
	for ( i=0; i<=(n_TSrule*len_rule); i++) {  TS_rule[i] = 0; }   

	_no_rulelist = 0;  




	// (2), constraints to CNF

	if ( code_of_fail > 0 ) {
		i = code_of_fail;
		fprintf(fp_cnf, "%d 0\n", (-1)*i );
		cnf_clause++;
	}

	if (  rulelink[i].data != 0  ) {
		
		printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

		c_pointer1 = rulelink[i].p_cross;
		while ( c_pointer1 != NULL ) {


			b_pointer1 = c_pointer1->p_body;
			while (b_pointer1 != NULL ) {

				fprintf(fp_cnf, "%d ", (-1)*b_pointer1->data );
				
				b_pointer1 = b_pointer1->p_body;
			}

			fprintf(fp_cnf, "0\n");
			cnf_clause++;

			c_pointer1 = c_pointer1->p_cross;

		} //end of while

	}// end of if, (2) constraint




	// (3), fill in CNF & TS_rule[], in order.

	if ( PARA_Reduce == 0 ) {             // NON- reduce

		for ( i=1; i< main_atom+1; i++ ) {


			// (3.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;


				// (b), CNF
				fprintf(fp_cnf, "%d 0\n", i);          // CNF
				cnf_clause++;

			}  // end of if, (3.1) Fact



			// (3.2) False, In NON-reduce mode, it is necessary for CNF

			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom

				/*	// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;  */

				// (b), CNF  
				fprintf(fp_cnf, "%d 0\n", (-1)*i);         // CNF
				cnf_clause++;

			}  // end of if, (3.2) False 
			


			
			
			// (3.3) Normal rules and constraints

			if (  rulelink[i].data > 0 ) {
			
			
				// (a), TS_rule[]. Normal rules and constraints.

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while


				// (b), to CNF, // only for normal rules

				if  ( i != code_of_fail ) {  // only for normal rules

					if (PARA_CompletionMode == 0 ) {
						CNF_iffclass_by_ccalc(i);
					}
					else if (PARA_CompletionMode == 1) {
						CNF_iffclass_by_clark(i);
					}
					else if (PARA_CompletionMode == 2) {
						CNF_iffclass_by_clark_withsorting(i);
					}
				} // only normal


			}// end of if, (3.3) Normal and constraint


		} // end of for, one loop finished

 

	} // end of if, (3), NON-reduce mode




	// (4), reduce mode

	else if ( PARA_Reduce == 1 ) {      // reduce-mode 1
		
		for ( i=1; i< main_atom+1; i++ ) {

			//if(i==6840){
			//	i=i;
			//}

			// (4.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;


				// (b), CNF
				fprintf(fp_cnf, "%d 0\n", i);          // CNF
				cnf_clause++;

			}  // end of if, (4.1) Fact



			// (4.2) False, In reduce-mode, not be included in CNF nor TS_rule[]

			
			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom

																		  /*
			// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;*/

				// (b), CNF  
				fprintf(fp_cnf, "%d 0\n", (-1)*i);         // CNF
				cnf_clause++;

			}  // end of if, (4.2) False 
			


			
			
			// (4.3) Normal

			if ( rulelink[i].data > 0 )  {
			
			
				// (a), TS_rule[].

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while


				// (b), to CNF

				if ( i != code_of_fail )  {
					if (PARA_CompletionMode == 0 ) {
						CNF_iffclass_by_ccalc(i);
					}
					else if (PARA_CompletionMode == 1) {
						CNF_iffclass_by_clark(i);
					}
					else if (PARA_CompletionMode == 2) {
						CNF_iffclass_by_clark_withsorting(i);
					}
				}

			}// end of if, (4.3) Normal 


		} // end of for, one loop finished


	}  // end of else, (4), reduce-mode




 















	// (5), save to rule file, optional!

	if ( PARA_DebugMode > 0 ) {
		
		if (!(fp_rule=fopen(rulefile,"w"))) {     // Open rule file with "W" mode. 
			printf("Can not open %s\n", rulefile);
			error =1;
		}

		fprintf(fp_rule, "\nNo. <> Length of body <>   head <:-> body1 body2 ... 0\n\n");

		for(i=0;i<n_TSrule;i++) {             

			_position = i*len_rule;

			fprintf(fp_rule, "No.%d  <> ",i);

			j=0;
			while( TS_rule[_position + j] != 0 ) {

				if ( j== 1 ) {  fprintf(fp_rule, " <> "); }
				if ( j== 2 ) {  fprintf(fp_rule, "    <:-> " );  }

				fprintf(fp_rule, "%d ",TS_rule[_position + j]);
				j++;
			}
			
			fprintf(fp_rule," 0\n");

		}
		
		fclose(fp_rule); 

	}   // end of if, (5)



 


} // end of seperate_rulelink()






void seperate_rulelink_clark( )  // CNF, rulelink[] => TSrule[]    Pure clark's completion
{

	FILE *fp_rule;
	char rulefile[20]="00TSrule";	
	
	int i, j;
	int _no_rulelist;

	int _position;
//	int _n_fact, _n_false;







	// (0), constraints to CNF

	if ( code_of_fail > 0 ) {
		i = code_of_fail;
		fprintf(fp_cnf, "%d 0\n", (-1)*i );
		cnf_clause++;
	}

	if (  rulelink[i].data != 0  ) {
		
		//printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

		c_pointer1 = rulelink[i].p_cross;
		while ( c_pointer1 != NULL ) {


			b_pointer1 = c_pointer1->p_body;
			while (b_pointer1 != NULL ) {

				fprintf(fp_cnf, "%d ", (-1)*b_pointer1->data );
				
				b_pointer1 = b_pointer1->p_body;
			}

			fprintf(fp_cnf, "0\n");
			cnf_clause++;

			c_pointer1 = c_pointer1->p_cross;

		} //end of while

	}// end of if, (0) constraint








	// (1), decide the total number of TSrule, that is also the length of it

	n_TSrule=0;

	
	if ( PARA_Reduce == 1 ) {    // Reduce-mode: Only calculate normal rules
		
		for( i=1; i<main_atom+1; i++) {

			if( ( rulelink[i].data >0 ) && ( i != code_of_fail ) ) {	
				n_TSrule = n_TSrule + rulelink[i].data;  
			}
		} // for
	}
	
	else  {                     // NON-Reduce mode: including normal rules + facts
		
		for( i=1; i<main_atom+1; i++) {

			if( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {	// normal
				n_TSrule = n_TSrule + rulelink[i].data;  
			}

			if( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {	// fact
				n_TSrule++;  
			}

		} // for
	}
	


	if (PARA_DebugMode >0 ) {
		printf("\n n_TSrule = %d, \n");
	}





	
	// (2), generate the array of TS_rule[]

	TS_rule = (int * ) malloc( (n_TSrule*len_rule) * sizeof(int) ) ;      
	if (TS_rule==NULL) { printf("\nHalt! out of memory: TS_r\n"); error =1; }
	for ( i=0; i<=(n_TSrule*len_rule); i++) {  TS_rule[i] = 0; }   

	_no_rulelist = 0;  








	// (3), fill in CNF & TS_rule[], in order.

	if ( PARA_Reduce == 0 ) {         

		for ( i=1; i< main_atom+1; i++ ) {


			// (3.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;


				// (b), CNF
				fprintf(fp_cnf, "%d 0\n", i);          // CNF
				cnf_clause++;

			}  // end of if, (3.1) Fact



			// (3.2) False

			/* FALSE, not be included in CNF nor TS_rule[]

			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom


			// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;

				// (b), CNF  
				fprintf(fp_cnf, "%d 0\n", (-1)*i);         // CNF
				cnf_clause++;

			}  // end of if, (3.2) False 
			*/


			
			
			// (3.3) Normal

			if ( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {
			
			
				// (a), TS_rule[].

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while


				// (b), to CNF

				if (PARA_CompletionMode == 0 ) {
					CNF_iffclass_by_ccalc(i);
				}
				else if (PARA_CompletionMode == 1) {
					CNF_iffclass_by_clark(i);
				}
				else if (PARA_CompletionMode == 2) {
					CNF_iffclass_by_clark_withsorting(i);
				}


			}// end of if, (3.3) Normal 


		} // end of for, one loop finished



	} // end of if, (3), NON-reduce mode




	// (4), reduce mode

	else {      // reduce-mode
		
		for ( i=1; i< main_atom+1; i++ ) {


			// (4.1) FACT

			if ( ( rulelink[i].data == -1 ) && ( i != code_of_fail ) ) {  // FACT-atoms


				// (a), TS_rule[]
				TS_rule[ _no_rulelist  ] = -1;          // RULE: set marker as -1
				TS_rule[ _no_rulelist +1 ] = i;         // RULE: then the code followed 

				_no_rulelist = _no_rulelist + len_rule;


				// (b), CNF
				fprintf(fp_cnf, "%d 0\n", i);          // CNF
				cnf_clause++;

			}  // end of if, (4.1) Fact



			// (4.2) False

			/* FALSE, not be included in CNF nor TS_rule[]

			if ( ( rulelink[i].data == 0 ) && ( i != code_of_fail ) ) {   // False-atom


			// Now we do not fill the false-atoms into the rules    July 6, 2001

				// (a), TS_rule[]
				TS_rule[ _no_rulelist * len_rule ] = -1;    // RULE: set marker as -1
				TS_rule[ _no_rulelist * len_rule +1 ] = i;  // RULE: then the code

				_no_rulelist = _no_rulelist + len_rule;

				// (b), CNF  
				fprintf(fp_cnf, "%d 0\n", (-1)*i);         // CNF
				cnf_clause++;

			}  // end of if, (4.2) False 
			*/


			
			
			// (4.3) Normal

			if ( ( rulelink[i].data > 0 ) && ( i != code_of_fail ) ) {
			
			
				// (a), TS_rule[].

				c_pointer1 = rulelink[i].p_cross;
				while ( c_pointer1 != NULL ) {

					//printf("    %d: ", c_pointer1->data);

					TS_rule[ _no_rulelist ] = c_pointer1->data;
					TS_rule[ _no_rulelist + 1 ] = i;

					j=2;

					b_pointer1 = c_pointer1->p_body;
					while (b_pointer1 != NULL ) {

						//printf("%d ", b_pointer1->data);
						
						TS_rule[ _no_rulelist + j ] = b_pointer1->data;
						j++;

						b_pointer1 = b_pointer1->p_body;
					}
					//printf("\n");
					_no_rulelist = _no_rulelist + len_rule;

					c_pointer1 = c_pointer1->p_cross;

				}//end of while


				// (b), to CNF

				if (PARA_CompletionMode == 0 ) {
					CNF_iffclass_by_ccalc(i);
				}
				else if (PARA_CompletionMode == 1) {
					CNF_iffclass_by_clark(i);
				}
				else if (PARA_CompletionMode == 2) {
					CNF_iffclass_by_clark_withsorting(i);
				}


			}// end of if, (4.3) Normal 


		} // end of for, one loop finished


	}  // end of else, reduce-mode












	//fclose(fp_cnf);   // close the CNF file








	// (4), save to rule file, optional!

	if ( PARA_DebugMode > 0 ) {
		
		if (!(fp_rule=fopen(rulefile,"w"))) {     // Open rule file with "W" mode. 
			printf("Can not open %s\n", rulefile);
			error =1;
		}

		fprintf(fp_rule, "\nNo. <> Length of body <>   head <:-> body1 body2 ... 0\n\n");

		for(i=0;i<n_TSrule;i++) {             

			_position = i*len_rule;

			fprintf(fp_rule, "No.%d  <> ",i);

			j=0;
			while( TS_rule[_position + j] != 0 ) {

				if ( j== 1 ) {  fprintf(fp_rule, " <> "); }
				if ( j== 2 ) {  fprintf(fp_rule, "    <:-> " );  }

				fprintf(fp_rule, "%d ",TS_rule[_position + j]);
				j++;
			}
			
			fprintf(fp_rule," 0\n");

		}
		
		fclose(fp_rule); 

	}






} // end of seperate_rulelink_clark()










// INPUT: chaff.log / 00satmodel / cherry.smj
// OUTPUT: 00model                     
int read_SAT_chaff2(char str_mdi[C_LEN_FILENAME])
{
// Chaff2 .cnf > .satout						
// return(_no_model)
//			_no_model = -1 :   Killed 
//          _no_model = 0  :   unsatisfiable
//          _no_model > 0  :   success, n is the number of models. 

// if _no_model > 0,  All models are saved in a list, model[]. seperated by "0";
//			  models are also saved into file.





	FILE *fp_satout, *fp_log;//, *fp_mdi;
	
	
	char logfile[C_LEN_FILENAME]="chaff.log";			// Read the log file  
	char cherryfile[C_LEN_FILENAME]="cherry.smj";		// Read the config file  
	char satfile[C_LEN_FILENAME]="00satmodel";			// Read the multi-models file  
	
	//char modelfile[C_LEN_FILENAME];			// output regular model to file 



	char _item[100];
	char _c;
	char _str[C_LEN_ATOM];


	int i, j, k, t;
//	int i_temp;  
	float f_temp;

	int _no_model;


	_no_model = 1;            // defautly, we believe there is 1 model


	// (a), generate model[]
//	model_from_sat = (int *) malloc( (main_atom+1) * sizeof (int) );          
//	if(model_from_sat == NULL) { printf("\nHalt! out of memory: model\n"); error =1; }
//	for ( i=0; i< main_atom+1; i++ ) { model_from_sat[i] = 0; }




	// (a), satout
	if (!(fp_satout=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s\n", satoutputfile);
		error =1;
	}
		
	_no_model = -1;
	while ( fscanf(fp_satout,"%s",&_item)!=EOF ) {

		if ( strcmp( _item, "Satisfyable" ) == 0 ) {	_no_model = 1;	}
		else if ( strcmp( _item,"Unsatisfiable" ) == 0 ) {	_no_model = 0;	}
		else if ( strcmp( _item, "TotalUserTime:" ) == 0 ) {
			fscanf(fp_satout,"%f",&f_temp);	
		}
	}

	if ( _no_model == -1 ) {	

		printf("                 Killed! \n");							
		return(-1);	
	}
	else if ( _no_model == 0 ) {	

		printf("                 Chaff2: User CPU time: %f (seconds)",f_temp);						

		totaltime_sat = totaltime_sat + f_temp;

		return(0);	
	}

	fclose(fp_satout);
	



	// (b), read model
	if (!(fp_log=fopen(logfile,"r"))) { 
		printf("Can not open %s\n", logfile);
		error =1;
	}
	
	int _n_line=0;
	while ( fscanf(fp_log,"%c",&_c)!=EOF ) {

		if ( _c== 10 ) {
			_n_line++;
		}
	}

	rewind(fp_log);

	i=0;
	while (  i< _n_line-1  ) {		// skip previous lines

		fscanf(fp_log,"%c",&_c);
		
		if ( _c== 10 ) {
			i++;
		}
	}// while , skip

	// "[11111101110000000000]" "t7" "0.01" 21 0
	// unsat  "t10" "0.23" 10267 2051

	if ( i== _n_line-1 ) { // last line

		fscanf(fp_log,"%c",&_c);

		if ( _c == 'u' ) {		//unsatisfiable
			_no_model = 0;
		}
		else {					// read model			// "
			fscanf(fp_log,"%c",&_c);		// [

			if ( _c == '[' ) {

				j=0;
				while ( ( fscanf(fp_log,"%c",&_c)!=EOF ) && ( _c != '"' ) && (j< main_atom)  ) {

					if ( ( _c >= 48 ) && ( _c <= 57 ) ) {
						j++;
						model_from_sat[j] = _c - 48;
					}
				} // while
			}// if

		}// else, read model

		//for ( j=1; j< main_atom+1; j++ ) {
		//	fscanf(fp_log,"%c",&_c);
		//	
		//		model_from_sat[j] = _c - 48;
		//	}
		//

		while ( ( fscanf(fp_log,"%c",&_c)!=EOF ) && ( _c != ' ') ) { }//skip temporary variables
		
		fscanf(fp_log,"%s %c%f\n",&_item,&_c,&f_temp);	// "t7" "0.01

		/*
		fscanf(fp_log,"%s",&_item);		// ]"
		fscanf(fp_log,"%s\n",&_item);	// "t7"
		fscanf(fp_log,"%c",&_c);		// "
		fscanf(fp_log,"%f\n",&f_temp);	// 0.01
		*/
			
		printf("\n                    Chaff2: User CPU time: %f (seconds)",f_temp);						

		totaltime_sat = totaltime_sat + f_temp;

		
	}// if , last line
	



	// (c), write model to file, optional

	if ( PARA_ResultFile == 1 ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}
		
		// close
//		fclose(fp_mdi);



		if ( PARA_TextOutput == 1 ) {	// txt format

//			if (!(fp_mdi=fopen(str_mdi,"a"))) { 
//				printf("Can not open %s\n", str_mdi);
//				error =1;
//			}


			// write
			for ( i = 0; i < _no_model; i++ )  {
				
				for( j =1; j<= main_atom; j++ ) {
					
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						//fprintf(fp_mdi, "%d ", j );  

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);

					}
				}
				
				fprintf(fp_mdi, "0\n\n");
			}
		
			// close
//			fclose(fp_mdi);

		}





	}  // end of if, (c), write models to file

	fclose(fp_log);

	
	
	return( _no_model );


	/*printf("\n Changing to regular models...               End. \n\n");*/

} // END of read_SAT_chaff2()





// INPUT: 00satout
// OUTPUT: 00model                     
int read_SAT_grasp(char str_mdi[C_LEN_FILENAME])
{
// grasp +s1 +O .cnf > .satout						
// return(n)
//			n = -1 :   unsatisfiable
//          n = 0  :   failed, for some reason I can not read      
//          n > 0  :   success, n is the number of models. 

// if n > 0,  All models are saved in a list, model[]. seperated by "0";
//			  models are also saved into file.





	FILE *fp_sat;//, *fp_mdi;
	
	//char satfile[C_LEN_FILENAME];			// Read the SAT file  

	//char modelfile[C_LEN_FILENAME]="00model";         // output regular model to file 



	char _item[100];


	int i, j;
	int i_temp;  
	float f_temp;

	int _no_model;

	

	_no_model = 0;            // defautly, we believe there is 1 model

//	// (a), generate model[]
//
//
//	model_from_sat = (int *) malloc( (main_atom+1) * sizeof (int) );          
//	if(model_from_sat == NULL) { printf("\nHalt! out of memory: model\n"); error =1; }
//	for ( i=0; i< main_atom+1; i++ ) { model_from_sat[i] = 0; }



    // (b), read
	

    if (!(fp_sat=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s\n", satoutputfile);
		error =1;
	}
	
	//printf("grasp 1\n");
	while ( (fscanf(fp_sat,"%s\n",&_item)!=EOF) && (strcmp(_item, "Terminating")!=0 ) ) {

		//printf("grasp 2\n");
		if (strcmp(_item, "Formula:")==0) { 
			
			_no_model++;

			if ( _no_model > 1 ) {		// realloc memory
				model_from_sat = (int *) realloc ( model_from_sat, _no_model * (main_atom+1) * sizeof (int));

				for ( i=(_no_model-1) * (main_atom+1); i< _no_model * (main_atom+1); i++ ) { 
					model_from_sat[i] = 0; 
				}
			}	// end of if, realloc memory


			//printf("grasp\n");
			while ( fscanf(fp_sat, "%d\n", &i_temp)  ) {
				 //printf("%d ",i_temp); 

				if ( (i_temp > 0 ) && (i_temp <= main_atom) ) {		
					                     //	exclude added atoms and negative literals
					model_from_sat[ (_no_model-1) * (main_atom+1) + i_temp ] = 1;
				} // if
				
			} // while			

		}  // End of if 

		if (strcmp(_item, "UNSATISFIABLE") == 0 ) {
			//_no_model=0;
		}


	}  // End of while 



	if (strcmp(_item, "Terminating")==0) {     // run-time
	
		fscanf(fp_sat,"%s\n",&_item);
		fscanf(fp_sat,"%s\n",&_item);
		fscanf(fp_sat,"%s\n",&_item);
		//fscanf(fp_sat,"%s\n",&_item);

		//strcpy(time_of_sat,_item);
		//printf("                  User CPU time: %s (seconds)",time_of_sat);						

		fscanf(fp_sat,"%f\n",&f_temp);
		
		printf("\n                    Grasp: User CPU time: %f (seconds)",f_temp);						

		totaltime_sat = totaltime_sat + f_temp;


	}  // End of if 



	// (b), check "unsatisfiable." ?
	//if ( strcmp(_item, "unsatisfiable.") == 0 ) {

	//if ( strcmp(_item, "UNSATISFIABLE") == 0 ) {

	//	fclose(fp_sat);
	//	return (-1);
	//}






	// (c), write model to file, optional

	if ( PARA_ResultFile == 1 ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
//					fprintf(fp_txt, "%s ", atomlist[ atommap[j] ]
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}


		
		if ( PARA_TextOutput == 1 ) {	// txt format

			int t;
			char _str[C_LEN_ATOM];
			
			for ( i = 0; i < _no_model; i++ )  {			
				for( j =1; j<= main_atom; j++ ) {				
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);
					}
				}				
				fprintf(fp_mdi, "0\n\n");
			} // for
		} // if


		// close
//		fclose(fp_mdi);

	}  // end of if, (c), write models to file

	fclose(fp_sat);



	if( _no_model == 0 ) {
		return(0);
	}
	else {
		return( _no_model-1 );  // in grasp, it repeats the last model once.
	}


	/*printf("\n Changing to regular models...               End. \n\n");*/

} // END of read_SAT_grasp()




// INPUT: 00satout
// OUTPUT: 00model                     
int read_SAT_sato(char str_mdi[C_LEN_FILENAME])
{
// sato -m2 -g1 -s2 -f .cnf > .satout						
// return(n)
//			n = -1 :   unsatisfiable
//          n = 0  :   failed, for some reason I can not read      
//          n > 0  :   success, n is the number of models. 

// if n > 0,  All models are saved in a list, model[]. seperated by "0";
//			  models are also saved into file.





	FILE *fp_sat;//, *fp_mdi;
	
	//char satfile[C_LEN_FILENAME];			// Read the SAT file  

	//char modelfile[C_LEN_FILENAME]="00model";         // output regular model to file 



	char _item[100];


	int i, j;
	int i_temp;  
	float f_temp;

	int _no_model;


	_no_model = 0;            // defautly, we believe there is 1 model


	// (a), generate model[]
//	model_from_sat = (int *) malloc( (main_atom+1) * sizeof (int) );          
//	if(model_from_sat == NULL) { printf("\nHalt! out of memory: model\n"); error =1; }
//	for ( i=0; i< main_atom+1; i++ ) { model_from_sat[i] = 0; }



    // (b), read
	

    if (!(fp_sat=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s\n", satoutputfile);
		error =1;
	}
	
	while ( (fscanf(fp_sat,"%s\n",&_item)!=EOF) && (strcmp(_item, "(seconds)")!=0 ) ) {


		//(a) model
		if (strcmp(_item, "atoms)")==0) {   // models
			
			_no_model++;

			if ( _no_model > 1 ) {		// realloc memory
				model_from_sat = (int *) realloc ( model_from_sat, _no_model * (main_atom+1) * sizeof (int));

				for ( i=(_no_model-1) * (main_atom+1); i< _no_model * (main_atom+1); i++ ) { 
					model_from_sat[i] = 0; 
				}
			}	// end of if, realloc memory


			// printf("\n");
			while ( fscanf(fp_sat, "%d\n", &i_temp)  ) {
				// printf("%d ",i_temp); 

				if (i_temp <= main_atom) {		//	exclude added atoms
					model_from_sat[ (_no_model-1) * (main_atom+1) + i_temp ] = 1;
				} // if
				
			} // while			

		}  // End of if (a)

		//(b) unsatisfiable?
		else if ( strcmp(_item, "unsatisfiable.") == 0 ) {
			_no_model = 0;
		}// else if (b)


	}  // End of while 


	if (strcmp(_item, "(seconds)")==0) {     // run-time
	
		//fscanf(fp_sat,"%s\n",&_item);

		//strcpy(time_of_sat,_item);
		//printf("                  User CPU time: %s (seconds)",time_of_sat);						

		fscanf(fp_sat,"%f\n",&f_temp);

		//strcpy(time_of_sat,_item);
		printf("\n                    SATO: User CPU time: %f (seconds)",f_temp);						

		totaltime_sat = totaltime_sat + f_temp;

	
	}  // End of if 


	// (b), check "unsatisfiable." ?

	//if ( strcmp(_item, "unsatisfiable.") == 0 ) {
	//	fclose(fp_sat);
	//	return (-1);
	//}

	fclose(fp_sat);





	// (c), write model to file, optional

	if ( PARA_ResultFile == 1 ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}
		

		if ( PARA_TextOutput == 1 ) {	// txt format

			int t;
			char _str[C_LEN_ATOM];
			
			for ( i = 0; i < _no_model; i++ )  {			
				for( j =1; j<= main_atom; j++ ) {				
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);
					}
				}				
				fprintf(fp_mdi, "0\n\n");
			} // for
		} // if


		// close
//		fclose(fp_mdi);

	}  // end of if, (c), write models to file




	return( _no_model );


	/*printf("\n Changing to regular models...               End. \n\n");*/

} // END of read_SAT_sato()




int read_SAT_satz(char str_mdi[C_LEN_FILENAME])
// 'satz' save its model (if it has) to file 'satx.sol'. Currently it only gives 1 model
// 'satz 00cnf [-s] > 00satout'. To save 00satout is to check if it's unsatisfiable.
{

  FILE *fp_satout, *fp_satmodel;//, *fp_mdi;
  
  char satmodelfile[20]="satx.sol";         /* input sat modles file */ 
//  char satoutputfile[20];				  /*  Control Information */ 
//  char modelfile[20]="00model";        /* output regular model file */

  char _item[100];
  int i_temp;  
  float f_temp;
  int _no_model;
  int i, j;



	_no_model = 1;            // defautly, we believe there is 1 model


	// a.
    if (!(fp_satout=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s\n", satoutputfile);
		error =1;
	}
    

	while ( fscanf(fp_satout,"%s\n",&_item)!=EOF) {
		
		if (strcmp(_item, "unsatisfiable")==0 )  {
			_no_model= 0;
		}

		if (strcmp(_item, "terminated")==0 )  {
			fscanf(fp_satout,"%s\n",&_item);

			fscanf(fp_satout,"%f\n",&f_temp);
			
			printf("\n                    satz: User CPU time: %f (seconds)",f_temp);						

			totaltime_sat = totaltime_sat + f_temp;

		}


	}

	fclose(fp_satout);


	// b.
	if ( _no_model == 1 ) {
		
		if (!(fp_satmodel=fopen(satmodelfile,"r"))) { 
			printf("Can not open %s\n", satmodelfile);
			error =1;
		}

//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		
		
		while (fscanf(fp_satmodel,"%d\n",&i_temp)!=EOF)  {

			if ( ( i_temp>0 ) && (i_temp <= main_atom) )  { 
				//fprintf(fp_mdi,"%d ",i_temp); 
				model_from_sat[ i_temp] =1;
			}
		}  /* End fo while */

//		fprintf(fp_mdi,"0\n");
		//fclose(fp_satmodel);
//fclose(fp_mdi);

	}// if



	
	// (c), write model to file, optional

	if ( PARA_ResultFile == 1 ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}

		
		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}
		

		if ( PARA_TextOutput == 1 ) {	// txt format

			int t;
			char _str[C_LEN_ATOM];
			
			for ( i = 0; i < _no_model; i++ )  {			
				for( j =1; j<= main_atom; j++ ) {				
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);
					}
				}				
				fprintf(fp_mdi, "0\n\n");
			} // for
		} // if


		// close
//		fclose(fp_mdi);

	}  // end of if, (c), write models to file







	return( _no_model);

} // end of read_SAT_satz()




int read_SAT_satzrand(char str_mdi[C_LEN_FILENAME])
// ' sr 00cnf -out 00satmodel > 00satout '
// sr save its model (if it has) to file '00satmodel', otherwise it reports 'unsatisfiable' in 00satout.
// sr gives 1 model only.
{


  FILE *fp_satout, *fp_satmodel;//, *fp_mdi;
  
  //char satmodelfile[20]="00satmodel";         /* the file contains model */ 
  //char satoutputfile[20];						  /* report */ 
  //char modelfile[20]="00model";               /* save a regular model to file */

  char _item[100];
  int i_temp;  
  float f_temp;
  int _no_model;
  int i, j;

	_no_model = 1;            // defautly, we believe there is 1 model

	 
	// a.
    if (!(fp_satout=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s\n", satoutputfile);
		error =1;
	}
    

	while ( fscanf(fp_satout,"%s\n",&_item)!=EOF) {
		
		if (strcmp(_item, "unsatisfiable")==0 )  {
			_no_model= 0;
		}

		if (strcmp(_item, "terminated")==0 )  {
			fscanf(fp_satout,"%s\n",&_item);

			fscanf(fp_satout,"%f\n",&f_temp);
			
			printf("\n                    satz-rand: User CPU time: %f (seconds)",f_temp);						

			totaltime_sat = totaltime_sat + f_temp;

		}


	}

	fclose(fp_satout);


	// b.
	if ( _no_model == 1 ) {
		
		if (!(fp_satmodel=fopen(satmodelfile,"r"))) { 
			printf("Can not open %s\n", satmodelfile);
			error =1;
		}

//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		
		
		while (fscanf(fp_satmodel,"%d\n",&i_temp)!=EOF)  {

			if ( ( i_temp>0 ) && (i_temp <= main_atom) )  { 
				//fprintf(fp_mdi,"%d ",i_temp); 
				model_from_sat[ i_temp] =1;
			}
		}  /* End fo while */

		//fprintf(fp_mdi,"0\n");
		fclose(fp_satmodel);
//		fclose(fp_mdi);

	}// if


	// (c), write model to file, optional

	if ( PARA_ResultFile == 1 ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}
		

		if ( PARA_TextOutput == 1 ) {	// txt format

			int t;
			char _str[C_LEN_ATOM];
			
			for ( i = 0; i < _no_model; i++ )  {			
				for( j =1; j<= main_atom; j++ ) {				
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);
					}
				}				
				fprintf(fp_mdi, "0\n\n");
			} // for
		} // if


		// close
//		fclose(fp_mdi);

	}  // end of if, (c), write models to file





	return( _no_model);

} // end of read_SAT_satzrand()




int read_SAT_walksat(char str_mdi[C_LEN_FILENAME])
// 'walksat -out 00satmodel < 00cnf > 00satout'
// walksat save its model (if it has) to file '00satmodel', otherwise it reports 'unsatisfiable' in '00satout'.
// walksat gives 1 model only.
{



	FILE *fp_satout, *fp_satmodel;//, *fp_mdi;
  
  //char satmodelfile[20]="00satmodel";         /* the file contains model */ 
  //char satoutputfile[20]="00satout";             /* report */ 
  //char modelfile[20]="00model";               /* save a regular model to file */

  char _item[100];
  int i_temp;  
  float f_temp;
  int _no_model;
  int i, j;

	_no_model = 1;            // defautly, we believe there is 1 model

	// a.
    if (!(fp_satout=fopen(satoutputfile,"r"))) { 
		printf("Can not open %s (walksat)\n", satoutputfile);
		return(0);	// walksat failed, but it may turn to chaff
	}
    

	while ( fscanf(fp_satout,"%s\n",&_item)!=EOF) {
		
		// ASSIGNMENT NOT FOUND
		if ( (strcmp(_item, "NOT")==0 ) || (strcmp(_item, "ERROR")==0 ) )  {
			_no_model= 0;			
		}
 
		// total elapsed seconds = 13.240000
		if (strcmp(_item, "elapsed")==0 )  {
			fscanf(fp_satout,"%s\n",&_item);
			fscanf(fp_satout,"%s\n",&_item);

			fscanf(fp_satout,"%f\n",&f_temp);
			
			printf("\n                    walksat: User CPU time: %f (seconds)",f_temp);						

			totaltime_sat = totaltime_sat + f_temp;

		}


	}
		
	fclose(fp_satout);


	// b.
	if ( _no_model != 0 ) {
		
		if (!(fp_satmodel=fopen(satmodelfile,"r"))) { 
			printf("Can not open %s (walksat)\n", satmodelfile);
			return(0);	// walksat failed, but it may turn to chaff
		}

//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		
		
		while (fscanf(fp_satmodel,"%d\n",&i_temp)!=EOF)  {

			if ( ( i_temp>0 ) && (i_temp <= main_atom) )  { 
				//fprintf(fp_mdi,"%d ",i_temp); 
				model_from_sat[ i_temp] =1;
			}
		}  /* End fo while */

		//fprintf(fp_mdi,"0\n");
		fclose(fp_satmodel);
//		fclose(fp_mdi);


	}// if
	else {	// Unsatisfiable
			printf("\n                    walksat: Unsatisfiable");						

	}


	// (c), write model to file, optional

	if ( ( PARA_ResultFile == 1 ) && ( _no_model != 0 ) ) {

		// open with w
//		if (!(fp_mdi=fopen(str_mdi,"w"))) { 
//			printf("Can not open %s\n", str_mdi);
//			error =1;
//		}


		// write
		for ( i = 0; i < _no_model; i++ )  {
			
			for( j =1; j<= main_atom; j++ ) {
				
				if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {
					fprintf(fp_mdi, "%d ", j );  
				}
			}
			
			fprintf(fp_mdi, "0\n\n");
		}
		

		if ( PARA_TextOutput == 1 ) {	// txt format

			int t;
			char _str[C_LEN_ATOM];
			
			for ( i = 0; i < _no_model; i++ )  {			
				for( j =1; j<= main_atom; j++ ) {				
					if ( model_from_sat[ i*(main_atom+1) + j ] == 1 ) {

						t=-1;
						do {
							t++;
							_str[t] = atomlist[ atommap[j] +t ];
						} while (_str[t] != 0 );
						fprintf(fp_mdi, "%s ", _str);
					}
				}				
				fprintf(fp_mdi, "0\n\n");
			} // for
		} // if


		// close
//		fclose(fp_mdi);

	}  // end of if, (c), write models to file


	


	return( _no_model);

} // end of read_SAT_walksat()




int read_SAT(char str_mdi[C_LEN_FILENAME])
{
	
	int _n_model;
	int i;


	// (a), generate model[]

	model_from_sat = (int *) malloc( (main_atom+1) * sizeof (int) );          
	if(model_from_sat == NULL) { printf("\nHalt! out of memory: model\n"); error =1; }
	for ( i=0; i< main_atom+1; i++ ) { model_from_sat[i] = 0; }



//	printf("%s", sat_name);

	if ( strcmp( sat_name, "sato     ") == 0 ) { 
		_n_model = read_SAT_sato(str_mdi); 
	}
	else if ( strcmp( sat_name, "grasp    ") == 0 ) { 
		_n_model = read_SAT_grasp(str_mdi); 
	}
	else if ( strcmp( sat_name, "satz     ") == 0 ) { 
		_n_model = read_SAT_satz(str_mdi); 
	}
	else if ( strcmp( sat_name, "satz-rand") == 0 ) { 
		_n_model = read_SAT_satzrand(str_mdi); 

		// SATZ-chaff
		if ( ( PARA_SatzChaff == 1 ) && ( _n_model == 0 ) ) {

			system( runsat_chaff );
			
			_n_model = read_SAT_chaff2(str_mdi);
		}// if


	}
	else if ( strcmp( sat_name, "walksat  ") == 0 ) { 
		_n_model = read_SAT_walksat(str_mdi); 

		// Walk-chaff
		if ( ( PARA_WalkChaff == 1 ) && ( _n_model == 0 ) ) {

			//strcpy(runsat_chaff, "Chaff2 ");
			//strcat(runsat_chaff, str_cnf);
			//strcat(runsat_chaff, " > ");
			//strcat(runsat_chaff, satoutputfile);
			system( runsat_chaff );
			
			_n_model = read_SAT_chaff2(str_mdi);
		}// if

	}
	else if ( strcmp( sat_name, "Chaff2   ") == 0 ) { 
		_n_model = read_SAT_chaff2(str_mdi); 
	}

	else {
		printf(" \n Unknow SAT solver \n");
		error =1;
	}
	
	totalnumber_sat++;
	totalnumber_model = totalnumber_model + _n_model; 
	return( _n_model );

}




int check_stable_model_on_conclusion( )           
{

// input var prarmeter: the number of checking conclusion for this model
// input var prarmeter return value: the original one in normal case; 
//	     PARA_CheckConclusion, in case get 'code_of_fail' in conclusion.
// return: 1, if the conclusion is a stable model



//	int *_model;            // one model, the current one on checking
	int _current_model;


//	int *_glrule;
	int _n_glrule;

//	int *_conclusion;

	int i, j, k, s;

	int _i_temp, _position;
	int _change, _active, _same;
	int _find_stablemodel;

	



  /*** check STABLE MODEL after G-L Transformation on a given Model M. Part B. ***/




//  checking_model = (int *) malloc( (main_atom+1) * sizeof (int) );
//  if(checking_model == NULL) { printf("\nHalt! out of memory: _conclusion\n"); error =1; }

//  checking_conclusion = (int *) malloc( (main_atom+1) * sizeof (int) );
//  if(_conclusion == NULL) { printf("\nHalt! out of memory: _conclusion\n"); error =1; }

//  checking_glrule = (int *) malloc ( n_TSrule * len_rule * sizeof (int));
//  if(_glrule == NULL) { printf("\nHalt! out of memory: _glrule\n"); error =1; }

  //for ( i=0; i< main_atom+1; i++ ) { difference[i] = 0; }



  _find_stablemodel = 0;


//  for ( _current_model=0; _current_model< _no_model; _current_model++) 
//    for ( _current_model=0; _current_model< 1; _current_model++) 


	  // (0), initialize checking_model[]

	  for(i=0; i<main_atom+1; i++) {

		  checking_model[i] = conclusion[i];		// for checking Cn
	  }

	  if(PARA_DebugMode>0) {
		  //fprintf(fp_everything,"\n _model in check_stablemodel_on_conclusion\n ");
		  for(i=0; i<main_atom+1; i++) {
			  //fprintf(fp_everything,"%d ", checking_model[i]);
		  }
		  //fprintf(fp_everything,"\n\n");
	  }

	  // (1), initialize checking_conclusion[]

	  for(i=0;i<=main_atom;i++) {   checking_conclusion[i]=0; }


	  // (2), initialize checking_glrule[], get a copy of TS_rule[]

	  for(i=0;i<n_TSrule * len_rule ;i++) {  checking_glrule[ i ] = TS_rule[i]; }

	  _n_glrule = n_TSrule;




	  // (3), collect fact-atom

	  for ( i=0; i< _n_glrule; i++ ) {
		  
		  if ( checking_glrule[ i* len_rule ] == -1 ) {
			  checking_conclusion[ checking_glrule[ i*len_rule + 1 ] ]=1;
		  }

	  } // end of for, (3), collect facts


	  /* DISPLAY checking_conclusion[] */
	  if( PARA_DebugMode > 3 ) {

		  printf("\nNo.1  checking_conclusion[] \n ");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n\n\n\n");
	  }
  





	  // (4), Gelfond-Lifschitz Transformation
	  
	  for(i=0;i<_n_glrule;i++) { 

		  j=2;
		  while((checking_glrule[i * len_rule + 0]>0) && (checking_glrule[ i * len_rule + j ]!=0)) {

		  /* get a negative literal in the body in a rule, say,  - _i_temp . 
		     If _i_temp belongs the model, then delete this rule.
		     Because this rule will never be execute.
		     If _i_temp does not belong the model, then delete this literal from the rule.
		  */

			  if (checking_glrule[ i * len_rule + j ]<0) {             // find any -p in the body

				  _i_temp=checking_glrule[ i * len_rule + j ]*(-1);

				  if( _i_temp == 3) {
					  i=i;
				  }

				  // (a), p is in this _model

				  if ( checking_model[_i_temp] == 1 ) {                // Belongs this _model   
					  checking_glrule[i * len_rule + 0]=-10;	      // delete this rule     
				  }
				  


				  // (b), p is not in this _model

				  else {                                      // Not in this _model.  

					  k=j;                                    // delete this literal  
					  while(checking_glrule[i * len_rule + k]!=0) {  
						  checking_glrule[i * len_rule + k]=checking_glrule[i * len_rule + k+1];
						  k++;
					  }     /* while */

					  /**/
					  if ( checking_glrule[i * len_rule + 2] == 0 ) {    // Single head is got. 
						  //checking_conclusion[ checking_glrule[i * len_rule + 1] ] = 1;   // mark 
						  //checking_conclusion[0]++;
						  checking_glrule[i * len_rule + 0]=-1;	         // delete this rule 
						  //printf(".");
					  }
					  

					  j--;
				  }       /* else */


			  }   /* if (checking_glrule[ i * len_rule + j ]<0) */

			  j++;
		  }  /* while, finish one rule */

	  }   /* for  	  *** end of transformation ***** */








	  // (3), collect fact-atom

	  for ( i=0; i< _n_glrule; i++ ) {
		  
		  if ( checking_glrule[ i* len_rule ] == -1 ) {
			  checking_conclusion[ checking_glrule[ i*len_rule + 1 ] ]=1;
		  }

	  } // end of for, (3), collect facts

	  /* DISPLAY checking_conclusion[] */
	  if( PARA_DebugMode > 3 ) {

		  printf("\nNo.2  checking_conclusion[] \n ");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n\n\n\n");
	  }
	  




	  if ( PARA_DebugMode > 3 ) {
		  
	  /* DISPLAY glrule  after transformation 
	  
		printf("\n #### DISPLAY glrule  after transformation\n ");
		
		  for(i=0;i<_n_glrule;i++) {
	
			  j=0;
			  while( checking_glrule[ i * len_rule + j ] != 0 ) {
			  printf("%d ",checking_glrule[ i * len_rule + j ]); j++;
			  }
			  printf("\n");
		  }
	  */

	  /* DISPLAY _conclusion just after transformation 
	  printf("\nNo.3  checking_conclusion[] \n");

	  for ( i=1; i< main_atom+1; i++) {
		  
		  if( checking_conclusion[i] == 1 ) {

			  printf("%d ", i );
		  }
	  }

	  printf("\n checking_conclusion[] \n");*/


	  } // end of if, display




      // (5), decution, get conclusion		  // develope the _conclusion  
	  
	  _change=1;
	  while(_change==1) {
		  _change=0;
		  /* printf(" @ "); */
		  for(i=0;i<_n_glrule;i++) {

			  _active=1;
			  
			  _position = i * len_rule;

			  if(checking_glrule[ _position ]>0) {

				  j=2;
				  while ( ( checking_glrule[ _position + j ] != 0 ) && ( _active == 1) ) {
					  
					  if (checking_conclusion[ checking_glrule[ _position + j ] ] == 0) { _active = 0; }
					  j++;
				  }  /* End of while */

				  if (_active == 1) {     /* _active this rule. */
					  checking_conclusion[ checking_glrule[_position + 1] ] = 1;  /* mark  */
					  /*checking_conclusion[0]++;*/
					  _change =1;
					  checking_glrule[ _position + 0] = -10;           /* Disable this rule. */
				  }	  /* if (_active==1) */

			  }  /* if(checking_glrule[i][0]>0) */





		  }  /* for  */
		  
	  }  /*  while *********** get the _conclusion **** */


	  
	  if ( PARA_DebugMode > 3 ) {
		  

		  /* DISPLAY _conclusion just after transformation */
		  printf("\n\n\nNo.3  checking_conclusion[] \n");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n");


	  } // end of if, display




	  /* counting _conclusion */
	  
	  /*
	  for (i=1;i<=main_atom;i++) {
	      if(TS_atom[i] ==1) { 		checking_conclusion[i] =1;		  }
      }
	  */















	  // (6), Marching?
		


	  s=0;
	  for (i=1;i<=main_atom;i++) {
		  if(checking_conclusion[i] ==1) { 
			  s++;
		  }		  
	  }
	  checking_conclusion[0]=s;
	  

	  // (b), compare with checking_model[]       
	  
	  
//		  i=0; _same=0;   
//		  while ( (i<=main_atom) && (checking_model[i] == checking_conclusion[i]) ) {  
//			  ////fprintf(fp_result,"%d: %d - %d \n", i, checking_model[i], checking_conclusion[i]); 
//			  i++; 
//		  }
//
//		  if (i>main_atom) { _same =1; }

      _same = 1;
	  for (i=1; i< main_atom+1; i++) {

		  if (checking_model[i] != checking_conclusion[i] ) { 
			  _same = 0;
		  }
		  
	  }
		  





	  // (7), Write result to file


	  //if ( (_same == 1)&&(checking_conclusion[code_of_fail] != 1) ) {           // This is a stable model!
	  if ( _same == 1 ) {           // This is a stable model!

		  if (code_of_fail > 0 ) {
			  if (checking_conclusion[code_of_fail] == 1) {			// fake stable model

				  printf("\n     --- go on checking Cn failed... (Fail) \n" );
				  //fprintf(fp_result,"\n--- go on checking Cn failed... (Fail) \n" );
				  
				  _find_stablemodel = -1 ;
			  }
		  }
		  else {										// real stable model	
			  _find_stablemodel ++;
			  
			  printf("\n      --- check Cn:                     OK! \n" );


			  // write to file

			  //fprintf(fp_result,"\n conclusion :                           OK!  \n\n" );

			  //fprintf(fp_stable,"\n");
			  
			  for(i=1;i<=main_atom;i++) {
				  if ( checking_model[i] == 1 ) { 				  
					  //fprintf(fp_stable,"%d ", i );
					  //fprintf(fp_result,"%d ", i );
				  }		  
			  }

			  //fprintf(fp_stable,"0 \n");
			  //fprintf(fp_result,"0 \n");

		  } // else

	  }   // end of if, stable


	  else {        // This is NOT a stabel model

		  //if ( checking_conclusion[code_of_fail] == 1 ) {
			//  printf("\n     --- check Cn:       fail \n" );
			  ////fprintf(fp_result,"\n\n conclusion :             fail  \n" );
		  //}
		  //else {
			//  printf("\n     --- check Cn:       Not \n" );
			  ////fprintf(fp_result,"\n\n conclusion :             Not  \n" );
		  //}

		  printf("\n     --- check Cn:       Not \n" );
		  //fprintf(fp_result,"\n\nconclusion :             Not  \n\n" );

		  //fprintf(fp_result,"the model (conclusion of previous step) on checking: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_model[i] == 1 ) { 	//fprintf(fp_result,"%d ", i); 
			  }
		  }  
		  //fprintf(fp_result,"0 \n ");

		  //fprintf(fp_result,"Conclusion: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_conclusion[i] ==1 ) { 	//fprintf(fp_result,"%d ", i); 
			  }
		  }  
		  //fprintf(fp_result,"0 \n ");

		  //fprintf(fp_result,"Difference: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_conclusion[i] != checking_model[i] ) { 	
				  //fprintf(fp_result,"%d: %d-%d  ", i, checking_model[i], checking_conclusion[i]);   
			  }
		  }  
		  //fprintf(fp_result,"0 \n ");
//		  //fprintf(fp_result,"\n--------------------------------------------------------  \n"); 





/*
		  // if 'fail' is contained in the model, then stop the checking of Cn
		  if ( checking_conclusion[code_of_fail] == 1 ) {
			  printf("\n     --- go on checking Cn failed... (Fail) \n" );
			  //fprintf(fp_result,"\n--- go on checking Cn failed... (Fail) \n" );
			  
			  _find_stablemodel = -1 ;

		  }
		  else {      // update Cn and prepare to go on checking  
			  
			  for(i=1;i<=main_atom;i++) {  conclusion[i] = checking_conclusion[i];	 }// for			  

		  }// else
*/
			  for(i=1;i<=main_atom;i++) {  conclusion[i] = checking_conclusion[i];	 }// for			  

	  }   // end of else, NON stable
		  










//  }  // end of for, finished a model

  /*
	  // --- reduce on conclusion[] and check conclusion[]

	  for (i=1; i< main_atom+1; i++) {

		  model[i] = checking_conclusion[i] ;
	  }
printf("## ");
	  _find_stablemodel = _find_stablemodel + check_stable_model_on_conclusion(_no_model);
*/


  //fclose(fp_stable);
	  
  return( _find_stablemodel );


} //END of check_stable_model_on_conclusion()









int check_stable_model_on_model( int _no_model )           
{

// _no_model: the number of models to be checked
// return: the number of stable models had been checked

	
//	char modelfile[20]="00model";
//	char resultfile[C_LEN_FILENAME]="00result";
//	char stablefile[C_LEN_FILENAME]="00stable";




//	int *_model;            // one model, the current one on checking
	int _current_model;


//	int *_glrule;
	int _n_glrule;

//	int *_conclusion;

	int i, j, k, s;

	int _i_temp, _position;
	int _change, _active, _same;
	int _find_stablemodel;
	int _found_cn;				// return value of check_conclusion()

	int n_check_conclusion;
	

	char _str[C_LEN_ATOM];
	int t;


  /*** check STABLE MODEL after G-L Transformation on a given Model M. Part B. ***/




//  _model = (int *) malloc( (main_atom+1) * sizeof (int) );
//  if(_model == NULL) { printf("\nHalt! out of memory: _model\n"); error =1; }

//  _conclusion = (int *) malloc( (main_atom+1) * sizeof (int) );
//  if(_conclusion == NULL) { printf("\nHalt! out of memory: _conclusion\n"); error =1; }

//  _glrule = (int *) malloc ( n_TSrule * len_rule * sizeof (int));
//  if(_glrule == NULL) { 
//	  printf("\nHalt! out of memory: _glrule\n"); 
//
//	  printf("\n main-atom: %d , n_TSrule: %d, len_rule: %d \n", main_atom, n_TSrule, len_rule );
//	  error =1; 
//  }

  for ( i=0; i< main_atom+1; i++ ) { difference[i] = 0; }




//  if (!(fp_result=fopen(resultfile,"w"))) {        // result file 
//	  printf("Can not open %s\n", resultfile);
//	  error =1;
//  }
//  if (!(fp_stable=fopen(stablefile,"w"))) {        // Stable Model file 
//	  printf("Can not open %s\n", stablefile);
//	  error =1;
//  }



  _find_stablemodel = 0;


  for ( _current_model=0; _current_model< _no_model; _current_model++) {


	  // (0), initialize checking_model[]

	  for(i=0; i<main_atom+1; i++) {

		  checking_model[i] = model_from_sat[ _current_model * (main_atom+1) + i ];
		  model[i] = model_from_sat[ _current_model * (main_atom+1) + i ];		//used for LF
	  }


	  // (1), initialize checking_conclusion[]

	  for(i=0;i<=main_atom;i++) {   checking_conclusion[i]=0; }


	  // (2), initialize checking_glrule[], get a copy of TS_rule[]

	  for(i=0;i<n_TSrule * len_rule ;i++) {  checking_glrule[ i ] = TS_rule[i]; }

	  _n_glrule = n_TSrule;




	  // (3), collect fact-atom

	  for ( i=0; i< _n_glrule; i++ ) {
		  
		  if ( checking_glrule[ i* len_rule ] == -1 ) {
			  checking_conclusion[ checking_glrule[ i*len_rule + 1 ] ]=1;
		  }

	  } // end of for, (3), collect facts


	  /* DISPLAY checking_conclusion[] */
	  if( PARA_DebugMode > 3 ) {

		  printf("\nNo.1  checking_conclusion[] \n ");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n\n\n\n");
	  }
  





	  // (4), Gelfond-Lifschitz Transformation
	  
	  for(i=0;i<_n_glrule;i++) { 

		  j=2;
		  while((checking_glrule[i * len_rule + 0]>0) && (checking_glrule[ i * len_rule + j ]!=0)) {

		  /* get a negative literal in the body in a rule,
		  say,  - _i_temp . 
		  If _i_temp belongs the model, then delete this rule.
		  Because this rule will never be execute.
		  If _i_temp does not belong the model, then delete 
		  this literal from the rule.
		  */

			  if (checking_glrule[ i * len_rule + j ]<0) {             // find any -p in the body

				  _i_temp=checking_glrule[ i * len_rule + j ]*(-1);

				  if( _i_temp == 3) {
					  i=i;
				  }

				  // (a), p is in this _model

				  if ( checking_model[_i_temp] == 1 ) {                // Belongs this _model   
					  checking_glrule[i * len_rule + 0]=-10;	      // delete this rule     
				  }
				  


				  // (b), p is not in this _model

				  else {                                      // Not in this _model.  

					  k=j;                                    // delete this literal  
					  while(checking_glrule[i * len_rule + k]!=0) {  
						  checking_glrule[i * len_rule + k]=checking_glrule[i * len_rule + k+1];
						  k++;
					  }     /* while */

					  /**/
					  if ( checking_glrule[i * len_rule + 2] == 0 ) {    // Single head is got. 
						  //checking_conclusion[ checking_glrule[i * len_rule + 1] ] = 1;   // mark 
						  //checking_conclusion[0]++;
						  checking_glrule[i * len_rule + 0]=-1;	         // delete this rule 
						  //printf(".");
					  }
					  

					  j--;
				  }       /* else */


			  }   /* if (checking_glrule[ i * len_rule + j ]<0) */

			  j++;
		  }  /* while, finish one rule */

	  }   /* for  	  *** end of transformation ***** */








	  // (3), collect fact-atom

	  for ( i=0; i< _n_glrule; i++ ) {
		  
		  if ( checking_glrule[ i* len_rule ] == -1 ) {
			  checking_conclusion[ checking_glrule[ i*len_rule + 1 ] ]=1;
		  }

	  } // end of for, (3), collect facts

	  /* DISPLAY checking_conclusion[] */
	  if( PARA_DebugMode > 3 ) {

		  printf("\nNo.2  checking_conclusion[] \n ");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n\n\n\n");
	  }
	  




	  if ( PARA_DebugMode > 3 ) {
		  
	  /* DISPLAY glrule  after transformation */
	  
		printf("\n #### DISPLAY glrule  after transformation\n ");
		
		  for(i=0;i<_n_glrule;i++) {
	
			  j=0;
			  while( checking_glrule[ i * len_rule + j ] != 0 ) {
			  printf("%d ",checking_glrule[ i * len_rule + j ]); j++;
			  }
			  printf("\n");
		  }
	  

	  /* DISPLAY _conclusion just after transformation 
	  printf("\nNo.3  checking_conclusion[] \n");

	  for ( i=1; i< main_atom+1; i++) {
		  
		  if( checking_conclusion[i] == 1 ) {

			  printf("%d ", i );
		  }
	  }

	  printf("\n checking_conclusion[] \n");*/


	  } // end of if, display




      // (5), decution, get conclusion		  // develope the _conclusion  
	  
	  _change=1;
	  while(_change==1) {
		  _change=0;
		  /* printf(" @ "); */
		  for(i=0;i<_n_glrule;i++) {

			  _active=1;
			  
			  _position = i * len_rule;

			  if(checking_glrule[ _position ]>0) {

				  j=2;
				  while ( ( checking_glrule[ _position + j ] != 0 ) && ( _active == 1) ) {
					  
					  if (checking_conclusion[ checking_glrule[ _position + j ] ] == 0) { _active = 0; }
					  j++;
				  }  /* End of while */

				  if (_active == 1) {     /* _active this rule. */
					  checking_conclusion[ checking_glrule[_position + 1] ] = 1;  /* mark  */
					  /*checking_conclusion[0]++;*/
					  _change =1;
					  checking_glrule[ _position + 0] = -10;           /* Disable this rule. */
				  }	  /* if (_active==1) */

			  }  /* if(checking_glrule[i][0]>0) */





		  }  /* for  */
		  
	  }  /*  while *********** get the _conclusion **** */


	  
	  if ( PARA_DebugMode > 3 ) {
		  

		  /* DISPLAY _conclusion just after transformation */
		  printf("\n\n\nNo.3  checking_conclusion[] \n");

		  for ( i=1; i< main_atom+1; i++) {
			  
			  if( checking_conclusion[i] == 1 ) {

				  printf("%d ", i );
			  }
		  }

		  printf("\n checking_conclusion[] \n");


	  } // end of if, display




	  /* counting _conclusion */
	  
	  /*
	  for (i=1;i<=main_atom;i++) {
	      if(TS_atom[i] ==1) { 		checking_conclusion[i] =1;		  }
      }
	  */















	  // (6), Marching?
		


	  s=0;
	  for (i=1;i<=main_atom;i++) {
		  if(checking_conclusion[i] ==1) { 
			  s++;
		  }		  
	  }
	  checking_conclusion[0]=s;
	  

	  // (b), compare with checking_model[]       
	  
	  
//		  i=0; _same=0;   
//		  while ( (i<=main_atom) && (checking_model[i] == checking_conclusion[i]) ) {  
//			  ////fprintf(fp_result,"%d: %d - %d \n", i, checking_model[i], checking_conclusion[i]); 
//			  i++; 
//		  }
//
//		  if (i>main_atom) { _same =1; }

      _same = 1;
	  for (i=1; i< main_atom+1; i++) {

		  if (checking_model[i] != checking_conclusion[i] ) { 
			  _same = 0;
		  }
		  
	  }
		  





	  // (7), Write result to file


	  if ( _same == 1) {								// This is a stable model!


		  _find_stablemodel ++;
		  
		  //printf("\n     Model: %d                           OK!  \n", _current_model+1 );
		  if ( _current_model > 0 ) {
printf("\n                                                                      ");
		  }
		  
		  printf("    Model: %d          OK!\n\n", n_model_to_check++);
		  
		  // output stable model to standard output
		  if (PARA_TextOutput == 1 ) {						// text format
			  
			  for(i=1;i<=main_atom;i++) {				
				  if ( checking_model[i] == 1 ) { 				  

					  t=-1;
					  do {
						  t++;
						  _str[t] = atomlist[ atommap[i] +t ];
					  } while (_str[t] != 0 );
					  printf("%s ", _str);
				  }			
			  }
		  } // if
		  else {											// code format

			  for(i=1;i<=main_atom;i++) {			
				  if ( checking_model[i] == 1 ) { 				  
					  printf("%d ", i);
				  }			
			  }

		  } //else

		  
		  printf("\n\n");

		  // write to file
		  //fprintf(fp_result,"\n--------------------------------------------------------  \n"); 
		  //fprintf(fp_result,"\n\n Model : %d                             Stable Model! \n\n", _current_model+1 );

		  //fprintf(fp_stable,"\n");
		  
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_model[i] == 1 ) { 				  
				  //fprintf(fp_stable,"%d ", i );
			  }
		  }

		  //fprintf(fp_stable,"0 \n");

	  }   // end of if, stable



	  else {										// This is NOT a stabel model

		  if ( _current_model > 0 ) {
printf("\n                                                                      ");
		  }

		  printf("    Model: %d      NO  ", n_model_to_check++);
		  //printf("    Model: %d      NO  %s", n_model_to_check++, str_cni);


		  ////fprintf(fp_result,"\n--------------------------------------------------------  \n"); 
		  //////fprintf(fp_result,"\n\n Model : %d               NOT\n\n", _current_model+1 );
		  ////fprintf(fp_result,"\n\n Model : %d               NOT\n\n", n_model_to_check );

		  ////fprintf(fp_result,"Model: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_model[i] == 1 ) { 	////fprintf(fp_result,"%d ", i);
			  }
		  }  
		  ////fprintf(fp_result,"0 \n ");

		  ////fprintf(fp_result,"Conclusion: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_conclusion[i] ==1 ) { 	////fprintf(fp_result,"%d ", i);
			  }
		  }  
		  ////fprintf(fp_result,"0 \n ");

		  ////fprintf(fp_result,"Difference: \n ");
		  for(i=1;i<=main_atom;i++) {
			  if ( checking_conclusion[i] != checking_model[i] ) { 	
				  //fprintf(fp_result,"%d: %d-%d  ", i, checking_model[i], checking_conclusion[i]);  
			  }// if
		  }  // for
		  //fprintf(fp_result,"0 \n ");
		  






		  for(i=1;i<=main_atom;i++) {
			  conclusion[i]=0;
			  difference[i]=0;
		  }
		  for(i=1;i<=main_atom;i++) {
			  if ( model[i] == 1 ) { 	
				  if (checking_conclusion[i] ==1) {	  
					  conclusion[i]=1;		// used for checking Cn
				  }
				  else {	
					  difference[i]=1;		// used for FL. This is the M- between M and Cn
				  }
			  }// if
		  }// for			  

		  


		  /* check conclusion[]   */
		  // This is NOT a stable model, check conclusion[]
		  // --- reduce on conclusion[] and check conclusion[]
		  //			
		  if ( PARA_CheckConclusion != 0 )  {

			  /*
			  // keep Cn & M- for the first model
			  for(i=1;i<=main_atom;i++) {
				  conclusion[i]=0;
				  difference[i]=0;
			  }
			  for(i=1;i<=main_atom;i++) {
				  if ( model[i] == 1 ) { 	
					  if (checking_conclusion[i] ==1) {	  
						  conclusion[i]=1;		// used for checking Cn
					  }
					  else {	
						  difference[i]=1;		// used for FL. This is the M- between M and Cn
					  }
				  }// if
			  }// for			  
			  */

			  
			  // check Cn for 'PARA_CheckConclusion' times, unless we find a stable model
			  _found_cn = 0;
			  n_check_conclusion=0;
			  while ( (n_check_conclusion < PARA_CheckConclusion) && (_found_cn == 0) ) {
				  _found_cn = check_stable_model_on_conclusion( );
				  n_check_conclusion++;
			  }
			  if (_found_cn == 1) {
				  _find_stablemodel ++;
			  }
		  } // end of if, _same != 1.






	  }   // end of else, NON stable




/*
	  // This is NOT a stable model, check conclusion[]
	  // --- reduce on conclusion[] and check conclusion[]

	  if ( (PARA_CheckConclusion != 0 ) && ( _same != 1 ) ) {
		  
		  // check Cn for 'PARA_CheckConclusion' times, unless we find a stable model
		  _found_cn = 0;
		  n_check_conclusion=0;
		  while ( (n_check_conclusion < PARA_CheckConclusion) && (_found_cn == 0) ) {
			  _found_cn = check_stable_model_on_conclusion( );
			  n_check_conclusion++;
		  }
		  if (_found_cn == 1) {
			  _find_stablemodel ++;
		  }
	  } // end of if, _same != 1.
*/




	  
    }  // end of for, finished a model


  //fclose(fp_stable);
	  
  return( _find_stablemodel );


} //END of check_stable_model_on_model()







void translate_rulelink_rule()            // translate from rulelink[] => rule[]
{

	FILE *fp_rule;
	char rulefile[20]="00rule";	
	
	int i, j;
	int _no_rulelist;

	int _position;



	//  rule = (int *) malloc ( i_temp * sizeof (int));
  

	rule = (int *) realloc ( rule, main_rule * len_rule * sizeof (int));
	for ( i=0; i<main_rule * len_rule; i++ )  { rule[i] = 0 ; } 
	
	_no_rulelist = 0;  


	// DISPLAY rulelink

	for ( i=0; i< main_atom+1; i++ ) {
		
		if ( rulelink[i].data != 0 ){
			
			//printf("\n head= %d n_iff= %d\n", i, rulelink[i].data );

			c_pointer1 = rulelink[i].p_cross;
			while ( c_pointer1 != NULL ) {

				//printf("    %d: ", c_pointer1->data);

				rule[ _no_rulelist ] = c_pointer1->data;
				rule[ _no_rulelist + 1 ] = i;

				j=2;

				b_pointer1 = c_pointer1->p_body;
				while (b_pointer1 != NULL ) {

					//printf("%d ", b_pointer1->data);
					
					rule[ _no_rulelist + j ] = b_pointer1->data;
					j++;

					b_pointer1 = b_pointer1->p_body;
				}
				//printf("\n");
				_no_rulelist = _no_rulelist + len_rule;

				c_pointer1 = c_pointer1->p_cross;

			}//end of while


		}// end of if

	}// end of for,  got rule[]



//  free(_rulelist);





	if (!(fp_rule=fopen(rulefile,"w"))) {     // Open rule file with "W" mode. 
		printf("Can not open %s\n", rulefile);
		error =1;
	}


	fprintf(fp_rule, "\n");
	for(i=0;i<main_rule;i++) {             

		_position = i*len_rule;

		fprintf(fp_rule, "%d= ",i);

		for(j=0; j<len_rule; j++) {
			fprintf(fp_rule, "%d ",rule[_position + j]);
		}
		
		fprintf(fp_rule," 0\n");
	}
	
	fclose(fp_rule); 







} // end of translate_rulelink_rule()




void LF_LoopDetect_SCC_in_difference(int v)
// start from atoms in M-, following rules which is satisfied by M, find SCCs
{	// use rulelink2[] !!

	struct CROSSNODE *_cp1;
	struct BODYNODE *_bp1;
/*
	struct LOOPTREENODE *_tp1;
	struct LOOPCHAINNODE *_lp1;
*/
	int i,j;

	int _w;

	int _goon;



	i_number++;
	lowlink[v] = i_number;
	number[v] = i_number;

	stack[v]=1;				// put v on stack of points


	// find SSCs in Pm, which are rules satisfied by M
	_cp1 = rulelink2[v].p_cross;
	while( _cp1 != NULL ) {

		_bp1 = _cp1->p_body;	_goon =1;
		while ( (_bp1 != NULL)&&(_goon ==1) ) {
			_w = _bp1->data;

			if( ( (_w>0) && (model[_w]==0) ) || ( (_w<0) && (model[abs(_w)]==1) ) ) {
				_goon =0;
			} // if this rule is satisfied by M
			else if ( (_w>0) && (difference[abs(_w)]==1) ) {  //only consider atoms in difference[]

				if ( number[_w] == 0) {
					//_cp1 is a tree arc;
					LF_LoopDetect_SCC_in_difference(_w);							// >>>>>> itself
					if( lowlink[_w] < lowlink[v])	{ lowlink[v]=lowlink[_w]; }
						
				}// if number[_w} == 0
				else if ( number[_w] < number[v] ) {
					// _cp1 is a frond or cross-link
					if ( stack[_w] == 1 ) {
						if( number[_w] < lowlink[v])	{ lowlink[v]=lowlink[_w]; }
					}// if stack[_w] == 1
				}
				// else if


				
			} // end of else if

			_bp1 = _bp1->p_body;
		} // while _bp1

		_cp1 = _cp1->p_cross;
	}// while _cp1


/*  // find SSCs in P
	_cp1 = rulelink2[v].p_cross;
	while( _cp1 != NULL ) {

		_bp1 = _cp1->p_body;
		while (_bp1 != NULL ) {
			_w = _bp1->data;
			if ( (_w>0) && (difference[abs(_w)]==1) ) {  //only consider atoms in difference[]

				if ( number[_w] == 0) {
					//_cp1 is a tree arc;
					LF_LoopDetect_SCC_in_difference(_w);
					if( lowlink[_w] < lowlink[v])	{ lowlink[v]=lowlink[_w]; }
						
				}// if number[_w} == 0
				else if ( number[_w] < number[v] ) {
					// _cp1 is a frond or cross-link
					if ( stack[_w] == 1 ) {
						if( number[_w] < lowlink[v])	{ lowlink[v]=lowlink[_w]; }
					}// if stack[_w] == 1
				}
				// else if


				
			} // end of if

			_bp1 = _bp1->p_body;
		} // while _bp1

		_cp1 = _cp1->p_cross;
	}// while _cp1
*/

	if ( lowlink[v] == number[v] ) {
		// v is the root of a component;
		// start a new strongly connected component;
		i_component++;

		stack[v] = 0;
		component[v]= i_component;

		for ( i=1; i<=main_atom; i++ ) {
			if ( ( stack[i] == 1 )&&( number[i] > number[v] ) ) {
				stack[i] = 0;
				component[i]= i_component;
			}
		} // for

	} // if ( lowlink[v] == number[v] )


} // LF_LoopDetect_SCC_in_difference()




void LF_LoopDetect( char _str_lpi[C_LEN_FILENAME] ) // find SCCs in M- following the rules r which is satisfied by M
{	// use rulelink2[] !!

//	FILE *fp_lp;

	int i,j, k;
	int _start;
	int _no_in_loop;

	char _str[C_LEN_ATOM];


	i_number = 0;
	i_component = 0;

	for (i=1; i<=main_atom; i++) {
		if ( ( number[i] == 0 ) && ( difference[i]==1 ) ) {

//			printf("LF_LoopDetect_SCC_in_difference:%d   ", i);
			LF_LoopDetect_SCC_in_difference(i);						// >>>>>> find SCC from difference
		}
	}



	if ( PARA_ResultFile == 1 ) { 

		
		fprintf(fp_lpi, "\n");

		for ( i=1; i<= i_component; i++ ) {
			fprintf(fp_lpi, "\n loop%d:    ",i);
			for (j=1; j<=main_atom; j++) {
				if(component[j]==i) {
					fprintf(fp_lpi, "%d ",j);
				}
			}	

			fprintf(fp_lpi, "\n\n");
		}

		if (PARA_TextOutput == 1 ) { // txt output
			
			fprintf(fp_lpi, "\nTEXT format:\n");

			for ( i=1; i<= i_component; i++ ) {
				fprintf(fp_lpi, "\n loop%d:    ",i);
				for (j=1; j<=main_atom; j++) {
					if(component[j]==i) {

						k=-1;
						do {
							k++;
							_str[k] = atomlist[ atommap[j] +k ];
						} while (_str[k] != 0 );
						fprintf(fp_lpi, "%s ", _str);
				
					}
				}	

				fprintf(fp_lpi, "\n");
			}

		} // txt output

	}



} // LF_LoopDetect()







void LF_to_CNF(struct CROSSNODE *_linkhead, int _n_otherrule, char str_cni[C_LEN_FILENAME])    
// add additional constraints to CNF following loops
// build CNF from _linkhead, which is something like a iff-class in rulelink2[]
// and write it back to cnf file

	/*						 A * B * ... * P
							A = a(1) ^ a(2) ^ a(3) ^ ... a(l1)
							B = b(1) ^ b(2) ^ b(3) ^ ... b(l2)
							...
							P = p(1) ^ p(2) ^ p(3) ^ ... p(l1)
		----------------------------------------------------------------------------
		SUBSTITUTE						|
		(A.1)							|
  	 
	*/
{	// use rulelink2[] !!

//	FILE *fp_cni, *fp_txt; 


//	char str_txt[C_LEN_FILENAME];
	char _str[C_LEN_ATOM];

	struct CROSSNODE *_cp1, *_cp2;
	struct BODYNODE  *_bp1, *_bp2;
	//struct BODYNODE  **combination_pointers1, **combination_pointers2;

	int _n;

	int _n_add_atom=0;
	int _add_atom;    //_add_atom = no_atom + _n_add_atom;

	double _pi_times, _sigma_adds;

	int i, j, k, _stop, i_temp;
	int _goon;
	int _equal=0;


	struct BODYNODE  *_cnflink;   // sort the cnf line
	struct BODYNODE  *_cnfp1,*_cnfp2;


	_cnflink = new BODYNODE;
	_cnflink->data = 0;
	_cnflink->p_body = NULL;


/*

_cp1= _linkhead;
while ( _cp1 != NULL ) {
	printf("\n%d : ", _cp1->data);

	_bp1=_cp1->p_body;
	while( _bp1 != NULL ) { 
		printf("%d ", _bp1->data);
		_bp1 = _bp1->p_body;
	}

	_cp1 = _cp1->p_cross;
}


i=0;

*/








	// (1),

	//_n = _linkhead->data;
	_n = _n_otherrule + 1 ;
	 
	if ( PARA_ResultFile == 1 ) {
/*		if (!(fp_cni=fopen(str_cni,"w"))) {	// 
			printf("Can not open the file: %s\n", str_cni);
			error =1;
		}
	

		if ( PARA_TextOutput == 1 ) {
			
			strcpy(str_txt, str_cni);
			strcat(str_txt, ".txt");
			
			if ( (fp_txt=fopen(str_txt,"w")) == NULL ) {	// 
				printf("Can not open the file: %s\n", str_txt);
				error =1;
			}
		}*/
	}



	// (2), calculate _pi_times & _sigma_adds; decide if it is necessary to substitute

	_pi_times = 1; _sigma_adds = 0;


	_cp1 = _linkhead;
	//_cp1 = _linkhead->p_cross;
	while ( (_cp1 != NULL ) && (_pi_times<=1000000) ) {        //26388279066624.

		_pi_times = _pi_times * _cp1->data;
		_sigma_adds = _sigma_adds + _cp1->data;
 
		_cp1 = _cp1->p_cross;

	} // end of while, 

	
	_sigma_adds = _sigma_adds + _n + 1;


	// blackbox
	if( PARA_DebugMode != 0 ) {
//		//fprintf(fp_everything, "\nLF_to_CNF: \n");
//		//fprintf(fp_everything, "\n_pi_times= %.0f     _sigma_adds= %.0f \n", _pi_times, _sigma_adds);
		
		_cp1 = _linkhead;
		//_cp1 = _linkhead->p_cross;
		while (_cp1 != NULL ) {
//			//fprintf(fp_everything, "\nlength: %d  :: ", _cp1->data);

			_bp1 = _cp1->p_body;
			while( _bp1 != NULL) {
//				//fprintf(fp_everything, " %d ", _bp1->data);
				_bp1 = _bp1->p_body;
			}

			_cp1 = _cp1->p_cross;
		} // end of while, 
		
//		//fprintf(fp_everything, " \n\n");
	}

/*
printf("\n\n");
_cp1= _linkhead;
while ( _cp1 != NULL ) {
	printf("\n%d : ", _cp1->data);

	_bp1=_cp1->p_body;
	while( _bp1 != NULL ) { 
		printf("%d ", _bp1->data);
		_bp1 = _bp1->p_body;
	}

	_cp1 = _cp1->p_cross;
}


i=0;

*/



	// (3), completion

	if ( ( _pi_times > PARA_RateOfSubstitute * _sigma_adds )||(_pi_times > 1000000) ) {       // (B), " Substitute 

		if( PARA_DebugMode != 0 ) {
//			//fprintf(fp_everything, "\n_pi_times > _sigma_adds, Substitute \n");
		}

		// (B.2), ONLYIF- semantics. No IF-direction in this case
		
		_cp1 = _linkhead;
		//_cp1 = _linkhead->p_cross;
		_n_add_atom =0;
		
		while (_cp1 != NULL ) {    

			//if ( _cp1->data > 4 ) {   // This guy is to be substitute
			if ( _cp1->data > 1 ) {   // This guy is to be substitute

				_n_add_atom ++;
				_add_atom = no_atom + _n_add_atom;


				// (a), A <- a1^a2^...^an      |->     -a1 -a2 ... -an A
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					// ---------------------------------- insert sorting
					i_temp = (-1)*_bp1->data;

					_goon =1;
					_cnfp1 = _cnflink;
					_cnfp2 = _cnfp1->p_body;
					while ( ( _cnfp2 != NULL)&& (_goon ==1) ) {
						
						if (i_temp > _cnfp2->data) {
							_cnfp1 = _cnfp2;
							_cnfp2 = _cnfp2->p_body;
						}
						else if (i_temp < _cnfp2->data) {
							_goon =0;
						}
						else { // i_temp == _cnfp2->data
							_equal =1;
							_goon = 0;
						}
					} // while

					if ( _equal == 1 ) { _equal =0; }
					else {
						_bp2 = new BODYNODE;
						_bp2->data = i_temp;
						_bp2->p_body = _cnfp2;					
						_cnfp1->p_body = _bp2;
					}
					// ---------------------------------- insert sorting


					//fprintf(fp_cnf, "%d ", (-1) * _bp1->data );  
					_bp1 = _bp1->p_body;

				} // end of while. 

				//---------------------------------save with sorted order
				_cnfp1 = _cnflink->p_body;
				while ( _cnfp1 != NULL ) {
					fprintf(fp_cnf, "%d ", _cnfp1->data );  

					if ( PARA_ResultFile == 1 ) { fprintf(fp_cni, "%d ", _cnfp1->data );

						if (PARA_TextOutput == 1) {

							//if ( abs(_cnfp1->data) > main_atom ) {
							//	if (_cnfp1->data >0 ) fprintf(fp_txt, "temp(%d) ", abs(_cnfp1->data));
							//	else fprintf(fp_txt, "not temp(%d) ", abs(_cnfp1->data));
							//}
							//else {

								k=-1;
								do {
									k++;
									_str[k] = atomlist[ atommap[abs(_cnfp1->data)] +k ];
								} while (_str[k] != 0 );
								if (_cnfp1->data >0 ) fprintf(fp_txt, "%s ", _str);
								else fprintf(fp_txt, "not %s ", _str);
							//}
						}
					}
					_cnfp2 = _cnfp1;
					_cnfp1 = _cnfp1->p_body;
					delete _cnfp2;
				}
				_cnflink->p_body=NULL;
				//---------------------------------save with sorted order

	
				fprintf(fp_cnf,  "%d 0\n", _add_atom ); 
				if ( PARA_ResultFile == 1 ) {  fprintf(fp_cni, "%d 0\n", _add_atom );

					if (PARA_TextOutput == 1) { 

						//if ( abs(_add_atom) > main_atom ) {
						//	if (_add_atom >0 ) fprintf(fp_txt, "temp(%d) ", abs(_add_atom));
						//	else fprintf(fp_txt, "not temp(%d) ", abs(_add_atom));
						//}
						//else {

							k=-1;
							do {
								k++;
								_str[k] = atomlist[ atommap[abs(_add_atom)] +k ];
							} while (_str[k] != 0 );
							if (_add_atom >0 ) fprintf(fp_txt, "%s ", _str);
							else fprintf(fp_txt, "not %s ", _str);
						//}
					}
					 

				}
				cnf_clause++;



				// (b), A -> a1^a2^...^an      |->     -A a1 / -A a2 / ... / -A an 
				_bp1 = _cp1->p_body;
				while ( _bp1 != NULL ) {

					fprintf(fp_cnf, "%d %d 0\n", (-1)*_add_atom, _bp1->data );  
					if ( PARA_ResultFile == 1 ) { fprintf(fp_cni, "%d %d 0\n", (-1)*_add_atom, _bp1->data ); 
//printf("%d %d 0\n", (-1)*_add_atom, _bp1->data ); 						
						if (PARA_TextOutput == 1) { 

							// 1st
							//if ( abs(_add_atom) > main_atom ) {
							//	if (_add_atom >0 ) fprintf(fp_txt, "not temp(%d) ", abs(_add_atom));
							//	else fprintf(fp_txt, "temp(%d) ", abs(_add_atom));
							//}
							//else {

								k=-1;
								do {
									k++;
									_str[k] = atomlist[ atommap[abs(_add_atom)] +k ];
								} while (_str[k] != 0 );
								if (_add_atom >0 ) fprintf(fp_txt, "not %s ", _str);
								else fprintf(fp_txt, "%s ", _str);
							//}


							//2nd
							//if ( abs(_bp1->data) > main_atom ) {
							//	if (_bp1->data >0 ) fprintf(fp_txt, "temp(%d) ", abs(_bp1->data));
							//	else fprintf(fp_txt, "not temp(%d) ", abs(_bp1->data));
							//}
							//else {

								k=-1;
								do {
									k++;
									_str[k] = atomlist[ atommap[abs(_bp1->data)] +k ];
								} while (_str[k] != 0 );
								if (_bp1->data >0 ) fprintf(fp_txt, "not %s ", _str);
								else fprintf(fp_txt, "%s ", _str);
							//}
						}
					} 
					cnf_clause++;

					_bp1 = _bp1->p_body;

				} // end of while. 
			
			}  // end of if, this guy has been substituted
		
			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class



		// (c), p -> A B c                        |->   -p A B c
		_cp1 = _linkhead;		
		//_cp1 = _linkhead->p_cross;
		while (_cp1 != NULL ) {
			
			if ( _cp1->data == 1 ) {        // Normal single body

				_bp1 = _cp1->p_body;
				fprintf(fp_cnf, "%d ", _bp1->data );  
				if ( PARA_ResultFile == 1 ) {   fprintf(fp_cni, "%d ", _bp1->data );
//printf("%d ", _bp1->data );
					if (PARA_TextOutput == 1) {

						//if ( abs(_bp1->data) > main_atom ) {
						//	if (_bp1->data >0 ) fprintf(fp_txt, "temp(%d) ", abs(_bp1->data));
						//	else fprintf(fp_txt, "not temp(%d) ", abs(_bp1->data));
						//}
						//else {

							k=-1;
							do {
								k++;
								_str[k] = atomlist[ atommap[abs(_bp1->data)] +k ];
							} while (_str[k] != 0 );
							if (_bp1->data >0 ) fprintf(fp_txt, "%s ", _str);
							else fprintf(fp_txt, "not %s ", _str);
						//}
					}
				
				}

			}

			else {                          // add_atom

				no_atom++;
				fprintf(fp_cnf, "%d ", no_atom );
				if ( PARA_ResultFile == 1 ) { fprintf(fp_cni, "%d ", no_atom );

					if (PARA_TextOutput == 1) {

						fprintf(fp_txt, "temp(%d) ", no_atom );
						//if ( abs(_bp1->data) > main_atom ) {
						//	if (_bp1->data >0 ) fprintf(fp_txt, "temp(%d) ", abs(_bp1->data));
						//	else fprintf(fp_txt, "not temp(%d) ", abs(_bp1->data));
						//}
						//else { printf("error 9560\n"); error =1;		}
					}
												
				}

			}

			_cp1 = _cp1->p_cross;

		} // end of while, implement the " IF_semantics " of this iff-class

		fprintf(fp_cnf, "0\n" );  
		if ( PARA_ResultFile == 1 ) { fprintf(fp_cni, "0\n" ); 
			if (PARA_TextOutput == 1) { fprintf(fp_txt, "0\n\n" ); }
		}
		
		cnf_clause++;

	}  // end of if, (B) substitute



	else {                 // (A), no substitute, normal method, combination   

		
		// (A.2), ONLYIF - semantics

		//combination_pointers1 = (struct BODYNODE ** ) malloc( _n * sizeof( struct BODYNODE *) ) ;      
		//if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }
		//combination_pointers2 = (struct BODYNODE ** ) malloc( _n * sizeof( struct BODYNODE *) ) ;      
		//if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }

		if ( _n > len_combination_pointer ) {
			
			//printf(" _n:%d ",_n);

			free ( combination_pointers1 );
			free ( combination_pointers2 );
			
			len_combination_pointer = _n + 2;

			combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }


			// while ( _n > len_combination_pointer ) 
			 // len_combination_pointer = len_combination_pointer + C_LEN_COMBINATION_POINTER;

			 //combination_pointers1 = (struct BODYNODE ** ) realloc(combination_pointers1, len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			 //if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
			 //combination_pointers2 = (struct BODYNODE ** ) realloc(combination_pointers2, len_combination_pointer * sizeof( struct BODYNODE *) ) ;      
			 //if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p, realloc %d \n", len_combination_pointer); error =1; }
		}



		i=0;

		_cp1 = _linkhead;
		//_cp1 = _linkhead->p_cross;
		while ( _cp1 != NULL ) {

			combination_pointers1[i] = _cp1->p_body;   
			combination_pointers2[i] = _cp1->p_body;   

			i++;

			_cp1 = _cp1->p_cross;
		}



		_stop=0;
		while ( _stop == 0 ) {
			
						
			for (i=0; i < _n; i++) {
				//fprintf(fp_cnf, "%d ", combination_pointers1[i]->data);

				// ----------------------------------------------insert sorting
				i_temp = combination_pointers1[i]->data;

				_goon =1;
				_cnfp1 = _cnflink;
				_cnfp2 = _cnfp1->p_body;
				while ( ( _cnfp2 != NULL)&& (_goon ==1) ) {
					
					if (i_temp > _cnfp2->data) {
						_cnfp1 = _cnfp2;
						_cnfp2 = _cnfp2->p_body;
					}
					else if (i_temp < _cnfp2->data) {
						_goon =0;
					}
					else { // i_temp == _cnfp2->data
						_equal =1;
						_goon = 0;
					}
				} // while

				if ( _equal == 1 ) { _equal =0; }
				else {
					_bp2 = new BODYNODE;
					_bp2->data = i_temp;
					_bp2->p_body = _cnfp2;					
					_cnfp1->p_body = _bp2;
				}
				// ----------------------------------------------insert sorting

			}// for

			//---------------------------------save with sorted order
			_cnfp1 = _cnflink->p_body;
			while ( _cnfp1 != NULL ) {
				fprintf(fp_cnf, "%d ", _cnfp1->data );  
				if ( PARA_ResultFile == 1 ) {   fprintf(fp_cni, "%d ", _cnfp1->data );
//printf("%d ", _cnfp1->data );
					if (PARA_TextOutput == 1) {
						
						//if ( abs(_cnfp1->data) > main_atom ) {
						//	if (_cnfp1->data >0 ) fprintf(fp_txt, "temp(%d) ", abs(_cnfp1->data));
						//	else fprintf(fp_txt, "not temp(%d) ", abs(_cnfp1->data));
						//}
						//else {
						
						k=-1;
						do {
							k++;
							_str[k] = atomlist[ atommap[abs(_cnfp1->data)] +k ];
						} while (_str[k] != 0 );
						if (_cnfp1->data >0 ) fprintf(fp_txt, "%s ", _str);
						else fprintf(fp_txt, "not %s ", _str);
						//}
					}
								
				}
				_cnfp2 = _cnfp1;
				_cnfp1 = _cnfp1->p_body;
				delete _cnfp2;
			}
			_cnflink->p_body=NULL;
			//---------------------------------save with sorted order


			fprintf(fp_cnf, "0\n");
			if ( PARA_ResultFile == 1 ) { fprintf(fp_cni, "0\n"); 
				if (PARA_TextOutput == 1) { fprintf(fp_txt, "0\n\n"); }
			}
			cnf_clause++;


			j=0;
			while ( (j<_n ) && ( combination_pointers1[j]->p_body == NULL ) ) {
				j++;
			}

			if ( j == _n  ) {  _stop = 1;	}
			else {
				combination_pointers1[j] = combination_pointers1[j]->p_body;

				for( k=0; k<j; k++) {
					combination_pointers1[k] = combination_pointers2[k];
				}
			}


		}  // end of while


		//delete []combination_pointers1;
		//delete []combination_pointers2;

	}  // end of else, (A), no substitute, normal method, combination   

/*	if ( PARA_ResultFile == 1 ) {
		fclose(fp_cni);

		if ( PARA_TextOutput == 1 ) {
			fclose(fp_txt);
		}
	}
*/

	return;

////////

} 
//LF_to_CNF()



 

void LF_by_SCCs_in_diff(char str_cni[C_LEN_FILENAME])
// from component[], build _lflink (something like a iffclass in rulelink2[])
// For example:
//				p1 <- G1, p1 <- G2, p2 <- G3
// are other rules, where G1=g11,g12,...g1m,  G2=g21,g22,...g2n, G3=g31,g32,...,g3o
//				LF = - (G1 V G2 V G3) -> -p1 ^ -p2 ^ -p3
//				   = G1 V G2 V G3 V ( -p1 ^ -p2 ^ -p3 )
//
// So,	_lflink -> ( -p1 ^ -p2 ^ -p3 ) -> G1 -> G2 -> G3 -> NULL
// while '_n_otherrule' = 3.
{	// use rulelink2[] !!


	struct CROSSNODE *_lflink;
	struct CROSSNODE *_lp1, *_lp2, *_lp3;
	struct CROSSNODE *_cp1, *_cp2, *_cp3;
	struct BODYNODE  *_bp1, *_bp2;

  
	int _n_otherrule;	// number of other rules for this loop

	int i, j;
	int _goon;  // for while loop, if go on loop?
	int _int;	// for ant variable in INT type 





//	if (!(fp_cnf=fopen("00cnf2","w"))) {  
//		printf("Can not open the file: %s\n", "00cnf2");
//		error =1;
//	}

	_lflink = new CROSSNODE;

	_lflink->data =0;
	_lflink->p_body = NULL;
	_lflink->p_cross = NULL;	_lflink->p_cross2 = NULL;


if ( ( PARA_Reduce ==1 ) && ( PARA_ConstraintFactReduction == 1 ) ) {		// Reduction Mode

	for ( i=1; i<= i_component; i++ ) {


		// (0) reset _lflink and clear something useless		
		_bp1 = _lflink->p_body;
		while( _bp1 != NULL ) {
			_bp2 = _bp1;
			_bp1 = _bp1->p_body;
			delete _bp2;
		}

		_lp1 = _lflink->p_cross;
		while( _lp1 != NULL ) {
			_lp2 = _lp1;
			_lp1 = _lp1->p_cross;
			delete _lp2;
		}

		_lflink->data =0;
		_lflink->p_cross = NULL;	_lflink->p_cross2 = NULL;
		_lflink->p_body = NULL;

		//

		_lp1 = _lflink;
		_n_otherrule = 0;
		// or _lp1 = _lflink->p_cross


		// (1): ( -p1 ^ -p2 ^ -p3 ) 
		for (j=1; j<=main_atom; j++) {
			if ( (component[j]==i) && ( CS_atom[j] != 1 ) ) {	// j in SCC i & j isn't flaSe literal
				
				_bp1 =  new BODYNODE;
				_bp1->data = (-1)*j;
				_bp1->p_body = _lp1->p_body;
				_lp1->p_body = _bp1;

				_lflink->data ++;

				//printf("%d ",j);					//>>>>>>>>
			}//
			else if ( CT_atom[j] == 1 ) {	// j is facT, it dones not matter
			}
		} // for each element in the component	



		// (2): Gi, use the same bodylink for the rule in rulelink2[]

		for (j=1; j<=main_atom; j++) {
			if(component[j]==i) {

				_cp2 = rulelink2[j].p_cross;
				while (_cp2 != NULL ) {

					_goon = 1;
					_bp1 = _cp2->p_body;
					while ( ( _bp1 != NULL ) && ( _goon==1 ) ) {

						_int = _bp1->data;

						if (_int > 0 ) {
							
							// check if it is satisfied by M !!! this condition is unreasonable
							// if ( model[_int] != 1 ) { _goon = 0; }
							
							// check if it is in otherrule 
							if ( component[_int] == i ) { _goon = 0; }

						} // >0

						_bp1 = _bp1->p_body;
					}
					
					if (_goon == 1 ) {	// this rule is a 'other-rule'


						if ( _cp2->p_cross2 == NULL ) {		
							
							// this rule has been deleted in reduction, so it is usless in loop formulars, 
							// skip it! If all rules about this literal 'p' were deleted, then we must have:
							// TS_atom[p] == 1, then 'p' should be in the right part of the LF.

						}
						else {								// collect it to 'other-rule'
							_lp2 = new CROSSNODE;
							_lp2->data = _cp2->p_cross2->data;
							_lp2->p_body = _cp2->p_cross2->p_body;
							_lp2->p_cross = _lp1->p_cross;		_lp2->p_cross2 = NULL;
							_lp1->p_cross = _lp2;

							_n_otherrule++;
						}

					} // if


					_cp2 = _cp2->p_cross;
				}// while

			}// if
		} // for each element in the component
	





		//display
//		_cp3 = _lflink;
//		while( _cp3 != NULL ) {
//			_bp1=_cp3->p_body;
//			while(_bp1!= NULL) {
//				printf("%d ", _bp1->data);						//>>>>>>>>
//				_bp1 = _bp1->p_body;
//			}

//			printf("\n");
//			_cp3 = _cp3->p_cross;
//		}
//			printf("\n");
			//printf("..");


		N_loopformula++;

		LF_to_CNF(_lflink, _n_otherrule, str_cni);  // write to CNF


	} // for i_component

} // if, // Reduction Mode


else {// Normal Mode


	for ( i=1; i<= i_component; i++ ) {


		// (0) reset _lflink and clear something useless		
		_bp1 = _lflink->p_body;
		while( _bp1 != NULL ) {
			_bp2 = _bp1;
			_bp1 = _bp1->p_body;
			delete _bp2;
		}

		_lp1 = _lflink->p_cross;
		while( _lp1 != NULL ) {
			_lp2 = _lp1;
			_lp1 = _lp1->p_cross;
			delete _lp2;
		}

		_lflink->data =0;
		_lflink->p_cross = NULL;	_lflink->p_cross2 = NULL;
		_lflink->p_body = NULL;

		//

		_lp1 = _lflink;
		_n_otherrule = 0;
		// or _lp1 = _lflink->p_cross


		// (1): ( -p1 ^ -p2 ^ -p3 ) 
		for (j=1; j<=main_atom; j++) {
			if(component[j]==i) {
				
				_bp1 =  new BODYNODE;
				_bp1->data = (-1)*j;
				_bp1->p_body = _lp1->p_body;
				_lp1->p_body = _bp1;

				_lflink->data ++;

				//printf("%d ",j);					//>>>>>>>>
			}//
		} // for each element in the component	



		// (2): Gi, use the same bodylink for the rule in rulelink2[]

		for (j=1; j<=main_atom; j++) {
			if(component[j]==i) {

				_cp2 = rulelink2[j].p_cross;
				while (_cp2 != NULL ) {

					_goon = 1;
					_bp1 = _cp2->p_body;
					while ( ( _bp1 != NULL ) && ( _goon==1 ) ) {

						_int = _bp1->data;

						if (_int > 0 ) {
							
							// check if it is satisfied by M !!! this condition is unreasonable
							// if ( model[_int] != 1 ) { _goon = 0; }
							
							// check if it is in otherrule 
							if ( component[_int] == i ) { _goon = 0; }

						} // >0

						_bp1 = _bp1->p_body;
					}
					
					if (_goon == 1 ) {

						_lp2 = new CROSSNODE;
						_lp2->data = _cp2->data;
						_lp2->p_body = _cp2->p_body;
						_lp2->p_cross = _lp1->p_cross;		_lp2->p_cross2 = NULL;
						_lp1->p_cross = _lp2;

						_n_otherrule++;

					} // if


					_cp2 = _cp2->p_cross;
				}// while

			}// if
		} // for each element in the component
	





		//display
		_cp3 = _lflink;
		while( _cp3 != NULL ) {
			_bp1=_cp3->p_body;
			while(_bp1!= NULL) {
				//printf("%d ", _bp1->data);						//>>>>>>>>
				_bp1 = _bp1->p_body;
			}

			//printf("\n");
			_cp3 = _cp3->p_cross;
		}
			//printf("\n");
			//printf("..");

		N_loopformula++;

		LF_to_CNF(_lflink, _n_otherrule, str_cni);  // write to CNF


	} // for i_component




}// Normal Mode


	//printf("\n");

//	fclose(fp_cnf);


} // LF_by_SCCs_in_diff()





void Decoding(char _outputfile[C_LEN_FILENAME] )
{

	FILE *fp_output, *fp_atom;
	

	char _atomfile[C_LEN_FILENAME]="00atom";

	char item[C_LEN_ATOM];		// be used to read an atom name

	int i_temp;
	int i=0;






 	if (!(fp_atom=fopen(_atomfile,"r"))) {
		printf("Can not open %s\n", _atomfile);
		error =1;
	}

	if (!(fp_output=fopen(_outputfile,"w"))) {
		printf("Can not open %s\n", _outputfile);
		error =1;
	}


	while (	fscanf(fp_atom, "%d %s\n",&i_temp, &item ) != EOF ) {

		if ( model[i_temp] == 1 ) {
			fprintf(fp_output, "%s  ", item);
			i++;
		}
	}

	fprintf(fp_output, "\n\n %d atoms in this model.\n", i);

	
	fclose(fp_atom); 
	fclose(fp_output);

}






void main(int argc, char **argv)
{
  //FILE  *fp_con;

	FILE *fp_tmp;

  char str_Iteration[4]="000";	// the string of the number of the instance


  char rulefile[C_LEN_FILENAME]="00rule";           /* output a file for the 2nd part */  
  char atomfile[C_LEN_FILENAME]="00atom";
  char cnftemp[C_LEN_FILENAME]="00cnftemp";
  char confile[C_LEN_FILENAME]="00con";
  char loopfile[C_LEN_FILENAME]="00loop";

  char catcnf[C_LEN_COMMAND]="cat 00cnf0 00cnf1 > 00cnf";  // cat CNF

  char TSrulefile[C_LEN_FILENAME]="00ts_rule";     // normal rule file
  char Crulefile[C_LEN_FILENAME]="00c_rule";       // constraint rule file 
  char TSatomfile[C_LEN_FILENAME]="00ts_atom";     // TS atoms file

  int position;        // normal position and offset  

                                   
  int i, j, k, s;

  int TS_stable;

  i=C_LEN_FILENAME;



  int n_clause=0;
  int n_rule=0;


  int goon;

  
  int i_temp;  

  int n_add=0;

  int cnf_atom; /* cnf_rule,*/ //cnf_clause;

  int no_model;
  int no_stable_model;

//  int max_search=0;


  int return_TS;
  int return_ConstraintFact;
  int return_SE;






	// START 
	printf("\nASSAT 1.0\n");



  // (0). parameters


  if ( argc > 1 ) {    // get 1st-class parameters from command line

	for ( i=1;  i<argc; i++) {

		
		if (strcmp(argv[i], "-c")==0) {  
			PARA_CompletionOnly =  1 ;
		}
		else if (strcmp(argv[i], "-t")==0) {  
			PARA_TextOutput =  1 ;
		}

		else if (strcmp(argv[i], "-f")==0) {   
			PARA_ResultFile = 1;

			i++;
			strcpy(str_ResultFileName, argv[i]);
		}
		else if (strcmp(argv[i], "-p")==0) {   
			PARA_ParameterFile = 1;

			i++;
			strcpy(str_ParameterFileName, argv[i]);
		}

		else {
			strcpy(str_InputFile1, argv[i]);
			i++;

			if (!(fp_tmp=fopen(str_InputFile1,"r"))) {  
				printf("\nCan not open the file: %s\n\n", str_InputFile1);
				exit(0);
			}
			fclose(fp_tmp);

			if (i<argc) {	
				strcpy(str_InputFile2, argv[i]);	

				printf("\n i=%d argc=%d, %s, %s \n", i, argc, argv[i], argv[argc]);

				if (!(fp_tmp=fopen(str_InputFile2,"r"))) {  
					printf("\nCan not open the file: %s\n\n", str_InputFile2);
					exit(0);
				}
				fclose(fp_tmp);
			}


			//break;
		}


	}	// for
	  
  }



  read_PARA_file( str_ParameterFileName );  // get 2nd-class parameters from parameter file






  if ( PARA_ResultFile == 1 ) {

	  strcpy(str_cn0, str_ResultFileName);		// cnf file of grounding LP
	  strcat(str_cn0, ".cn0");

  	  strcpy(str_md0, str_ResultFileName);		// model of cn0	
	  strcat(str_md0, ".md0");

	  strcpy(str_lpi, str_ResultFileName);		// loops found in iteration i
	  strcat(str_lpi, ".lpi");

	  strcpy(str_cni, str_ResultFileName);		// the corresponding loop formulars
	  strcat(str_cni, ".cni");

	  strcpy(str_txt, str_ResultFileName);		// loop formulars in TEXT format
	  strcat(str_txt, ".cni.txt");

	  strcpy(str_mdi, str_ResultFileName);		// model of cn0 +...+ cni
	  strcat(str_mdi, ".mdi");


  	  strcpy(str_cnf, str_ResultFileName);		// == cnf00, input file to SAT solvers
	  strcat(str_cnf, ".cnf");



  }
  else { // if PARA_ResultFile ==0, then  PARA_TextOutput =  0 
	  //PARA_TextOutput =  0 ;
  }


  // initialize
  n_clause=0;







  // (1). GROUNDING: 


  if ( PARA_ExecuteGrounding == 1 ) {  

	  printf(" \n  * Grounding: Lparse ... ");

	  if ( ( strcmp(runlparse, "EMPTY")==0 ) || ( strcmp(runlparse, "NONE")==0 ) ) {

		  if ( strcmp( str_InputFile1, "EMPTY" ) == 0 ) {			  
			  usage();	
			  //error =1;	  
			  exit(0);
		  }
		  else if ( strcmp( str_InputFile2, "EMPTY" ) == 0 ) {
			  // lparse -d none (str_InputFile1) > (groundlpfile)
			  //strcpy(runlparse,"lparse -d none ");    // A lp with pure facts does NOT like it.
			  strcpy(runlparse,"lparse ");
			  strcat(runlparse, str_InputFile1);
			  strcat(runlparse, " > ");
			  strcat(runlparse, groundlpfile); 
			  
		  }
		  else {
			  // cat (str_InputFile1) (str_InputFile2) | lparse -d none > (groundlpfile)
			  strcpy(runlparse,"cat ");
			  strcat(runlparse, str_InputFile1);
			  strcat(runlparse, " ");
			  strcat(runlparse, str_InputFile2);
			  //strcat(runlparse, " | lparse -d none > ");
			  strcat(runlparse, " | lparse > ");
			  strcat(runlparse, groundlpfile);

		  }
	  }

	  //printf("   %s", runlparse);
	  system(runlparse);  // Execute lparse
  
  }
  else {	  
	  printf("\n  * Grounding: Skip");  
  }




  // (2) pre-processing

  printf("\n  * Pre-processing:  ");  

  if ( PARA_CompletionOnly ==1 ) { 
	  read_grounded_program_rulelink();             // Read the ground program
	  printf("\n\nThe Completion\n\n");		
	  output_completion();             
	  goto stop;
  }

  if ( PARA_Order == 1 ) {    // reorder and encode?
	  read_grounded_program_rulelink_reordering();  // get a reordered rule_link[]
  }
  else {
  	  read_grounded_program_rulelink();             // Read the ground program
  }


  
  Reduce_StrongE_1();	// (1): p:- p, G									// >>>>>> SE-Reduce 
  


  // T-S reduce ( Optional, depends on the PARAmeter "PARA_Reduce".

  if ( PARA_Reduce == 1 ) {



	  return_TS = Reduce_TS();												// >>>>>> TS-reduce


	  if( return_TS == -1 ) {
		  printf("\n Get 'Fail' literal, program is inconsistent and has no stable model \n");
		  goto stop1;
	  }  


	  if ( check_consistency() == 0 ) {             // check the consistency of TS_set and rules
		  printf(" \n INCONSISTENT ! \n");
		  goto stop1;		  
	  }


  }

  // no reduce
  else {

	  //TS_stable = Reduce_TS_Collection();       // generate TS-set from rule_link  WHY?

  }



  return_SE = Reduce_StrongE_2();	// (2): p:- not p							// >>>>>> SE-Reduce 

  if ( return_SE == -1 ) {
	  printf("\n No stable model!  \n");
	  goto stop1;
  }



  if ( PARA_DebugMode > 5 ) {

	  printf("\n PARA_DebugMode > 5 \n");
	  display_rulelink();     //display the rule link of the program
	  printf(" \natoms: %d  positive: %d  negative: %d  unknown: %d \n", main_atom, n_TS_p, n_TS_n, n_TS_u);
  }

  

  // OUTPUT: n_TS_p, n_TS_u, n_TS_n


  build_rulelink2();										// >>>>>> Save rulelink[] to rulelink2[]
  build_TSrule();										// >>>>>> Save rulelink[] to TSrule[]


  if ( (PARA_Reduce == 1 ) && ( PARA_ConstraintFactReduction == 1 ) ){    

	  return_ConstraintFact = Reduce_ConstraintFact();						// >>>>>>	CF-Reduce

	  if( return_ConstraintFact == -1 ) {
		  printf("\n Inconsistent! No stable model!  \n");
		  goto stop1;
	  }  


  }
  else {
  }







  // (3). COMPLETION, 
  printf(" \n  * Clark's Completion: ");

  // (3.1), file 00cnf
  

  if ( ( PARA_MakeCompletion ==0 ) && ( PARA_ExecuteGrounding ==0 ) ) {
  	  printf("\n      use previous CNF file");  
	}
  else {


	  combination_pointers1 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE ) ) ;      
	  if (combination_pointers1==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }
	  combination_pointers2 = (struct BODYNODE ** ) malloc( len_combination_pointer * sizeof( struct BODYNODE ) ) ;      
	  if (combination_pointers2==NULL) { printf("\nHalt! outof memory: c_p\n"); error =1; }


	  if (!(fp_cnf=fopen(str_cnf,"w"))) {  
		  printf("Can not open the file: %s\n", str_cnf);
		  error =1;
	  }

	  fprintf(fp_cnf, "                                                   \n");  // reserve 50 blanks


	  cnf_clause = 0;
	  
	  CNF();											// >>>>>> build CNF file (fact, Fail rule)

	  cnf_atom = no_atom;

	  rewind(fp_cnf);
	  fprintf(fp_cnf, "p cnf %d %d\n\n", cnf_atom, cnf_clause);

	  fclose(fp_cnf);						// close the CNF file

	  if ( PARA_ResultFile == 1 ) {
		  strcpy(runcopycn0,"cp ");
		  strcat(runcopycn0,str_cnf);
		  strcat(runcopycn0," ");
		  strcat(runcopycn0,str_cn0);
		  system(runcopycn0);
	  }

	  if ( ( cnf_atom == 0 ) || ( cnf_clause == 0 ) ) {
		  printf("\n\nUnsatisfiable! No stable model found!\n\n");
		  goto stop_aftercnf;
	  }



  }// else




  // (5), SAT solver
  
  printf(" \n  * SAT solver: ");

  if ( PARA_ExecuteSAT == 1 ) {     // Execute SAT solvers,   00cnf --> 00satout




	i=0;
	while ( (i<C_LEN_COMMAND) && (runsat[i] != 32) ) {
		sat_name[i] = runsat[i];
		i++;
	}

//	printf("%s", sat_name);

	if ( strcmp( sat_name, "Chaff2   ") == 0 ) { // Chaff2 00.cnf > satoutput.temp
		strcpy(runsat_prefix, "Chaff2 ");

		strcpy(runsat_suffix, " > ");
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);
	}
	else if ( strcmp( sat_name, "walksat  ") == 0 ) { 

		strcpy(runsat_prefix, "walksat -out ");	// "walksat -out satmodel.temp < "
		strcat(runsat_prefix, satmodelfile);
		strcat(runsat_prefix, " < ");

		strcpy(runsat_suffix, " > ");			// " > satoutput.temp "
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);			// "walksat -out satmodel.temp < .cnf > satoutput.temp "
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);

	}
	else if ( strcmp( sat_name, "sato     ") == 0 ) { // sato -m1 -f 00cnf > 00satout
		//strcpy( runsat_prefix, runsat);
		strcpy( runsat_prefix, "sato -m1 -f ");

		strcpy(runsat_suffix, " > ");
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);
	}
	else if ( strcmp( sat_name, "grasp    ") == 0 ) { // grasp +s1 +O 00cnf > 00satout
		strcpy( runsat_prefix, "grasp +s1 +O ");

		strcpy(runsat_suffix, " > ");
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);
	}
	else if ( strcmp( sat_name, "satz     ") == 0 ) { // "satz 00cnf > 00satout"
		strcpy( runsat_prefix, "satz ");

		strcpy(runsat_suffix, " > ");
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);

	}
	else if ( strcmp( sat_name, "satz-rand") == 0 ) { // "satz-rand 00cnf -out 00satmodel > 00satout"
		strcpy( runsat_prefix, "satz-rand ");

		strcpy(runsat_suffix, " -out ");
		strcat(runsat_suffix, satmodelfile);
		strcat(runsat_suffix, " > ");
		strcat(runsat_suffix, satoutputfile);

		strcpy(runsat, runsat_prefix);
		strcat(runsat, str_cnf);
		strcat(runsat, runsat_suffix);

	}

	else {
		printf(" \n Unknow SAT solver \n");
		error =1;
	}



	// runsat_chaff, W-C or S-C
	strcpy(runsat_chaff, "Chaff2 ");
	strcat(runsat_chaff, str_cnf);
	strcat(runsat_chaff, " > ");
	strcat(runsat_chaff, satoutputfile);





	  //printf("%s\n", runsat);
//	  strcpy( runsat_prefix, runsat);
//	  strcat( runsat_prefix, str_cnf);
//	  strcat( runsat_prefix, " > ");

//	  strcpy( runsat, runsat_prefix);
//	  strcat( runsat, satoutputfile  );	  
	  //printf("%s\n", runsat);
	  system(runsat);  
  }    
  
  
 
  

  
  // (6), read from SAT output


  //printf(" \n  * Check: ");
  
  model = (int *) malloc( (main_atom+1) * sizeof (int) );          
  if(model == NULL) { printf("\nHalt! out of memory: model\n"); error =1; }
  difference = (int *) malloc( (main_atom+1) * sizeof (int) );          
  if(difference == NULL) { printf("\nHalt! out of memory: difference\n"); error =1; }
  conclusion = (int *) malloc( (main_atom+1) * sizeof (int) );          
  if(conclusion == NULL) { printf("\nHalt! out of memory: conclusion\n"); error =1; }
  for ( i=0; i< main_atom+1; i++ ) { difference[i] = 0;	conclusion[i] = 0; }
  

  if ( PARA_ResultFile == 1 ) {
	  if( (fp_mdi = fopen( str_md0, "w" )) == NULL ) {			// open file: .cn0
		  printf( "The file %s was not opened\n", str_md0 );
		  error = 1;
	  }
	  if ( error == 1 ) { goto stop;	}
  }

  no_model = read_SAT(str_md0);  // return is the number of models founded

  if ( PARA_ResultFile == 1 ) {
	  fclose(fp_mdi);
  }

  if (no_model == 0) {
	  printf("\n Unsatisfiable! \n\n\n NO Stable Model.\n\n"); 
 	  goto stop0;
  }



  
  
  
  
  
  
  // (6), check stable model


  printf("  Check... ");		
  



	// build arrays
  checking_model = (int *) malloc( (main_atom+1) * sizeof (int) );
  if(checking_model == NULL) { printf("\nHalt! out of memory: checking_model\n"); error =1; }

  checking_conclusion = (int *) malloc( (main_atom+1) * sizeof (int) );
  if(checking_conclusion == NULL) { printf("\nHalt! out of memory: checking_conclusion\n"); error =1; }

  checking_glrule = (int *) malloc ( n_TSrule * len_rule * sizeof (int));
  if(checking_glrule == NULL) { printf("\nHalt! out of memory: checking_glrule\n");   error =1;   }

  for ( i=0; i< main_atom+1; i++ ) { difference[i] = 0; }


  no_stable_model = check_stable_model_on_model( no_model );  // return the number of stable models


  
//  no_stable_model = check_stable_model_on_conclusion( no_model );  // return the number of stable models
  if( no_stable_model > 0 ) { 
	  printf("\n\n Find %d Stable Model.\n\n", no_stable_model);
	  goto stop0;
  }
  else {
	  //printf("\n\n It's not a Stable Model.\n\n");
  }











  // LOOP detect and erease


//int *looplink, *looplist;

  number = (int * ) malloc( (main_atom+1) * sizeof( int) ) ; // used for find loop
  if (number==NULL) { printf("\nHalt! out of memory: number\n"); error =1; }
  lowlink = (int * ) malloc( (main_atom+1) * sizeof( int) ) ; // used for find loop
  if (lowlink==NULL) { printf("\nHalt! out of memory: lowlink\n"); error =1; }
  stack = (int * ) malloc( (main_atom+1) * sizeof( int) ) ; // used for find loop
  if (stack==NULL) { printf("\nHalt! out of memory: stack\n"); error =1; }
  component = (int * ) malloc( (main_atom+1) * sizeof( int) ) ; // used for find loop
  if (component==NULL) { printf("\nHalt! out of memory: component\n"); error =1; }

  for(i=0;i<= main_atom;i++) {  
	  number[i] = 0; 
	  lowlink[i] = 0; 
	  stack[i] = 0; 
	  component[i] = 0; 	  
  }     // Initially, set 0,




  loop_list = (struct LOOPLIST * ) malloc( (main_atom+1) * sizeof( struct LOOPLIST) ) ; // used for find loop
  if (loop_list==NULL) { printf("\nHalt! out of memory: loop_list\n"); error =1; }
  for(i=0;i<= main_atom;i++) {  loop_list[i].data = 0; }     // Initially, set 0,


  loop_tree_head = new LOOPTREENODE;
  loop_tree_head->data = 0;
  loop_tree_head->p_chain = NULL;
  loop_tree_head->p_next = NULL;



  if ( PARA_ResultFile == 1 ) {

	  if( (fp_lpi = fopen( str_lpi, "w" )) == NULL ) {		// loop(i)
		  printf( "The file %s was not opened\n", str_lpi );
		  error = 1;
	  }
	  if( (fp_cni = fopen( str_cni, "w" )) == NULL ) {		// loop-formula of loop(i)
		  printf( "The file %s was not opened\n", str_cni );
		  error = 1;
	  }
	  if( (fp_txt = fopen( str_txt, "w" )) == NULL ) {		// loop-formula in TEXT fromat
		  printf( "The file %s was not opened\n", str_txt );
		  error = 1;
	  }
	  if( (fp_mdi = fopen( str_mdi, "w" )) == NULL ) {		// model of cn0 +...+ cni
		  printf( "The file %s was not opened\n", str_mdi );
		  error = 1;
	  }
	  if ( error == 1 ) { goto stop;	}
  }


  int no_loop;

  no_loop = 1;
  while( no_loop <= PARA_LoopToSearch ) {

//	  printf("\n>>%d>>\n", no_loop);

/*	  // iteration of 3 bits	
	  i=2;
	  goon = 1;
	  while ( ( i >= 0 ) && (goon==1) ) {
		  if ( str_iteration[i] != 57 ) {
			  str_iteration[i]++;
			  goon=0;
		  }
		  else  {
			  str_iteration[i] = 48;
			  i--;
		  }
	  }	// while
	  if ( i<0 ) {
		  printf("\n More than 1000 iterations !\n");
		  error =1;
	  }	// if

	  printf("\n>>%d>>%s:  ", no_loop, str_iteration);


	  strcpy(str_lpi, str_ResultFileName);
	  strcat(str_lpi, ".lf");
	  strcat(str_lpi, str_iteration);

	  strcpy(str_cni, str_ResultFileName);
	  strcat(str_cni, ".cn");
	  strcat(str_cni, str_iteration);

	  strcpy(str_mdi, str_ResultFileName);
	  strcat(str_mdi, ".md");
	  strcat(str_mdi, str_iteration);
*/

	  if ( PARA_ResultFile == 1 ) {

		  fprintf(fp_lpi, "\n\nIteration %d:\n", no_loop);
		  fprintf(fp_cni, "\n\nIteration %d:\n", no_loop);
		  fprintf(fp_txt, "\n\nIteration %d:\n", no_loop);
		  fprintf(fp_mdi, "\n\nIteration %d:\n", no_loop);
	  }




	  for(i=0;i<= main_atom;i++) {  
		  number[i] = 0; 
		  lowlink[i] = 0; 
		  stack[i] = 0; 
		  component[i] = 0; 	  
	  }     // Initially, set 0,


//	  printf("strongly connected component...\n");		
	  
	  LF_LoopDetect(str_lpi);										// >>>>>> find loops
	  // SCC: strongly connected components



	  if (!(fp_cnf=fopen(str_cnf,"a+"))) {	// append  
		  printf("Can not open the file: %s\n", str_cnf);
		  error =1;
	  }
//	  printf("loop formula...\n");												 

	  LF_by_SCCs_in_diff(str_cni);									// >>>>>> Add Loop-Formulas 

	  fclose(fp_cnf);


	  
	  if (!(fp_cnf=fopen(str_cnf,"r+"))) {	// update
		  printf("Can not open the file: %s\n", str_cnf);
		  error =1;
	  }


	  cnf_atom = no_atom;

	  rewind(fp_cnf);	  

	  fprintf(fp_cnf, "p cnf  %d  %d\n", cnf_atom, cnf_clause);

	  fclose(fp_cnf);
	  


	  if ( PARA_ExecuteSAT == 1 ) {  // Execute SAT solvers,   00cnf --> 00satout   
		  //printf("SAT...");													

		  //strcpy( runsat, runsat_prefix  );
		  //strcat( runsat, satoutputfile);
		  //printf(" %s ", runsat);
		  system(runsat);  
	  }    



	  no_model = read_SAT(str_mdi);										// >>>>>> read from SAT output	
	  // return of the function is the number of models in SAT output file

	  if (no_model == 0) {
		  printf("\n Unsatisfiable! Inconsistent after adding loop formulas \n"); 
		  
		  printf("\n\n NOT find Stable Model.\n\n", no_stable_model);

		  goto stop0;
	  }
 

	  // (), check stable model
	  printf("  Check... ");														

	  no_stable_model = check_stable_model_on_model( no_model );	// >>>>>> check stable model
	  // return the number of stable models

	  if( no_stable_model > 0 ) { 
		  printf("\n\nFind %d Stable Model.\n", no_stable_model);

		  goto stop0;
	  }


	  no_loop++;


  }// while( no_loop <= PARA_LoopToSearch ) 

  free( loop_list);


  
  printf("\n\nNO Stable Model found after  %d  iteration.\n\n", PARA_LoopToSearch);


  stop0:

  free( combination_pointers1 );
  free( combination_pointers2 );

  free(checking_model);
  free(checking_conclusion);
  free(checking_glrule);


  if ( PARA_OutputModel == 1 ) {	Decoding("01model");	}					// >>>>>> Translate

  
  printf("\nRules: %d  Atoms: %d  TemporaryVariable: %d  clause: %d  LoopFormulas: %d \n\n", 
	  main_rule, main_atom, cnf_atom-main_atom, cnf_clause, N_loopformula);
  printf("Total time cost of SAT: %f\n", totaltime_sat);
  printf("Execute SAT solver: %d\n", totalnumber_sat);
  printf("Check models from SAT: %d\n", totalnumber_model);
  printf("The average time cost of SAT: %f", totaltime_sat/totalnumber_sat);
 

  stop1:


  if ( PARA_ResultFile == 1 ) {

	  fclose(fp_lpi);
	  fclose(fp_cni);
	  fclose(fp_txt);
	  fclose(fp_mdi);
  }
  
stop_aftercnf:
stop:

  printf("\n\n\n");

}
	  



